<?php
$_db->speichereGeaenderteTabellen();
$_tmpl->assign('inhalt',$_inh);
$_tmpl->assign('s',$_seite);
if(isset($_tmpl->tk_fussnoten) and count($_tmpl->tk_fussnoten) > 0){
	$_tmpl->assign('fussnoten',$_tmpl->tk_fussnoten);
}
$_tmpl->assign('_datumwahl',isset($_tmpl->tk_datumwahl));
# JS-Dateien
$jsdateien = $_tmpl->get_template_vars('jsdateien');
if(is_array($jsdateien)){
	unset($jsdateien[0]);
    $jsdateien = array_unique($jsdateien);
	$_tmpl->assign('jsdateien',$jsdateien);
    if(in_array('/src/js/loeschfrage.js',$jsdateien) and $_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
        $_tmpl->tk_append_string('js_inline',"var keineloeschfrage = 1;",1);
    }
}

# Konstanten in $js_inline ersetzen
$js = $_tmpl->get_template_vars('js_inline');
if(!empty($js)){
	$anz = preg_match('~[A-Z_]{2,}~', $js, $match);
	if($anz > 0){
    	foreach($match as $m){
        	if(!defined($m)){
            	continue;
            }
            else{
            	$js = str_replace($m, constant($m), $js);
            }
        }
    }
    $_tmpl->assign('js_inline',trim($js));
}

# Hintergrundbild und Favicon vorhanden?
if(isset($_SESSION['darstellung'])){
	if($_SESSION['darstellung']['hintergrund']){
		$_tmpl->tk_append_string('css_inline',"body { background:url('".ROOT."/src/img/hintergrund.png') repeat-y 6em 1em; }",1);
	}
	$_tmpl->assign('faviconanzeigen', $_SESSION['darstellung']['favicon']);
}

# css_inline ggf. um Leerzeile krzen
$_tmpl->assign('css_inline', trim($_tmpl->get_template_vars('css_inline')));

# externe CSS-Datei
if(!empty($_einst['globaleeinstellungen']['externecssdatei'])){
	$_tmpl->assign('externecssdatei',$_einst['globaleeinstellungen']['externecssdatei']);
}

$inhalt = $_tmpl->fetch('tmpl.inc.html');
if(!headers_sent()){
    header('x-Powered-By: tkswim');
}
if(isset($_einst) and $_einst['globaleeinstellungen']['inhaltkomprimiertausliefern']){
	ob_start('ob_gzhandler');
	echo $inhalt;
	ob_end_flush();
}
else{
	echo $inhalt;

}

if(isset($_SESSION['hinweis'])){
	unset($_SESSION['hinweis']);
}

if(TKSWIM_DEBUG){
	$endzeit = microtime_float();
	echo "\n".'<!-- diverse Angaben ber die aktuelle Seite'."\n";
    echo ' aktuelle Version: '.TKSWIM_VERSION."\n";
    echo '     Generierzeit: '.round($endzeit-$startzeit,4).'s'."\n";
    echo '      DB-Abfragen: '.$_db->anzahldbabfragen."\n";
    echo '     Dateigroesse: '.round((strlen($inhalt)+152)/1024,2).'Kb'."\n";
    echo '-->';
}
# EOF
?>