<?php

class email{

var $an;
var $betreff;
var $text;
var $header = array();
var $parameter;

function setzeAn($wert, $pruefen = true){
	if($pruefen){
    	$this->an = $this->_ersteZeile($wert);
    }
    else{
    	$this->an = $wert;
    }
    return true;
}

function setzeBetreff($wert, $pruefen = true){
	if($pruefen){
    	$this->an = $this->_ersteZeile($wert);
    }
    else{
    	$this->betreff = $wert;
    }
    return true;
}

function setzeText($wert, $anhaengen = false){
	if($anhaengen){
    	$this->text .= $wert;
    }
    else{
    	$this->text = $wert;
    }
    return true;
}

function setzeParameter($wert, $anhaengen = false){
	if($anhaengen){
    	$this->parameter .= $wert;
    }
    else{
    	$this->parameter = $wert;
    }
    return true;
}

function setzeTextTemplate($templatedatei, &$smarty, $empfaenger, $variablen = ''){
	if(is_array($variablen)){
    	foreach($variablen as $key => $value){
        	$smarty->assign($key, $value);
        }
    }
    if(!isset($this->conf)){
    	$this->conf = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
    }
    $this->setzeAn($empfaenger['email'],true);
    $von = array('[br]','{vname}','{nname}','{herrfrau}','{r}');
    $nach = array("\n",$empfaenger['vorname'],$empfaenger['nachname'],($empfaenger['mw']=='m'?'Herr':'Frau'),($empfaenger['mw']=='m'?'r':''));
    $smarty->assign('_begruessung',    str_replace($von,$nach,$this->conf['textteile']['begruessung']));
    $smarty->assign('_verabschiedung', str_replace('[br]',"\n",$this->conf['textteile']['verabschiedung']));
    $smarty->assign('_dusie', $this->conf['sonstiges']['dusie']);
    $this->text = $smarty->fetch($templatedatei);
    return true;
}

function setzeHeader($header, $wert){
	$erlaubte = array('CC','BCC','User-Agent','From','Content-Transfer-Encoding','X-PHP-Script','Content-Type','Reply-To');
    if(!in_array($header, $erlaubte)){
    	return false;
    }
    $this->header[$header] = $this->_ersteZeile($wert);
    return true;
}

function verschickeMail(){
	if(!isset($this->header['User-Agent']) or empty($this->header['User-Agent'])){
    	$this->header['User-Agent'] = 'tkswim '.TKSWIM_VERSION;
    }
    if(!isset($this->header['From'])){
        $this->header['From'] = $this->conf['absender']['name'].' <'.$this->conf['absender']['email'].'>';
    }
    if(!empty($this->conf['sonstiges']['fparameter'])){
    	$this->setzeParameter('-f '.$this->conf['sonstiges']['fparameter']);
    }

	$header = '';
    foreach($this->header as $key => $value){
    	$header .= $key.': '.$value."\r\n";
    }
    $header = trim($header);

    if(TKSWIM_DEBUG){
		$tmp = '<strong>An:</strong> '.text_format($this->an,'htmlmaskieren').'<br />';
		$tmp .= '<strong>Betreff:</strong> '.text_format($this->betreff,'htmlmaskieren').'<br />';
		$tmp .= '<strong>Text:</strong><pre>'.text_format($this->text,'htmlmaskieren').'</pre>';
		$tmp .= '<strong>Header:</strong><pre>'.text_format($header,'htmlmaskieren').'</pre>';
		$tmp .= '<strong>Parameter:</strong> '.text_format($this->parameter,'htmlmaskieren').'<br />';
    	echo $tmp.'<hr />';
		return;
	}

    if(empty($this->an)){
    	return 'es wurde keine Empfnger angegeben';
    }
    if(empty($this->betreff)){
    	return 'es wurde keine Betreff angegeben';
    }
    if(empty($this->text)){
    	return 'es wurde kein Text angegeben';
    }

	$erfolg = mail($this->an, $this->betreff, $this->text, $header, $this->parameter);
    return $erfolg;
}

function _ersteZeile($wert){
	$anz = preg_match("~^(.*?)(\015\012|\015|\012)~",$wert,$match);
	if($anz == 0){
		return $wert;
	}
    return $match[1];
}

} # Ende der Klasse, EOF
?>