<?php
if(!defined('PFAD_SMARTY')){
    trigger_error('[tkswim] [tktemplate] Smarty konnte nicht gefunden werden',E_USER_ERROR);
}

if(PFAD_SMARTY == ''){
	# Smarty suchen
    if(isset($_SESSION['_smarty'])){
    	require_once($_SESSION['_smarty']);
    }
    else{
        $open_basedir = ini_get('open_basedir');
        $document_root = $_SERVER['DOCUMENT_ROOT'];
        if(empty($open_basedir)){
            $anfang = '/';
        }
        else{
            $ob_teile = explode(PATH_SEPARATOR, $open_basedir);
            $anz = count($ob_teile);
            for($i=0;$i<$anz;$i++){
                if(substr($document_root, 0, strlen($ob_teile[$i])) == $ob_teile[$i]){
                    $anfang = $ob_teile[$i];
                    break;
                }
            }
        }
        if(substr($anfang,-1) != '/'){
            $anfang .= '/';
        }
        function sucheSmarty($anfang){
            $dh = opendir($anfang);
            if(!$dh){
                return false;
            }
            $datei = false;
            while (false !== ($file = readdir($dh))){
                if($file == '.' or $file == '..'){
                    continue;
                }
                if(is_dir($anfang.$file)){
                    $datei = sucheSmarty($anfang.$file.'/');
                    if($datei !== false){
                        break;
                    }
                }
                if($file == 'Smarty.class.php'){
                    $datei = $anfang.$file;
                }
            }
            closedir($dh);
            return $datei;
        }
        $_smarty = sucheSmarty($anfang);
        if($_smarty === false){
            die('Smarty wurde nicht gefunden, bitte erst in der config.inc.php Pfad zu Smarty angeben.');
        }
        $_SESSION['_smarty'] = $_smarty;
        require_once($_SESSION['_smarty']);
    }
}
else{
	require_once(PFAD_SMARTY.'Smarty.class.php');
}

class tktemplate extends Smarty {

	function tktemplate(){
    	if(defined('PFAD_TEMPLATES')){
        	$this->template_dir = PFAD_TEMPLATES;
        }
        if(defined('PFAD_TEMPLATESC')){
        	$this->compile_dir = PFAD_TEMPLATESC;
        }
        $this->plugins_dir = array();
        if(defined('PFAD_TMPLPLUGINS')){
        	$this->plugins_dir[] = PFAD_TMPLPLUGINS;
        }
        $this->plugins_dir[] = 'plugins';
    }

    function tk_append_string($tpl_var, $value, $br = 0, $zwingend = 0){
    	if(is_array($tpl_var)){
            $this->trigger_error('$tpl_var darf kein Array sein.');
            return;
        }
    	if(is_array($value)){
            $this->trigger_error('$value darf kein Array sein.');
            return;
        }
        if(isset($this->_tpl_vars[$tpl_var]) and is_array($this->_tpl_vars[$tpl_var])){
            $this->trigger_error('Um Werte an Arrays anzuhngen append() verwenden.');
            return;
        }
        if(!isset($this->_tpl_vars[$tpl_var])){
        	$this->_tpl_vars[$tpl_var] = '';
        }
        if($zwingend == 0 and strpos($this->_tpl_vars[$tpl_var],$value)!==false){
        	return true;
        }
        if($br == 1){
            $value .= "\n";
        }
        $this->_tpl_vars[$tpl_var] .= $value;
        return true;
    }


} # Ende der Klasse, EOF
?>