<?php
/*
 Wettkampfabwicklung, Aktion: anzahlstartereingeben
 verwendete Templates:
  - 42.abwickeln-anzahlstartereingeben.inc.html
*/
$query = "SELECT z.id as zid, YEAR(gebdatum) as jg, CONCAT(disziplin, '_', streckenlaenge, '_', m.mw) as strecke, z.platzvon
            FROM (".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
              LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid = m.id
            WHERE z.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND staffelid IS NULL";
$_db->holeDaten($query);
$einzelzeiten = $_db->baueArray('*', 'zid');

$wettkaempfe = array();
$einzelstarts = array();
foreach($einzelzeiten as $row){
    if(!isset($einzelstarts[$row['strecke']])){
        $einzelstarts[$row['strecke']] = array();
        list($d, $s, $m) = explode('_', $row['strecke']);
        $wettkaempfe[$row['strecke']] = $_lagen[$d].' '.$s.'m '.$_geschlechter[$m];
    }
    if(!isset($einzelstarts[$row['strecke']][$row['jg']])){
        $einzelstarts[$row['strecke']][$row['jg']] = $row['platzvon'];
    }
}
ksort($einzelstarts);
foreach($einzelstarts as $key => $w){
    krsort($einzelstarts[$key]);
}

$query = "SELECT CONCAT(s.disziplin, '_', s.anzahl, 'x', s.laenge, '_', s.mw) as strecke, s.id as sid, s.platzvon,
              GROUP_CONCAT(CONCAT(LEFT(vorname,1), '. ', nachname) ORDER BY sz.schwimmernr SEPARATOR ', ') as namen
            FROM ((".DB_PREFIX."staffeln as s LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON s.id=sz.staffelid)
              LEFT JOIN ".DB_PREFIX."zeiten as z ON sz.zeitid=z.id) LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid = m.id
            WHERE s.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
            GROUP BY s.id, strecke, platzvon
            ORDER BY strecke, s.gesamtzeit";
$_db->holeDaten($query);
$staffelstarts = $_db->baueArray('*', 'sid');


foreach($staffelstarts as $sid => $row){
	list($d, $s, $m) = explode('_', $row['strecke']);
    $staffelstarts[$sid]['platzvonoriginal'] = $row['platzvon'];
    $wettkaempfe[$row['strecke']] = $_lagen[$d].' '.$s.'m '.$_geschlechter[$m];
}

if(isset($_POST['speichern'])){
	$f = '';
    require_once('func/pruefen.inc.php');

    foreach($einzelstarts as $strecke => $werte){
    	foreach($werte as $jg => $anzahl){
        	if(!isset($_POST['einzelstarts'][$strecke][$jg])){
            	continue;
            }
            $f .= pruefen($_POST['einzelstarts'][$strecke][$jg], 'maxlaenge', 'Der Wert beim Wettkampf '.$wettkaempfe[$strecke].', JG '.$jg.' ist zu lang (max drei Ziffern).',3);
            $f .= pruefen($_POST['einzelstarts'][$strecke][$jg], 'zahl', 'Der Wert beim Wettkampf '.$wettkaempfe[$strecke].', JG '.$jg.' ist keine Zahl.');
            $einzelstarts[$strecke][$jg] = $_POST['einzelstarts'][$strecke][$jg];
        }
    }
    foreach($staffelstarts as $key => $wert){
        	if(!isset($_POST['staffelstarts'][$key])){
            	continue;
            }
            $f .= pruefen($_POST['staffelstarts'][$key], 'maxlaenge', 'Der Wert beim Wettkampf '.$wettkaempfe[$staffelstarts[$key]['strecke']].' ist zu lang (max drei Ziffern).',3);
            $f .= pruefen($_POST['staffelstarts'][$key], 'zahl', 'Der Wert beim Wettkampf '.$wettkaempfe[$staffelstarts[$key]['strecke']].' ist keine Zahl.');
            $staffelstarts[$key]['platzvon'] = $_POST['staffelstarts'][$key];
    }

    if(!empty($f)){
    	$_tmpl->assign('fehler', $f);
    }
    else{
    	$querys = array();
		foreach($einzelzeiten as $zid => $row){
        	if($einzelstarts[$row['strecke']][$row['jg']] == $row['platzvon']){
            	continue;
            }
            $querys[] = "UPDATE ".DB_PREFIX."zeiten SET platzvon = ".$einzelstarts[$row['strecke']][$row['jg']]." WHERE id = ".$zid."";
        }

		foreach($staffelstarts as $sid => $row){
        	if($staffelstarts[$sid]['platzvonoriginal'] == $row['platzvon']){
            	continue;
            }
            $querys[] = "UPDATE ".DB_PREFIX."staffeln SET platzvon = ".$row['platzvon']." WHERE id = ".$sid."";
        }
        foreach($querys as $query){
        	$_db->fuehreQueryAus($query);
        }
        weiterleiten('/wettkaempfe/abwickeln.html', 'Die Anzahl der Starter wurden gespeichert.');
    }
}

$_tmpl->assign('staffelstarts', $staffelstarts);
$_tmpl->assign('einzelstarts', $einzelstarts);
$_tmpl->assign('wettkaempfe', $wettkaempfe);
$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-anzahlstartereingeben.inc.html');
# EOF
?>