<?php
/*
 Wettkampfabwicklung, Aktion: dsvidlizenzierung_vorhanden
 verwendete Templates:
  - 42.dsvidlizenzierung-uebersicht.inc.html
*/
# relevante Mitglieder holen
$mitglieder = array();
if($_wettkampfart == 'dmsj'){
	if(isset($_wkeinst['dmsj'])){
		$mitglieder = explode('|',implode('|',array_values($_wkeinst['dmsj'])));
        $nurkindgerecht = array();
    }
}
else{
    $query = "SELECT mt.mid, a.kindgerecht
                FROM ((".DB_PREFIX."meldungen_teilnehmer as mt LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON mt.id=ms.teilnehmerid)
                  LEFT JOIN ".DB_PREFIX."wks as w ON ms.wkid = w.id) LEFT JOIN ".DB_PREFIX."abschnitte as a ON w.abschnittid = a.id
                WHERE mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mt.teilnahme != '-' AND ms.teilnehmerid IS NOT NULL";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl'] > 0){
    	$mitglieder = $_db->baueArray('mid','mid');
        $nurkindgerecht = $_db->baueArray('mid','mid');
        $kindgerechttest = $_db->baueArray('*','#');
        foreach($kindgerechttest as $row){
        	if(is_null($row['kindgerecht'])){
            	unset($nurkindgerecht[$row['mid']]);
            }
        }
        unset($kindgerechttest);
    }
}
if(count($mitglieder) < 1){
    $_tmpl->assign('fehler','Fr diesen Wettkampf wurden noch keine Mitglieder gewhlt');
}
else{
    # Daten zu den Mitgliedern holen
    $query = "SELECT m.id, CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg, mw, dsvid, IF(l.jahr IS NULL,0,1) as lizenziert,
                  IF((YEAR('".$_SESSION['wk_abwickeln']['wettkampfdatum']."')-YEAR(gebdatum))>=10,1,0) as lizenznoetig, mt.teilnahme
                FROM (".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."meldungen_teilnehmer as mt
                    ON m.id=mt.mid and mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id'].")
                  LEFT JOIN ".DB_PREFIX."lizenzierungen as l
                    ON m.id=l.mitgliedid AND l.jahr='".substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4)."'
                WHERE m.id IN (".implode(', ',$mitglieder).")
                ORDER BY name";
    $_db->holeDaten($query);
    $daten = $_db->ergebnis['daten'];
    $query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art='m' AND eigenschaft='dsvidbeantragt'";
    $_db->holeDaten($query);
    $beantragte = $_db->baueArray('artid','#');
    $fehlendedsvids = array();
    $fehlendelizenzen = array();
    $kosten = array(
    	'registrierungen' => 0,
        'lizenzierungen'  => 0
    );
    foreach($daten as $key => $row){
        if(in_array($row['id'],$beantragte)){
            $daten[$key]['beantragt'] = 1;
        }
        if(in_array($row['id'],$nurkindgerecht)){
            $daten[$key]['nurkindgerecht'] = 1;
        }
        if(!in_array($row['id'],$beantragte) and !in_array($row['id'],$nurkindgerecht) and empty($row['dsvid'])){
            $fehlendedsvids[] = $row['id'];
        }
        if($row['lizenznoetig'] == 1 and $row['lizenziert'] != 1){
        	$kosten['lizenzierungen']++;
            if(!isset($daten[$key]['beantragt']) and $row['teilnahme'] == '+'){
            	$fehlendelizenzen[] = $row['id'];
            }
        }
        if(is_null($row['dsvid'])){
        	$kosten['registrierungen']++;
        }
    }
    $_tmpl->assign('daten',$daten);
    $_tmpl->assign('kosten',$kosten);
    $_tmpl->assign('fehlendelizenzen',$fehlendelizenzen);
    $_tmpl->assign('fehlendedsvids',$fehlendedsvids);
    $_tmpl->assign('lizenzjahr',substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4));
    $_inh .= $_tmpl->fetch('wettkaempfe/42.dsvidlizenzierung-uebersicht.inc.html');
}
# EOF
?>