<?php
/*
 Wettkampfabwicklung, Aktion: hinzufuegen_einzeln
 verwendete Templates:
  - 42.hinzufuegen-einzeln-streckenwaehlen.inc.html
  - 42.hinzufuegen-einzeln-zeitenwaehlen.inc.html
*/
if(isset($_POST['anderesmitglied'])){
	unset($_SESSION['wk_abwickeln']['he_schritt1']);
    if(isset($_SESSION['wk_abwickeln']['he_schritt2'])){
		unset($_SESSION['wk_abwickeln']['he_schritt2']);
    }
    if(isset($_SESSION['wk_abwickeln']['he_schritt3'])){
		unset($_SESSION['wk_abwickeln']['he_schritt3']);
    }
}

if(isset($_POST['zurstreckenwahl'])){
	unset($_SESSION['wk_abwickeln']['he_schritt2']);
    if(isset($_SESSION['wk_abwickeln']['he_schritt3'])){
		unset($_SESSION['wk_abwickeln']['he_schritt3']);
    }
}

if(!isset($_SESSION['wk_abwickeln']['he_schritt1'])){ # Mitglied suchen
	if(isset($_GET['id'])){
    	$query = "SELECT id, CONCAT(nachname,', ',vorname,'; JG ',YEAR(gebdatum),'; ',mw) as name
                    FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_GET['id'],'id')."'";
        $_db->holeDaten($query);
        if($_db->holeAnzahl() == 1){
        	$_SESSION['wk_abwickeln']['he_schritt1'] = $_db->holeZeile();
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_einzeln');
        }
    }
    require_once('func/mitgliedwaehlen.inc.php');
    $_inh .= mitgliedwaehlen('/wettkaempfe/abwickeln.html', 'aktion=hinzufuegen_einzeln');
}
elseif(!isset($_SESSION['wk_abwickeln']['he_schritt2'])){ # Strecken whlen
	$wks = $wk->wettkaempfeFuerSchwimmer($_SESSION['wk_abwickeln']['id'], $_SESSION['wk_abwickeln']['he_schritt1']['id']);
    if(count($wks['wks']) < 1){
    	unset($_SESSION['wk_abwickeln']['he_schritt1']);
    	weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_einzeln','Das Mitglied kann an dem Wettkampf nicht teilnehmen.');
    }
    $query = "SELECT w.id, a.nr, w.wknr, w.laenge, w.disziplin, FIELD(w.laenge,'25','50','100','200','400','800','1500') AS sort
              FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
              WHERE w.abschnittid=a.id AND w.id IN (".implode(',',$wks['wks']).")
              ORDER BY w.disziplin, sort";
    $_db->holeDaten($query);
    $wettkaempfe = $_db->baueArray('*','id');

    if(isset($_POST['speichern'])){
        # Nachschauen ob Mitglied fr den Wettkampf schon gemeldet ist
        $query = "SELECT id FROM ".DB_PREFIX."meldungen_teilnehmer
                    WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mid = ".$_SESSION['wk_abwickeln']['he_schritt1']['id']."";
        $_db->holeDaten($query);
        $neu = true;
        if($_db->holeAnzahl() > 0){ # schon gemeldet
            $tid = $_db->holeWert();
            $neu = false;
        }
        else{ # noch nicht gemeldet, Datensatz schreiben
            $query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer SET
                        wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                        mid = ".$_SESSION['wk_abwickeln']['he_schritt1']['id']."";
            $_db->fuehreQueryAus($query);
            $tid = $_db->ergebnis['insertid'];
        }
        $_SESSION['wk_abwickeln']['he_schritt1']['tid'] = $tid;
    }

    if(isset($_POST['ohnestrecken'])){
        unset($_SESSION['wk_abwickeln']['he_schritt1']);
    	weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_einzeln', $neu?'Das Mitglied wurde gemeldet':'Das Mitglied war bereits gemeldet');
    }

    if(isset($_POST['strecken']) and is_array($_POST['strecken'])){
    	$_SESSION['wk_abwickeln']['he_schritt2'] = array();
        $gesetzte = array();
    	foreach($_POST['strecken'] as $wkid){
        	if(!in_array($wkid, array_keys($wettkaempfe))){
            	continue;
            }
            $w = $wettkaempfe[$wkid];
            $gesetzte[] = $wkid;
            $_SESSION['wk_abwickeln']['he_schritt2'][$wkid] =$w['laenge'].'m '.$_lagen[$w['disziplin']].' (WK: '.$w['wknr'].', Abschnitt: '.$w['nr'].')';
        }
        if(!$neu and count($gesetzte)>0){
        	# evtl. noch vorhandenen Lschen
        	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$tid." AND wkid NOT IN (".implode(',',$gesetzte).")";
            $_db->fuehreQueryAus($query);
        }
    	weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_einzeln');
    }
    $_tmpl->assign('_lagen',$_lagen);
    $_tmpl->assign('vorhandene',$wks['vorhandene']);
    $_tmpl->assign('wettkaempfe',$wettkaempfe);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-einzeln-streckenwaehlen.inc.html');
}
else{ # Zeiten whlen
	$wkids = array_keys($_SESSION['wk_abwickeln']['he_schritt2']);
    # Zeiten fr den Schwimmer holen
	if(!isset($_SESSION['wk_abwickeln']['he_schritt3'])){
    	$_SESSION['wk_abwickeln']['he_schritt3'] = array();
        $zeiten = $wk->sucheStreckenzeitenfuerMitglied($wkids,$_SESSION['wk_abwickeln']['he_schritt1']['id'],array('allezeiten'=>1));
        $query = "SELECT id, CONCAT(laenge,'_',disziplin) as strecke FROM ".DB_PREFIX."wks WHERE id IN (".implode(',',$wkids).")";
        $_db->holeDaten($query);
        $strecke2wkid = $_db->baueArray('strecke','id');
        $aktuellezeiten = $wk->holeAktuelleZeitenFuerMitglied($_SESSION['wk_abwickeln']['he_schritt1']['id'], '', false);
        foreach($zeiten as $wkid => $zeiten){
        	$_SESSION['wk_abwickeln']['he_schritt3'][$wkid] = array();
            if(isset($aktuellezeiten[$strecke2wkid[$wkid]])){
            	$_SESSION['wk_abwickeln']['he_schritt3'][$wkid][$aktuellezeiten[$strecke2wkid[$wkid]]] =
                  text_format($aktuellezeiten[$strecke2wkid[$wkid]],'schwimmzeit').' (=aktuelle Zeit)';
            }
        	foreach($zeiten as $zeit){
            	$str = text_format($zeit['zeit'],'schwimmzeit').', ';
                $str .= $zeit['datum'].(!is_null($zeit['schwimmernr'])?', Staffelzeit ('.$zeit['schwimmernr'].'.)':'').', ';
                $str .= $zeit['bahnlaenge'].'m, '.$zeit['kurztitel'];
                if(isset($_SESSION['wk_abwickeln']['he_schritt3'][$wkid][$zeit['zeit']])){
                	$str .= ' (=aktuelle Zeit)';
                }
                $_SESSION['wk_abwickeln']['he_schritt3'][$wkid][$zeit['zeit']] = $str;
            }
        }
    }
    $_tmpl->assign('zeiten',$_SESSION['wk_abwickeln']['he_schritt3']);
    # gemeldete Strecken holen
    $query = "SELECT wkid, meldezeit FROM ".DB_PREFIX."meldungen_starts
                WHERE wkid IN (".implode(',',$wkids).") AND teilnehmerid = ".$_SESSION['wk_abwickeln']['he_schritt1']['tid']."";
    $_db->holeDaten($query);
    $gemeldete = $_db->baueArray('meldezeit','wkid');
    $_tmpl->assign('gemeldete',$gemeldete);
	if(isset($_POST['weiter'])){
        require_once('func/pruefen.inc.php');
        foreach($_POST['meldezeiten'] as $wkid => $optionen){
        	if(!in_array($wkid,array_keys($_SESSION['wk_abwickeln']['he_schritt2']))){
            	continue;
            }
            if($optionen['select'] != 'textfeld'){
            	if(ctype_digit($optionen['select'])){
                	$mzeit = $optionen['select'];
                }
                else{
                	$mzeit = 'NULL';
                }
            }
            else{
            	$f = pruefen($optionen['text'],'schwimmzeit','-');
                if(empty($f) and !empty($optionen['text'])){
                	$mzeit = $optionen['text'];
                }
                else{
                	$mzeit = 'NULL';
                }
            }
            if(in_array($wkid,array_keys($gemeldete))){
            	if($gemeldete[$wkid] == $mzeit){
                    # Meldezeit wurde nicht gendert -> weiter machen
                	continue;
                }
                $query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeit = ".$mzeit."
                            WHERE teilnehmerid = ".$_SESSION['wk_abwickeln']['he_schritt1']['tid']." AND wkid = ".$wkid."";
                $_db->fuehreQueryAus($query);
                continue;
            }
            $query = "INSERT INTO ".DB_PREFIX."meldungen_starts (meldezeit,teilnehmerid,wkid) VALUES (".$mzeit.",
                        ".$_SESSION['wk_abwickeln']['he_schritt1']['tid'].", ".$wkid.")";
            $_db->fuehreQueryAus($query);
        }
		unset($_SESSION['wk_abwickeln']['he_schritt1']);
		unset($_SESSION['wk_abwickeln']['he_schritt2']);
		unset($_SESSION['wk_abwickeln']['he_schritt3']);
    	weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_einzeln','Die Meldungen wurden gespeichert');
    }
    $_tmpl->assign('wks',$_SESSION['wk_abwickeln']['he_schritt2']);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-einzeln-zeitenwaehlen.inc.html');
}
# EOF
?>