<?php
/*
 Wettkampfabwicklung, Aktion: hinzufuegen_pflichtzeiten
 verwendete Templates:
  - 42.hinzufuegen-pflichtzeiten-optionen.inc.html
 #- 42.hinzufuegen-pflichtzeit-wkwaehlen.inc.html
 #- 42.hinzufuegen-pflichtzeit-mitgliederwaehlen.inc.html
*/
#unset($_SESSION['wk_abwickeln']['hp_optionen']);
if(!isset($_SESSION['wk_abwickeln']['hp_optionen']) or isset($_POST['einstellungenaendern'])){
    if(!isset($_SESSION['wk_abwickeln']['hp_optionen'])){
        $query =  "SELECT richtpflicht FROM ".DB_PREFIX."pflichtzeiten WHERE id = ".$_SESSION['wk_abwickeln']['pflichtzeiten']."";
        $_db->holeDaten($query);
        $rp = $_db->holeWert();
    }
    else{
    	$rp = $_SESSION['wk_abwickeln']['hp_optionen']['optionen']['richtpflicht'];
    }

    if(isset($_SESSION['wk_abwicklen']['hp_optionen']) and !isset($_POST['weiter'])){
    	$optionen = $_SESSION['wk_abwicklen']['hp_optionen'];
    }
    elseif(!isset($_POST['weiter'])){
    	$optionen = array(
        	'mitglieder' => 'trainierende',
            'optionen' => array(
                'zeiten_trainierende' => 1,
                'keinewettkampfteilnahmebeachten' => 1
            ),
            'toleranzen' => array(
                'zeittoleranz' => $_gleinst['wettkaempfe_abwickeln'][($rp=='r'?'richtzeittoleranz':'pflichtzeitabstand')],
                'maxalter' => $_gleinst['wettkaempfe_abwickeln']['maxzeitalter']
            ),
            'sonstiges' => array(
                'pdferzeugen' => 0
            )
        );
    }

    if(isset($_POST['weiter'])){
    	require_once('func/pruefen.inc.php');
        $f = '';
        $d =  &$_POST['optionen'];
        $f .= pruefen($d['mitglieder'],'wertemenge','Welche Mitglieder sollen gesucht werden?',array('trainierende','vorhandenezeiten'));
        $f .= pruefen($d['toleranzen']['zeittoleranz'],'leer','Die Zeittoleranz fehlt.');
        $f .= pruefen($d['toleranzen']['zeittoleranz'],'regexpr','Die Zeittoleranz ist ungltig.','^-?[0-9.]{1,4}%?$');
        $f .= pruefen($d['toleranzen']['maxalter'],'leer','Das maximale Alter der Zeiten fehlt.');
        $f .= pruefen($d['toleranzen']['maxalter'],'regexpr','Das maximale Alter der Zeiten ist ungltig.','^[0-9]{1,2}$');
        if(!empty($f)){
        	$_tmpl->assign('fehler',$f);
        	$_POST['optionen']['optionen']['richtpflicht'] = $rp;
            $optionen = $_POST['optionen'];
        }
        else{
        	$_POST['optionen']['optionen']['richtpflicht'] = $rp;
            $_SESSION['wk_abwickeln']['hp_optionen'] = $_POST['optionen'];
            weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_pflichtzeiten');
        }
    }
    $optionen['optionen']['richtpflicht'] = $rp;
    $_tmpl->assign('optionen',$optionen);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-pflichtzeiten-optionen.inc.html');
}
else{
	# Wettkaempfe holen
    $query = "SELECT ps.id, wknr, a.nr as abschnnr, w.mw, w.laenge, w.disziplin, w.jahrgang
                FROM ".DB_PREFIX."pflichtzeiten_strecken as ps, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                WHERE pflichtzeitenid = ".$_SESSION['wk_abwickeln']['pflichtzeiten']." AND
                  a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND ps.laenge=w.laenge AND
                  ps.disziplin = w.disziplin AND ps.mw=w.mw AND w.abschnittid = a.id AND (wkart = 'e' OR wkart = 'v')
                ORDER BY ps.disziplin, ps.laenge, w.mw";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl']<1){
        $_SESSION['hinweis'] = 'Es wurden keine Wettkmpfe gefunden';
    }
    else{
        $wks = $_db->baueArray('*','id');

        $keinewkteilnahmebeachten = $_SESSION['wk_abwickeln']['hp_optionen']['optionen']['keinewettkampfteilnahmebeachten']==1;
        $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'] = $_SESSION['wk_abwickeln']['hp_optionen']['toleranzen']['maxalter'];

        if($_SESSION['wk_abwickeln']['hp_optionen']['mitglieder'] == 'vorhandenezeiten'){
            # Schwimmer fuer Wettkaempfe holen
            foreach($wks as $wkid => $w){
                $conf = $w;
                $richtpflicht = $_SESSION['wk_abwickeln']['hp_optionen']['optionen']['richtpflicht'];
                $conf['richtpflicht'] = $wks[$wkid]['richtpflicht'] = $richtpflicht;
                $conf['maxzeitalter'] = $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'];
                $conf['toleranz'] = 20;#$_SESSION['wk_abwickeln']['hp_optionen']['toleranzen']['zeittoleranz'];
                unset($conf['wkart']);
                $wks[$wkid]['_schwimmer'] = $wk->schwimmerFuerPflichtzeit($conf);
            }
        }
        else{
            # trainierende Mitglieder holen
            $query = "SELECT mt.mitgliedid, COUNT(z.id) as anz
                        FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt LEFT JOIN ".DB_PREFIX."zeiten as z ON mt.mitgliedid=z.mitgliedid
                          LEFT JOIN ".DB_PREFIX."eigenschaften as e ON mt.mitgliedid=e.artid AND art='m' AND e.eigenschaft='keinewettkampfteilnahme'
                        ".($keinewkteilnahmebeachten?'WHERE eigenschaft IS NULL':'')." GROUP BY mt.mitgliedid HAVING anz > 0";
            $_db->holeDaten($query);
            $mids = $_db->baueArray('mitgliedid','#');
            if(count($mids)<1){
                $_tmpl->assign('fehler','es wurden keine Mitglieder gefunden');
            }
            else{
                # Mitgliederdaten holen
                $query = "SELECT id, CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg, mw FROM ".DB_PREFIX."mitglieder
                            WHERE id IN (".implode(',',$mids).") ORDER BY name";
                $_db->holeDaten($query);
                $mitglieder = $_db->baueArray('*','id');
                $pflichtzeiten = array();
                foreach($mitglieder as $mid => $daten){
                    # Pflichtzeiten holen
                    if(!isset($pflichtzeiten[$daten['jg'].'_'.$daten['mw']])){
                        $pflichtzeiten[$daten['jg'].'_'.$daten['mw']] = $wk->holePflichtzeitenFuerJahrgangGeschlecht(substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4), $daten['jg'], $daten['mw']);
                    }
                    $pz = $pflichtzeiten[$daten['jg'].'_'.$daten['mw']];

                    if($pz === false){
                        unset($mitglieder[$mid]);
                        continue;
                    }
                    # Zeiten des Mitglieds holen
                    $zeiten = $wk->holeAktuelleZeitenFuerMitglied($mid, '', false);
                    if(count($zeiten) == 0){
                        unset($mitglieder[$mid]);
                        continue;
                    }

                    $prozent = substr($_SESSION['wk_abwickeln']['hp_optionen']['toleranzen']['zeittoleranz'],-1)=='%';
                    $pflichtzeit = $_SESSION['wk_abwickeln']['hp_optionen']['optionen']['richtpflicht']=='p';
                    $toleranz = $_SESSION['wk_abwickeln']['hp_optionen']['toleranzen']['zeittoleranz'];
                    if($prozent){
                        $toleranz_o = substr($toleranz,0,-1)*0.01;
                    }
                    else{
                        $toleranz_o = $toleranz*100;
                    }
                    # Zeiten mit Pflichtzeiten vergleichen
                    foreach($zeiten as $strecke => $zeit){
                        if(!isset($pz[$strecke])){ # Strecke gibt es bei den Pflichtzeiten nicht
                            unset($zeiten[$strecke]);
                            continue;
                        }
                        $pflzeit = $pz[$strecke];
                        if($prozent){
                            $toleranz = $toleranz_o*$pflzeit;
                        }
                        $pflzeit = $pflichtzeit?$pflzeit-$toleranz:$pflzeit+$toleranz;
                        # berprfen
                        if($pflzeit <= $zeit){
                            unset($zeiten[$strecke]);
                        }
                        else{
                            $zeiten[$strecke] = $zeit;
                        }
                    }
                    if(count($zeiten)<1){
                        unset($mitglieder[$mid]);
                        continue;
                    }
                    $mitglieder[$mid]['_zeiten'] = $zeiten;
                }
            }

            # Strecke -> wknr
            $query = "SELECT CONCAT(wknr,' (',nr,')') as wk, CONCAT(laenge,'_',disziplin,'_',mw) as strecke
                        FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                        WHERE w.abschnittid = a.id AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
            $_db->holeDaten($query);
            $strecke2wknr = $_db->baueArray('wk','strecke');



            $pdfdaten = array();
            foreach($mitglieder as $mid => $daten){
                $erste = true;
                $tmp = array(
                    'name'        => '',
                    'strecke'     => '',
                    'wk'          => '',
                    'zeit'        => '',
                    'pflichtzeit' => ''
                );
                foreach($daten['_zeiten'] as $strecke => $zeit){
                    $zeile = $tmp;
                    list($l,$d) = explode('_',$strecke);
                    $zeile['strecke'] = $l.' '.$_lagen[$d];
                    $zeile['wk'] = $strecke2wknr[$strecke.'_'.$daten['mw']];
                    $zeile['zeit'] = text_format($zeit,'schwimmzeit');
                    $zeile['pflichtzeit'] = text_format($pflichtzeiten[$daten['jg'].'_'.$daten['mw']][$strecke],'schwimmzeit');
                    if($erste){
                        $zeile['name'] = $daten['name'].' ('.$daten['mw'].', '.$daten['jg'].')';
                        $erste = false;
                    }
                    $pdfdaten[] = $zeile;
                }
            }
            require_once('class/pdf.inc.php');
            $pdf = new tkpdf(12);
            $schriftgroesse = 12;
            $pdf->tkseitennummern();
            $pdf->tkseitentitel('Mitglieder die die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen');

            $optionen = array(
                'fontSize' => $schriftgroesse,
                'xPos' => 60,
                'xOrientation' => 'right',
                'shaded' => 0,
                'showLines' => 2,
                'colGap' => 7
            );
            $spalten = array(
                'name' => 'Name',
                'strecke' => 'Strecke',
                'wk' => 'WK',
                'zeit' => 'Meldezeit',
                'pflichtzeit' => 'Pflichtzeit'
            );
            $y = $pdf->ezTable($pdfdaten,$spalten,'',$optionen);
            $pdf->tk_autor = $_SESSION['user']['realname'];
            $pdf->tk_titel = 'Mitglieder die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen';
            $pdf->tkstream('liste_pflichtzeiten.pdf');
        }
    }
}
#$_inh .= '<hr />'.printr($_SESSION['wk_abwickeln'],true,true);


# alter Code
/*
require_once('class/pdf.inc.php');
if($_SERVER['REQUEST_METHOD'] == 'HEAD'){
	$pdf = new tkpdf();
	$pdf->tkstream('liste_pflichtzeiten.pdf');
}

# Richt- oder Pflichtzeit?
$query = "SELECT richtpflicht FROM ".DB_PREFIX."pflichtzeiten WHERE id = ".$_SESSION['wk_abwickeln']['pflichtzeiten']."";
$_db->holeDaten($query);
$richtpflicht = $_db->holeWert();
if($_db->ergebnis['anzahl']<1){
	$_SESSION['hinweis'] = 'Es wurden keine Wettkmpfe gefunden';
    break;
}
$wks = $_db->baueArray('*','id');
# Schwimmer fuer Wettkaempfe holen
foreach($wks as $wkid => $w){
    $conf = $w;
    $conf['richtpflicht'] = $wks[$wkid]['richtpflicht'] = $richtpflicht;
    $conf['maxzeitalter'] = $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'];
    $conf['toleranz'] = $_gleinst['wettkaempfe_abwickeln'][($richtpflicht=='p'?'pflichtzeitabstand':'richtzeittoleranz')];
    unset($conf['wkart']);
	$wks[$wkid]['_schwimmer'] = $wk->schwimmerFuerPflichtzeit($conf);
}
# PDF-Klasse starten, Kopf- und Fusszeile setzen
require_once('class/pdf.inc.php');
$pdf = new tkpdf(12);
$schriftgroesse = 12;
$pdf->ezSetMargins(45,40,50,20);
$pdf->tkseitennummern();
$pdf->tkseitentitel('Mitglieder die die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen');
# Optionen fuer Tabellen
$optionen = array(
    'fontSize' => $schriftgroesse,
    'xPos' => 60,
    'xOrientation' => 'right',
    'shaded' => 0,
    'showLines' => 2,
    'colGap' => 7
);
# Liste nach Mitgliedern sortiert
$pdf->ezText('Liste nach Mitgliedern sortiert',$schriftgroesse+4);
$mitglieder = array();
foreach($wks as $w){
    $richtpflicht = ($w['richtpflicht']=='r'?'Richt':'Pflicht').'zeit';
	foreach($w['_schwimmer'] as $m){
    	if(!isset($mitglieder[$m['mid']])){
        	$tmp = array();
            $tmp['mid'] = $m['mid'];
            $tmp['name'] = $m['name'];
            $tmp['jahrg'] = $m['jahrg'];
            $tmp['dsvid'] = $m['dsvid'];
            $tmp['mw'] = $m['mw'];
            $tmp['richtpflicht'] = $richtpflicht;
            $tmp['_wks'] = array();
            $mitglieder[$m['mid']] = $tmp;
        }
        $tmp = array();
        $tmp['lage'] = $w['laenge'].' '.$_lagen[$w['disziplin']];
        $tmp['wknr'] = $w['wknr'].' ('.$w['abschnnr'].')';
        $tmp['meldezeit'] = text_format($m['zeit'],'schwimmzeit');
        $tmp['pflichtzeit'] = text_format($m['pflichtzeit'],'schwimmzeit');
    	$tmp['datumwettkampf'] = $m['datum'].', '.$m['kurztitel'];
        $mitglieder[$m['mid']]['_wks'][] = $tmp;
    }
}
# Mitglieder holen, die nicht an Wettkaempfen teilnehmen
$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme'";
$_db->holeDaten($query);
$mids = $_db->baueArray('artid','#');
#echo 'F';
#printr($mids);
#exit;
# Mitglieder sortieren
$tmp = array();
foreach($mitglieder as $row){
    if(in_array($row['mid'],$mids)){
        continue;
    }
    $tmp[$row['mid']] = $row['name'];
}
asort($tmp);
foreach($tmp as $mid => $name){
    $tmp[$mid] = $mitglieder[$mid];
}
$mitglieder = $tmp;
# PDF-Eintraege generieren
$spalten = array(
    'lage' => 'Strecke',
    'wknr' => 'WK',
    'meldezeit' => 'Meldezeit',
    'pflichtzeit' => '',
    'datumwettkampf' => 'Datum, Wettkampf'
);
$anz = count($mitglieder);
$i = 1;
foreach($mitglieder as $m){
	$titel = $m['name'].' ('.$m['mw'].', '.$m['jahrg'].', '.(!empty($m['dsvid'])?$m['dsvid']:'-').')';
	$y = $pdf->ezText($titel,$schriftgroesse+2);
    $spalten['pflichtzeit'] = $m['richtpflicht'];
    $daten = array();
    foreach($m['_wks'] as $w){
        $daten[] = $w;
    }
    $pdf->ezSetDy(-7);
    $y = $pdf->ezTable($daten,$spalten,'',$optionen);
    $i++;
    if($y < 120 and $i <= $anz){
    	$pdf->eznewPage();
    }
    if($i <= $anz){
    	$y = $pdf->ezSetDy(-15);
    }
}
$pdf->eznewPage();

# Tabelle nach Wettkaempfen sortiert
$pdf->ezText('Liste nach Wettkmpfen sortiert',$schriftgroesse+4);
$spalten = array(
	'name' => 'Name',
    'meldezeit' => 'Meldezeit',
    'pflichtzeit' => '',
    'datumwettkampf' => 'Datum, Wettkampf'
);
foreach($wks as $w){
	$titel = 'WK'.$w['wknr'].' - '.$w['laenge'].'m '.$_lagen[$w['disziplin']].' ';
    $titel .= $w['mw'].' (Jahrgnge: '.$w['jahrgang'].', Abschnitt: '.$w['abschnnr'].')';
	$y = $pdf->ezText($titel,$schriftgroesse+2);
    $spalten['pflichtzeit'] = ($w['richtpflicht']=='r'?'Richt':'Pflicht').'zeit';
    $daten = array();
    foreach($w['_schwimmer'] as $s){
        $tmp = array();
        $tmp['name'] = $s['name'].' ('.$s['jahrg'].')';
    	$tmp['meldezeit'] = text_format($s['zeit'],'schwimmzeit');
        $tmp['pflichtzeit'] = text_format($s['pflichtzeit'],'schwimmzeit');
    	$tmp['datumwettkampf'] = $s['datum'].', '.$s['kurztitel'];
        $daten[] = $tmp;
    }
    $pdf->ezSetDy(-7);
    if(count($daten) < 1){
		$y = $pdf->ezText('Fr diesen Wettkampf wurden keine Schwimmer gefunden',$schriftgroesse+2);
    }
    else{
    	$y = $pdf->ezTable($daten,$spalten,'',$optionen);
    }
    if($y < 120){
    	$pdf->eznewPage();
    }
    else{
    	$y = $pdf->ezSetDy(-15);
    }
}
# PDF-Autor und -Titel setzen, ausgeben
$pdf->tk_autor = $_SESSION['user']['realname'];
$pdf->tk_titel = 'Mitglieder die Richt-/Pflichtzeiten fr '.$_SESSION['wk_abwickeln']['titel'].' erfllen';
if(isset($_GET['ziel']) and $_GET['ziel']=='dateisystem' and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
	require_once('class/dateien.inc.php');
    $dat = new dateien($_db,$_tmpl);
	$daten = $pdf->tkstream('liste_pflichtzeiten.pdf','rueckgabe');
    if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], 'liste_pflichtzeiten.pdf', 'pdf', $daten, 'Schwimmer die die Pflichtzeiten erfllen',true)){
    	weiterleiten('/wettkaempfe/abwickeln.html','die Datei wurde im Dateisystem abgelegt');
    }
}
$pdf->tkstream('liste_pflichtzeiten.pdf');}
*/

/*
if(isset($_GET['wkzuruecksetzen'])){
    unset($_SESSION['wk_abwickeln']['wk']);
}
$_SESSION['wk_abwickeln']['hinzufuegenoption'] = 'hinzufuegen_pflichtzeiten';
if(!isset($_SESSION['wk_abwickeln']['wk'])){
    $query = "SELECT DISTINCT w.id, wknr, a.nr as abschnnr, w.mw, w.laenge, w.disziplin, w.jahrgang, pj.richtpflicht,
                  w.wkart, FIELD(laenge,'50','100','200','400','800','1500') AS sort
                FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."pflichtzeiten_zeiten as pz,
                  ".DB_PREFIX."pflichtzeiten_jahrgaenge as pj
                WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND w.abschnittid = a.id AND pz.wkid = w.id AND
                  pz.jahrgangid = pj.id AND (wkart = 'e' OR wkart = 'v') AND SUBSTRING(laenge,2,1) != 'x' AND SUBSTRING(w.laenge,3,1) != 'x'
                ORDER BY sort, disziplin, wknr";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl']<1){
        $_SESSION['hinweis'] = 'Es wurden keine Wettkmpfe gefunden';
        break;
    }
    $daten = $_db->ergebnis['daten'];
    $wkids = array();
    foreach($daten as $key => $row){
        $conf = $row;
        $conf['maxzeitalter'] = $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'];
        $conf['toleranz'] = $_gleinst['wettkaempfe_abwickeln'][($conf['richtpflicht']=='p'?'pflichtzeitabstand':'richtzeittoleranz')];
        unset($conf['wkart']);
        $daten[$key]['_schwimmer'] = $wk->schwimmerFuerPflichtzeit($conf);
        if(count($daten[$key]['_schwimmer']) < 1){
            unset($daten[$key]);
            continue;
        }
        $wkids[] = $row['id'];
        $daten[$key]['original_jahrgang'] = $row['jahrgang'];
        $daten[$key]['jahrgang'] = $wk->_formatiereJahrgang($row['jahrgang']);
    }
    if(isset($_POST['wkid']) and in_array($_POST['wkid'],$wkids)){
        foreach($daten as $row){
            if($row['id'] == $_POST['wkid']){
                unset($row['sort']);
                $_SESSION['wk_abwickeln']['wk'] = $row;
                break;
            }
        }
        weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_pflichtzeiten');
    }
    $_tmpl->assign('wks',$daten);
    $_tmpl->assign('lagen',$_lagen);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-pflichtzeit-wkwaehlen.inc.html');
}
else{
    $conf = $_SESSION['wk_abwickeln']['wk'];
    $conf['jahrgang'] = $conf['original_jahrgang'];
    $conf['maxzeitalter'] = $_gleinst['wettkaempfe_abwickeln']['maxzeitalter'];
    $conf['toleranz'] = $_gleinst['wettkaempfe_abwickeln'][($conf['richtpflicht']=='p'?'pflichtzeitabstand':'richtzeittoleranz')];
    unset($conf['original_jahrgang'], $conf['wkart']);
    $daten = $wk->schwimmerFuerPflichtzeit($conf);

    # gemeldete holen
    $query = "SELECT meldezeitid, mt.mid, teilnehmerid
                FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt
                WHERE wkid = ".$conf['id']." AND ms.teilnehmerid = mt.id AND wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
    $_db->holeDaten($query);
    $gemeldete = ($_db->ergebnis['anzahl'] > 0)?$_db->ergebnis['daten']:array();
    if(isset($_POST['speichern'])){
        $gemeldetemids = $_db->baueArray('teilnehmerid','mid');
        foreach($_POST['mitglieder'] as $mid => $meldezeitid){
            if(in_array($mid,array_keys($gemeldetemids))){
                $teilnehmerid = $gemeldetemids[$mid];
                $query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeitid = ".$meldezeitid."
                            WHERE teilnehmerid = ".$teilnehmerid." AND wkid = ".$conf['id']."";
                $_db->fuehreQueryAus($query);
            }
            else{
                $query = "SELECT id FROM ".DB_PREFIX."meldungen_teilnehmer WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mid = ".$mid."";
                $_db->holeDaten($query);
                if($_db->ergebnis['anzahl'] < 1){
                    $query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer SET wettkampfid = ".$_SESSION['wk_abwickeln']['id'].", mid = ".$mid."";
                    $_db->fuehreQueryAus($query);
                    $teilnehmerid = $_db->ergebnis['insertid'];
                }
                else{
                    $teilnehmerid = $_db->holeWert();
                }
                $query = "INSERT INTO ".DB_PREFIX."meldungen_starts
                                SET teilnehmerid = ".$teilnehmerid.", meldezeitid = ".$meldezeitid.", wkid = ".$conf['id']."";
                $_db->fuehreQueryAus($query);
            }
        }
        $_SESSION['hinweis'] = 'Die nderungen wurden gespeichert';
        $query = "SELECT meldezeitid, mt.mid
                    FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt
                    WHERE wkid = ".$conf['id']." AND ms.teilnehmerid = mt.id AND wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
        $_db->holeDaten($query);
        $gemeldete = ($_db->ergebnis['anzahl'] > 0)?$_db->ergebnis['daten']:array();
    }
    # gemeldete markieren
    foreach($gemeldete as $row){
        $daten[$row['mid']]['gemeldet'] = 1;
        if($daten[$row['mid']]['zid'] != $row['meldezeitid']){
            $daten[$row['mid']]['anderezeit'] = 1;
        }
    }
    $_tmpl->assign('daten',$daten);
    $_tmpl->assign('lagen',$_lagen);
    $_tmpl->assign('wk',$conf);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-pflichtzeit-mitgliederwaehlen.inc.html');
}
*/
# EOF
?>