<?php
/*
 Wettkampfabwicklung, Aktion: hinzufuegen_zeitenexport
 verwendete Templates:
  - 42.hinzufuegen-auszeitenexport.inc.html
*/
if(isset($_GET['gespeicherteloeschen'])){
	unset($_SESSION['zeitenexport2wkmeldung']);
    if(isset($_SESSION['wk_abwickeln']['meldungauszeitenexport'])){
    	unset($_SESSION['wk_abwickeln']['meldungauszeitenexport']);
    }
	weiterleiten('/wettkaempfe/abwickeln.html','Die exportieren Zeiten wurden gelscht.');
}
require_once('class/zeitenexport.inc.php');
$_ze = new zeitenexport;
$_ze->_einst['altersklassen'] = $_altersklassen;

if(isset($_SESSION['zeitenexport2wkmeldung']) and $_SESSION['zeitenexport2wkmeldung'] !== false){
    $export = $_SESSION['zeitenexport2wkmeldung'];
    $wettkampf = $_SESSION['wk_abwickeln']['id'];

    # Mitglieder holen
    $query = "SELECT id, CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg, mw
                FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',array_keys($export)).") ORDER BY nachname, vorname";
    $_db->holeDaten($query);
    $mitglieder = $_db->baueArray('*','id');

    # Wettkmpfe holen
    $query = "SELECT w.id, a.nr, w.wknr, w.mw, w.laenge, w.disziplin, w.jahrgang, w.wkart
                FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
                WHERE a.id = w.abschnittid AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND
                  wkart != 'f' AND wkart != 'z' AND LOCATE('x', w.laenge)<1
                ORDER BY a.nr, w.wknr";
    $_db->holeDaten($query);
    $wettkaempfe = $_db->baueArray('*','id');
    foreach($wettkaempfe as $id => $row){
        $wettkaempfe[$id]['_kurz'] = 'WK'.$row['wknr'].'-'.$row['nr'].', '.$row['laenge'].'m '.$_lagen[$row['disziplin']].' '.$_geschlechter[$row['mw']];
        $wettkaempfe[$id]['_lang'] = 'WK '.$row['wknr'].' (A'.$row['nr'].'), '.$row['laenge'].'m '.$_lagen[$row['disziplin']].' '.$_geschlechter[$row['mw']].($row['wkart']=='v'?' (Vorlauf)':'').', '.$_ze->formatiereAltersklasse($row['jahrgang']);
        $wettkaempfe[$id]['_jahrgaenge'] = $_ze->_holeJahrgaenge($row['jahrgang']);
    }

    # vorhandene Meldungen
    $query = "SELECT mt.id as teilnehmerid, mt.mid, ms.meldezeit, ms.wkid
                FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."meldungen_starts as ms
                WHERE mt.id = ms.teilnehmerid AND mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
                  ".(count($mitglieder)>0?' AND mid IN ('.implode(',',array_keys($mitglieder)).')':'')."";
    $_db->holeDaten($query);
    $tmp = $_db->baueArray('*','#');
    $vorhandenemeldungen = array();
    foreach($tmp as $row){
        $vorhandenemeldungen[$row['mid'].'_'.$row['wkid']] = $row;
    }
    $daten = array();
    foreach($mitglieder as $mid => $row){
        $row = $export[$mid];
        $_mw = $mitglieder[$mid]['mw'];
        $_jg = $mitglieder[$mid]['jg'];
        $daten[$mid] = array(
            'name' => $mitglieder[$mid]['name'],
            'jg' => $_jg,
            'mw' => $_mw,
            '_teilnehmerid' => false,
            'meldungen' => array()
        );
        # bei bereits gemeldeten Mitgliedern die Teilnehmerid speichern
        foreach($vorhandenemeldungen as $meldung){
            if($meldung['mid'] != $mid){
                continue;
            }
            $daten[$mid]['_teilnehmerid'] = $meldung['teilnehmerid'];
            break;
        }
        foreach($row as $meldung){
            $tmp = $meldung;
            $tmp['_bez'] = $meldung['laenge'].$_lagen[$meldung['lage']][0];
            $tmp['_wk'] = false;
            # Wettkampf suchen
            foreach($wettkaempfe as $wettk){
                # unpassende Wettkmpfe aussortieren
                if($wettk['mw'] != $_mw and $wettk['mw'] != 'x'){ # falsches Geschlecht
                    continue;
                }
                if($wettk['laenge'] != $meldung['laenge']){ # falsche Lnge
                    continue;
                }
                if($wettk['disziplin'] != $meldung['lage']){ # falsche Disziplin
                    continue;
                }
                if(!in_array($_jg, $wettk['_jahrgaenge'])){ # falscher Jahrgang
                    continue;
                }
                # gefundene Wettkmpfe setzen
                if($tmp['_wk'] === false){
                    $tmp['_wk'] = $wettk['id'];
                }
                elseif(!is_array($tmp['_wk'])){
                    $tmp['_wk'] = array($tmp['_wk']);
                    $tmp['_wk'][] = $wettk['id'];
                }
                else{
                    $tmp['_wk'][] = $wettk['id'];
                }
            }
            # berprfen ob bereits gemeldet
            $tmp['_vorhandenezeit'] = false;
            if($daten[$mid]['_teilnehmerid'] !== false and $tmp['_wk'] !== false and !is_array($tmp['_wk'])){


                if(isset($vorhandenemeldungen[$mid.'_'.$tmp['_wk']])){
                    $tmp['_vorhandenezeit'] = $vorhandenemeldungen[$mid.'_'.$tmp['_wk']]['meldezeit'];
                }

            }
            $daten[$mid]['meldungen'][] = $tmp;
        }
    }
    $_SESSION['wk_abwickeln']['meldungauszeitenexport'] = array(
    	'daten' => $daten,
        'wettkaempfe' => $wettkaempfe,
    );
    $_SESSION['zeitenexport2wkmeldung'] = false;
}


if(isset($_POST['speichern'])){
	$daten = $_SESSION['wk_abwickeln']['meldungauszeitenexport']['daten'];
	if(isset($_POST['geaendertewkids']) and is_array($_POST['geaendertewkids'])){
    	foreach($_POST['geaendertewkids'] as $mid => $wert){
            list($zkey, $wkid) = each($wert);
        	if($wkid == '-'){
            	unset($daten[$mid]['meldungen'][$zkey]);
            	continue;
            }
            $daten[$mid]['meldungen'][$zkey]['_wk'] = $wkid;
        }
    }

    $starts = 0;
    foreach($daten as $mid => $mitgl){
    	if(count($mitgl['meldungen'])<1){
        	continue;
        }

        # Teilnehmerid holen
        if($mitgl['_teilnehmerid'] === false){ # Mitglied noch nicht gemeldet, Teilnehmer anlegen
        	$query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer SET wettkampfid = ".$_SESSION['wk_abwickeln']['id'].", mid = ".$mid."";
            $_db->fuehreQueryAus($query);
            $teilnehmerid = $_db->ergebnis['insertid'];
        }
        else{
            $teilnehmerid = $mitgl['_teilnehmerid'];
        }

        foreach($mitgl['meldungen'] as $zkey => $meldung){
        	if($meldung['_wk'] == '-'){
            	continue;
            }
            if($meldung['_vorhandenezeit'] === false){ # keine Meldung vorhanden -> anlegen
            	$query = "INSERT INTO ".DB_PREFIX."meldungen_starts SET
                          	  teilnehmerid = ".$teilnehmerid.",
                          	  meldezeit = ".$meldung['zeit'].",
                          	  wkid = ".$meldung['_wk']."";
            	$_db->fuehreQueryAus($query);
            	$starts++;
            }
            elseif($meldung['zeit'] != $meldung['_vorhandenezeit']){
            	if(!isset($_POST['zeitueberschreiben']) or !isset($_POST['zeitueberschreiben'][$mid]) or !in_array($zkey, $_POST['zeitueberschreiben'][$mid])){
                	continue;
                }
                $query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeit = ".$meldung['zeit']."
                            WHERE teilnehmerid = ".$teilnehmerid." AND wkid = ".$meldung['_wk']."";
            	$_db->fuehreQueryAus($query);
            }
        }
    }
    unset($_SESSION['wk_abwickeln']['meldungauszeitenexport']);
    unset($_SESSION['zeitenexport2wkmeldung']);
    if($_wkeinst['flags']['pflichtzeitengeprueft'] != 0){
    	$_wkeinst['flags']['pflichtzeitengeprueft'] = 0;
    	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
    }
    weiterleiten('/wettkaempfe/abwickeln.html','Es wurde'.($starts==1?' 1 Start':'n '.$starts.' Starts').' eingetragen');
}

$_tmpl->assign('wettkaempfe',$_SESSION['wk_abwickeln']['meldungauszeitenexport']['wettkaempfe']);
$_tmpl->assign('daten',$_SESSION['wk_abwickeln']['meldungauszeitenexport']['daten']);
$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-auszeitenexport.inc.html');
# EOF
?>