<?php
/*
 Wettkampfabwicklung, Aktion: kontrolllistegenerieren
 verwendete Templates:
  - 42.abwickeln-kontrollliste.inc.html
*/
$fehler = false;
if(isset($_SESSION['wk_abwickeln']['pflichtzeiten'])){
	$link = ROOT.'/wettkaempfe/abwickeln.html?aktion=einhaltung_pflichtzeit';
	if(!isset($_wkeinst['flags']['pflichtzeitengeprueft']) or $_wkeinst['flags']['pflichtzeitengeprueft'] == '0'){
    	$fehlermeldung = 'Die Meldung muss erst auf die Einhaltung der Pflichtzeiten <a href="'.$link.'">berprft</a> werden.';
        $fehler = true;
	}
    elseif($_wkeinst['flags']['pflichtzeitengeprueft'] == '-'){
    	$fehlermeldung = 'Die momentane Meldung kann nicht abgeschickt werden, da Mitglieder gemeldet sind, die die Pflichtzeit nicht erfllen bzw. ohne Zeit gemeldet sind, siehe <a href="'.$link.'">Prfseite</a>.';
        $fehler = true;
    }
}

if($fehler){
	$_tmpl->assign('fehler', $fehlermeldung);
}
else{
$wkid = $_SESSION['wk_abwickeln']['id'];
$kontrollliste = '';
# Kampfrichtermeldung
if(count($_wkeinst['kampfrichter']) > 0){
	# Abschnittid -> Abschnittnr
    $query = "SELECT id, nr FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid."";
    $_db->holeDaten($query);
    $abschnids = $_db->baueArray('nr','id');
    # Kampfrichter
    $query = "SELECT k.id, CONCAT(nachname,', ',vorname) as name, gruppe
               FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
               WHERE k.mitgliedid = m.id AND k.id IN (".implode(',',array_keys($_wkeinst['kampfrichter'])).")
               ORDER BY m.nachname, m.vorname";
    $_db->holeDaten($query);
    $kampfr = array();
    foreach($_db->ergebnis['daten'] as $row){
    	$kampfr[$row['id']] = $row;
    }
    # und zusammenbauen
    $kontrollliste = 'Kampfrichter:'."\n";
    foreach($_wkeinst['kampfrichter'] as $kariid => $kariabschn){
        $tmp = explode(',',$kariabschn);
        $abschn = array();
        foreach($tmp as $t){
        	$abschn[] = $abschnids[$t];
        }
        $kontrollliste .= '  '.$kampfr[$kariid]['name'].' (KaRiGr: '.$kampfr[$kariid]['gruppe'].', Abschnitte: '.implode(',',$abschn).')'."\n";
    }
}

# Einzelmeldungen
$anzstarts = array('personen' => 0, 'einzeln' => 0, 'staffel' => 0);
$query = "SELECT CONCAT(m.nachname, ', ', m.vorname) as name, dsvid, UCASE(mw) as mw, YEAR(gebdatum) as jg, mt.id as meldungsid
            FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
            WHERE wettkampfid = ".$wkid." AND m.id = mt.mid ".($_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1?"AND teilnahme = '+'":"")." ORDER BY m.nachname, m.vorname";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] > 0){
    $kontrollliste .= "\nEinzelmeldungen:\n";
	$anzstarts['personen'] = $_db->ergebnis['anzahl'];
    $daten = $_db->ergebnis['daten'];
    foreach($daten as $m){
        $query = "SELECT wknr, ms.meldezeit as zeit, w.laenge, w.disziplin
                    FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                    WHERE ".($_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1?"teilnahme = '+' AND ":"")."teilnehmerid = ".$m['meldungsid']." AND ms.wkid = w.id AND a.id = w.abschnittid
                    ORDER BY a.nr, w.wknr";
        $_db->holeDaten($query);
        if($_db->ergebnis['anzahl'] < 1){
            continue;
        }
        $anzstarts['einzeln'] += $_db->ergebnis['anzahl'];
        $wks = $_db->ergebnis['daten'];
        $tmp = '  '.$m['name'].' ('.$m['mw'].','.$m['jg'].''.(empty($m['dsvid'])?'':','.$m['dsvid']).'):';
        $kl = array();
        foreach($wks as $w){
            $kl[] = $w['laenge'].substr($_lagen[$w['disziplin']],0,1).'/WK'.$w['wknr'].' ('.(is_null($w['zeit'])?((isset($_wkeinst['meldedatei']['ohnemeldezeit']) and $_wkeinst['meldedatei']['ohnemeldezeit']=='ohnezeit')?'00:00,00':'59:59,99'):text_format($w['zeit'],'schwimmzeit')).')';
        }
        if(count($kl) > 0){
        	$maxbreite = 72;
        	$laenge = strlen($tmp);
            $anz = count($kl);
            for($i=0;$i<$anz;$i++){
            	if($laenge+strlen($kl[$i])+2 > $maxbreite){
                	$tmp .= ($i!=0?',':'')."\n".'    '.$kl[$i];
                    $laenge = strlen($kl[$i])+4;
                }
                else{
                	$tmp .= ($i!=0?', ':' ').$kl[$i];
                    $laenge += strlen($kl[$i])+2;
                }
            }
            $tmp .= "\n";
        }
        else{
        	$tmp .= "keine Meldung\n";
        }
        $kontrollliste .= $tmp;
    }
}

# Staffeln
if(isset($_wkeinst['staffeln'])){
    foreach($_wkeinst['staffeln'] as $key => $staffel){
        if(substr($key,0,9) == 'staffeln_'){
            unset($_wkeinst['staffeln'][$key]);
        }
    }
    if(count($_wkeinst['staffeln']) > 0){
        $kontrollliste .= "\nStaffelmeldungen:\n";
        $query = "SELECT wknr, id, laenge, disziplin FROM ".DB_PREFIX."wks WHERE id IN (".implode(',', array_keys($_wkeinst['staffeln'])).")";
        $_db->holeDaten($query);
        $wkids = array();
        foreach($_db->ergebnis['daten'] as $row){
            $wkids[$row['id']] = $row;
        }
        $staffeln = array();
        foreach($_wkeinst['staffeln'] as $key => $staffel){
            $zeiten = explode(',', $staffel);
            $tmp = '  '.$wkids[$key]['laenge'].$_lagen[$wkids[$key]['disziplin']]{0}.'/WK'.$wkids[$key]['wknr'].': ';
            $i = 1;
            $staffeln = array();
            foreach($zeiten as $z){
                $staffeln[] = 'Mannschaft '.$i.': '.text_format($z, 'schwimmzeit');
                $i++;
            }
            $anzstarts['staffel'] += count($staffeln);
            if(count($staffeln) > 0){
                $maxbreite = 72;
                $laenge = strlen($tmp);
                $anz = count($staffeln);
                for($i=0;$i<$anz;$i++){
                    if($laenge+strlen($staffeln[$i])+2 > $maxbreite){
                        $tmp .= ($i!=0?',':'')."\n".'    '.$staffeln[$i];
                        $laenge = strlen($staffeln[$i])+4;
                    }
                    else{
                        $tmp .= ($i!=0?', ':'').$staffeln[$i];
                        $laenge += strlen($staffeln[$i])+2;
                    }
                }
                $tmp .= "\n";
            }
            else{
                $tmp .= "keine Meldung\n";
            }
            $kontrollliste .= $tmp;
        }
    }
}
$_tmpl->assign('kontrollliste', trim($kontrollliste));
# Meldegeld berechnen
$query = "SELECT meldegeld FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
$_db->holeDaten($query);
$meldegeld = $wk->parseMeldegeld($_db->holeWert(),'db','wkpreis_rechnen');
$query = "SELECT wknr, COUNT(*) as anz
            FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."wks as w
            WHERE ms.teilnehmerid=mt.id AND ms.wkid=w.id AND wettkampfid = ".$_SESSION['wk_abwickeln']['id'].($_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1?" AND ms.teilnahme = '+'":"")."
            GROUP BY wknr ORDER BY wknr";
$_db->holeDaten($query);
$wkzahlen = $_db->baueArray('anz','wknr');
$preis = array('einzel'=>0,'staffel'=>0);
foreach($wkzahlen as $wknr => $zahl){
	if(in_array($wknr,array_keys($meldegeld['wks']))){
    	$preis['einzel'] += $meldegeld['wks'][$wknr]*$zahl;
    }
    else{
    	$preis['einzel'] += $meldegeld['einzel']*$zahl;
    }
}
$preis['staffel'] = $meldegeld['staffel']*$anzstarts['staffel'];
# Zusammenfassung ausgeben
$preis['summe'] = number_format($preis['einzel']+$preis['staffel'],2,',','');
$preis['einzel'] = number_format($preis['einzel'],2,',','');
$preis['staffel'] = number_format($preis['staffel'],2,',','');


$_tmpl->assign('anzstarts', $anzstarts);
$_tmpl->assign('preis', $preis);
$_tmpl->assign('stand', date('d.m.Y, H:i'));

$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-kontrollliste.inc.html');
} # Ende $fehler-else
# EOF
?>