<?php
/*
 Wettkampfabwicklung, Aktion: pdf_telefonliste
 verwendete Templates:
  - 42.abwickeln-telefonliste.inc.html
*/
if(!isset($_POST['ausgeben'])){
    # teilnehmende Mitglieder mit Telefonnummer aus Meldezettel holen
    $query = "SELECT CONCAT(nachname,', ',vorname) as name, mid, telefon
                FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."meldungen_teilnehmer as mt
                WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND teilnahme != '-' AND mt.mid = m.id
                ORDER BY name";
    $_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] < 1){
		$_tmpl->assign('fehler','Es sind noch keine Mitglieder ausgewhlt');
	}
    else{
        $daten = array();
        foreach($_db->ergebnis['daten'] as $row){
            $daten[$row['mid']] = array(
                'name' => $row['name'],
                '_nr' => array()
            );
            if(!empty($row['telefon'])){
                $daten[$row['mid']]['_nr'][] = array(
                    'nr' => $row['telefon'],
                    'art' => 'Rcklaufzettel',
                    'gewaehlt' => 1
                );
            }
        }
        # Sonstige Zeiten holen
        $mids = $_db->baueArray('mid','#');
        $query = "SELECT mitgliedid as mid, CONCAT(vorwahl,'/',nummer) as nr, telefonart
                     FROM ".DB_PREFIX."telefon
                     WHERE mitgliedid IN (".implode(',',$mids).") AND telefonart IN (1,2)";
        $_db->holeDaten($query);
        foreach($_db->ergebnis['daten'] as $row){
            if(count($daten[$row['mid']]['_nr']) == 0){
                $tmp = array(
                    'nr' => $row['nr'],
                    'art' => $_telefonarten[$row['telefonart']],
                    'gewaehlt' => 1
                );
            }
            else{
                $tmp = array(
                    'nr' => $row['nr'],
                    'art' => $_telefonarten[$row['telefonart']]
                );
            }
            $daten[$row['mid']]['_nr'][] = $tmp;
            $tmp = array();
        }
        $_tmpl->assign('daten',$daten);
        $_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-telefonliste.inc.html');
    }
}
else{ # PDF-Datei ausgeben
	# PDF-Klasse starten, Liniendicke, Schriftart, Ueberschrift
	require_once('class/pdf.inc.php');
	$pdf = new tkpdf(12);
    $schriftgroesse = 12;
    $pdf->tkseitentitel('<b>Telefonliste fr '.$_SESSION['wk_abwickeln']['titel'].'</b>');
    $pdf->tkseitennummern();
    foreach($_POST['daten'] as $row){
    	foreach($row['nummern'] as $key => $nr){
        	if(empty($nr)){
            	unset($row['nummern'][$key]);
            }
        }
        if(count($row['nummern']) < 1){
        	$row['nummern'][] = 'keine Nummer gefunden';

        }
    	$nummern = implode(', ',$row['nummern']);
    	$pdf->eztext($row['name'].' - '.$nummern, $schriftgroesse);
    }
	# PDF-Autor und -Titel setzen, ausgeben
	$pdf->tk_autor = $_SESSION['user']['realname'];
	$pdf->tk_titel = 'Telefonliste fr '.$_SESSION['wk_abwickeln']['titel'];
    if(isset($_POST['ziel']) and $_POST['ziel']=='dateisystem' and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
        require_once('class/dateien.inc.php');
        $dat = new dateien($db,$tmpl);
        $daten = $pdf->tkstream('wettkampfmeldung_telefonliste.pdf','rueckgabe');
        if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], 'wettkampfmeldung_telefonliste.pdf', 'pdf', $daten, 'Telefonliste',true)){
            weiterleiten('/wettkaempfe/abwickeln.html','die Datei wurde im Dateisystem abgelegt');
        }
    }
	$pdf->tkstream('wettkampfmeldung_telefonliste.pdf');
}
# EOF
?>