<?php
/*
 Wettkampfabwicklung, Aktion: zwischenzeiten-bemerkungen_speichern
 verwendete Templates:
  - 42.zwischenzeiten-bemerkungen_auswahl.inc.html
  - 42.zwischenzeiten-bemerkungen_formular.inc.html
*/

if(!isset($_GET['bereich'])){
	# Wettkmpfe mit Einzelstarts holen
	$query = "SELECT w.wknr, w.disziplin, w.laenge, w.mw, COUNT(z.id) as anz
                FROM (".DB_PREFIX."meldungen_starts as ms LEFT JOIN ".DB_PREFIX."wks as w ON w.id = ms.wkid) LEFT JOIN ".DB_PREFIX."zeiten as z ON ms.zeitid=z.id
                WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND (z.platz != 'NA' OR z.platz IS NULL)
                GROUP BY w.id HAVING anz > 0
                ORDER BY w.wknr, w.disziplin, w.laenge, w.mw";
    $_db->holeDaten($query);
    $einzelstarts = $_db->baueArray('*', 'wknr');
    $_tmpl->assign('einzelstarts', $einzelstarts);

    # Alle Staffeldisziplinen holen
    $query = "SELECT disziplin FROM ".DB_PREFIX."staffeln
                WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND (platz != 'NA' OR platz IS NULL)
                GROUP BY disziplin ORDER BY disziplin";
    $_db->holeDaten($query);
    $staffelstarts = $_db->baueArray('disziplin', 'disziplin');
    $_tmpl->assign('staffelstarts', $staffelstarts);

    # nachschauen ob es noch Zeiten ohne Meldung in tkswim gibt
    $query = "SELECT z.id as zid
                FROM (".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
                  LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON z.id=ms.zeitid
                WHERE z.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND sz.staffelid IS NULL AND ms.zeitid IS NULL AND (z.platz != 'NA' OR z.platz IS NULL)
                ORDER BY z.disziplin, z.streckenlaenge, z.zeit";
    $_db->holeDaten($query);
    $_tmpl->assign('startsohnemeldung', $_db->holeAnzahl()<1?false:true);

    # Teilnehmer fr Meldungen in tkswim? (z.B. bei DMS-J gibt es die nicht)
    $query = "SELECT id FROM ".DB_PREFIX."meldungen_teilnehmer WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
    $_db->holeDaten($query);
    $_tmpl->assign('teilnehmer', $_db->holeAnzahl()<1?false:true);

    $_tmpl->assign('lagen', $_lagen);
    $_tmpl->assign('mws', $_geschlechter);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.zwischenzeiten-bemerkungen_auswahl.inc.html');
}
else{

	switch($_GET['bereich'][0]){
    case 'e': # Einzelstrecken
    	# berschrift holen
        $wknr = (int)substr($_GET['bereich'],1);
        if($wknr == 0){
        	$_tmpl->assign('fehler', 'Die Wettkampfnummer ist ungltig.');
            break;
        }
        $query = "SELECT w.wknr, w.mw, w.laenge, w.disziplin, w.wkart, a.nr
                    FROM ".DB_PREFIX."wks as w LEFT JOIN ".DB_PREFIX."abschnitte as a ON w.abschnittid=a.id
                    WHERE w.wknr = ".$wknr." AND wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
        $_db->holeDaten($query);
        $w = $_db->holeZeile();
        $titel = 'WK '.$w['wknr'].' - '.$w['laenge'].'m '.$_lagen[$w['disziplin']].' '.$_geschlechter[$w['mw']].' ('.$_wkarten[$w['wkart']].', '.$w['nr'].'. Abschnitt)';
        $_tmpl->assign('titel', $titel);

    	# Bahnlnge holen
        $query = "SELECT bahnlaenge FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
        $_db->holeDaten($query);
        $bahnlaenge = $_db->holeWert();
        if(!in_array($bahnlaenge, array('25', '50'))){
        	$bahnlaenge = 25;
        }

    	$query = "SELECT z.id as zid, m.id as mid, z.zeit, z.platz, z.bemerkung, ms.meldezeit, IF(ms.meldezeit IS NULL,1,0) as ohnemeldezeit,
                      m.vorname, m.nachname, YEAR(m.gebdatum) as jg
                    FROM (((".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
                      LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON z.id=ms.zeitid)
                      LEFT JOIN ".DB_PREFIX."wks as w ON ms.wkid = w.id)
                      LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid = m.id
                    WHERE z.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND sz.staffelid IS NULL AND w.wknr = ".$wknr." AND (z.platz != 'NA' OR z.platz IS NULL)
                    ORDER BY w.wknr, ohnemeldezeit DESC, ms.meldezeit DESC, m.nachname, m.vorname";
        $_db->holeDaten($query);
        $daten = $_db->baueArray('*', 'zid');

        # Zwischenzeiten holen bzw. Array bauen
        if($w['laenge'] > $bahnlaenge and count($daten)>0){
        	$query = "SELECT zeitid, streckenlaenge, zeit, bestenliste, CONCAT(zeitid,'_',streckenlaenge) as schluessel
                        FROM ".DB_PREFIX."zwischenzeiten WHERE zeitid IN (".implode(', ', array_keys($daten)).")";
        	$_db->holeDaten($query);
        	$zwzeiten = $_db->baueArray('*', 'schluessel');
            foreach($daten as $zid => $row){
            	$row['zwischenzeiten'] = array();
                for($i=$bahnlaenge;$i<$w['laenge'];$i+=$bahnlaenge){
                	$row['zwischenzeiten'][$i] = '';
                    if(isset($zwzeiten[$row['zid'].'_'.$i])){
                		$row['zwischenzeiten'][$i] = $zwzeiten[$row['zid'].'_'.$i]['zeit'];
                    }
                }
                $daten[$zid] = $row;
            }
        }

        # Formular verarbeiten
        if(isset($_POST['speichern'])){
            require_once('func/pruefen.inc.php');
            $f = '';
            foreach($_POST['daten'] as $zid => $zeit){
            	if(!isset($daten[$zid])){
                	continue;
                }
                $fehlername = text_format($daten[$zid]['vorname'].' '.$daten[$zid]['nachname'], 'html');
            	$f .= pruefen($zeit['bemerkung'], 'maxlaenge', 'Die Bemerkung bei '.$fehlername.' ist zu lang (max. 255 Zeichen)', 255);
                if(!isset($zeit['zwischenzeiten']) or !isset($daten[$zid]['zwischenzeiten'])){
                	continue;
                }
                $vorherige = 0;
                $erste = true;
                foreach($zeit['zwischenzeiten'] as $laenge => $zwzeit){
                	if(!isset($daten[$zid]['zwischenzeiten'][$laenge])){
                    	unset($_POST['daten'][$zid]['zwischenzeiten'][$laenge]);
                        continue;
                    }
                    $f .= pruefen($zeit['zwischenzeiten'][$laenge], 'schwimmzeit', 'Die '.$laenge.'m-Zeit bei '.$fehlername.' ist ungltig');
                    if($zeit['zwischenzeiten'][$laenge]<=$vorherige and $zeit['zwischenzeiten'][$laenge]>0 and !$erste){
                    	$f .= 'Die '.$laenge.'m-Zeit bei '.$fehlername.' muss grer sein als die voherigen Zeit(en)<br />';
                    }
                    $erste = false;
                    $vorherige = $zeit['zwischenzeiten'][$laenge];
                }
                $_POST['daten'][$zid] = $zeit;
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler', $f);
            	foreach($_POST['daten'] as $zid => $zeit){
                    $daten[$zid]['bemerkung'] = $zeit['bemerkung'];
                 	$daten[$zid]['zwischenzeiten'] = $zeit['zwischenzeiten'];
               }
            }
            else{
                $querys = array();
                foreach($_POST['daten'] as $zid => $row){
                	if($row['bemerkung'] != $daten[$zid]['bemerkung']){
                		$querys[] = "UPDATE ".DB_PREFIX."zeiten SET bemerkung = ".(empty($row['bemerkung'])?'NULL':"'".text_format($row['bemerkung'], 'db')."'")." WHERE id = ".$zid."";
                    }
                    if(!isset($row['zwischenzeiten'])){
                    	continue;
                    }
                    foreach($row['zwischenzeiten'] as $laenge => $zeit){
                    	$key = $zid.'_'.$laenge;
                        if(empty($zeit)){
                        	if(isset($zwzeiten[$key])){
                        		$querys[] = "DELETE FROM ".DB_PREFIX."zwischenzeiten WHERE zeitid = ".$zid." AND streckenlaenge = ".$laenge."";
                                $querys[] = "DELETE FROM ".DB_PREFIX."zeiten_rekorde WHERE zeitid = ".$zid." AND laenge = ".$laenge."";
                            }
                        }
                    	elseif(isset($zwzeiten[$key])){ # Update
                        	if($zeit != $zwzeiten[$key]['zeit']){
                        		$querys[] = "UPDATE ".DB_PREFIX."zwischenzeiten SET zeit = ".$zeit."".($zwzeiten[$key]['bestenliste']==1?", bestenliste = 0":'')." WHERE zeitid = ".$zid." AND streckenlaenge = ".$laenge."";
                            }
                        }
                        else{
                        	$querys[] = "INSERT INTO ".DB_PREFIX."zwischenzeiten SET zeitid = ".$zid.", streckenlaenge = ".$laenge.", zeit = ".$zeit.", bestenliste = 0";
                        }
                    }
                }
                foreach($querys as $q){
                	$_db->fuehreQueryAus($q);
                }
                weiterleiten('/wettkaempfe/abwickeln.html?aktion=zwischenzeiten-bemerkungen_speichern&bereich='.$_GET['bereich'], 'Die nderungen wurden gespeichert');
            }
        }

        # Daten zuweisen
        $_tmpl->assign('daten', $daten);
        $_tmpl->assign('_platzarten', $_platzarten);
        $_tmpl->assign('art', 'e');
        break;

    case 's': # Staffelstrecekn
    	# berschrift holen
        if(strlen($_GET['bereich'])!=2 or !isset($_lagen[$_GET['bereich'][1]])){
        	$_tmpl->assign('fehler', 'Die Staffeldisziplin ist ungltig.');
            break;
        }
        $titel = $_lagen[$_GET['bereich'][1]].'-Staffeln';
        $_tmpl->assign('titel', $titel);

    	# Bahnlnge holen
        $query = "SELECT bahnlaenge FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
        $_db->holeDaten($query);
        $bahnlaenge = $_db->holeWert();
        if(!in_array($bahnlaenge, array('25', '50'))){
        	$bahnlaenge = 25;
        }

        # Staffeln holen
        $query = "SELECT id, disziplin, anzahl, laenge, mw, gesamtzeit, platz, bemerkung, IF(ABS(platz)=0,1,0) as platzsort
                    FROM ".DB_PREFIX."staffeln
                    WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND disziplin = ".$_GET['bereich'][1]." AND (platz != 'NA' OR platz IS NULL)
                    ORDER BY laenge, anzahl, mw, platzsort, gesamtzeit";
        $_db->holeDaten($query);
        if($_db->holeAnzahl()<1){
        	$_tmpl->assign('fehler', 'Es wurden keine '.$_lagen[$_GET['bereich'][1]].'-Staffeln gefunden.');
            break;
        }
        $_staffeln = $_db->baueArray('*', 'id');

        $_zwischenzeiten = array();
        $j = 1;
        foreach($_staffeln as $key => $row){
        	$geslaenge = $row['laenge']*$row['anzahl'];
        	for($i=$bahnlaenge;$i<$geslaenge;$i+=$bahnlaenge){
            	if(!isset($_zwischenzeiten[$key])){
                	$_zwischenzeiten[$key] = array();
                }
            	if(!isset($_zwischenzeiten[$key][$i])){
                	$_zwischenzeiten[$key][$i] = array();
                }
                # zid ist immer vergeben (ID der Zeit)
                # nr ist die Nummer des Staffelschwimmers zu der die Zeit gehrt
                # laenge ist die Lnge der Zwischenzeit (nur gefllt wenn die Zeit aus den Zwischenzeiten kommt, sonst ist es die Endzeit des Schwimmers aus nr)
                # zeit ist immer vergeben (die Zeit selbst eben)
        	    $_zwischenzeiten[$key][$i] = array('zid'=>'','nr'=>ceil($i/$row['laenge']),'laenge'=>NULL,'zeit'=>'');
            }
            $_staffeln[$key]['tmpid'] = $j;
            $j++;
        }

        # Schwimmer/Zeiten holen
        $staffelids = array_keys($_staffeln);
        $query = "SELECT z.id as zid, z.zeit, z.bemerkung, m.vorname, m.nachname, YEAR(m.gebdatum) as jg, m.mw, z.streckenlaenge,
                      z.bestenliste, sz.schwimmernr, sz.schwimmernr*z.streckenlaenge as staffellaenge, sz.staffelid
                    FROM (".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
                      LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid=m.id
                    WHERE sz.staffelid IN (".implode(', ', $staffelids).")
                    ORDER BY sz.staffelid, sz.schwimmernr";
        $_db->holeDaten($query);
        $_zeiten = $_db->baueArray('*', 'zid');

        $zids = array();
        $plus = 0;
        foreach($_zeiten as $row){
        	$zids[] = $row['zid'];
            if($row['schwimmernr'] == 1){
                $_staffeln[$row['staffelid']]['_schwimmer'] = array();
                $_staffeln[$row['staffelid']]['_schwimmer'][$row['schwimmernr']] = $row;
                $plus = 0;
            }
            else{
            	if(!is_null($row['zeit'])){
            		$row['zeit'] += $_staffeln[$row['staffelid']]['_schwimmer'][$row['schwimmernr']-1]['zeit'];
                }
                $_staffeln[$row['staffelid']]['_schwimmer'][$row['schwimmernr']] = $row;
            }
            if($_staffeln[$row['staffelid']]['platz'] == 'DS' and is_null($row['zeit'])){
        		for($i=$row['staffellaenge']-$row['streckenlaenge'];isset($_zwischenzeiten[$row['staffelid']][$i]) or $i==0;$i+=$bahnlaenge){
                	unset($_zwischenzeiten[$row['staffelid']][$i]);
                }
            }
            if(!isset($_zwischenzeiten[$row['staffelid']][$row['staffellaenge']])){
            	continue;
            }
            $_zwischenzeiten[$row['staffelid']][$row['staffellaenge']]['zid'] = $row['zid'];
            $_zwischenzeiten[$row['staffelid']][$row['staffellaenge']]['laenge'] = false;
            $_zwischenzeiten[$row['staffelid']][$row['staffellaenge']]['zeit'] = $row['zeit'];
        }

        # Zwischenzeiten holen bzw. Array bauen
        $query = "SELECT zz.zeitid, zz.streckenlaenge, zz.zeit, zz.bestenliste, sz.staffelid, sz.schwimmernr,
                      ((sz.schwimmernr-1)*z.streckenlaenge)+zz.streckenlaenge as laenge
                    FROM (".DB_PREFIX."zwischenzeiten as zz LEFT JOIN ".DB_PREFIX."zeiten as z ON zz.zeitid=z.id)
                      LEFT JOIN ".DB_PREFIX."staffeln_zeiten sz ON sz.zeitid = z.id
                    WHERE zz.zeitid IN (".implode(', ', $zids).")";
        $_db->holeDaten($query);
        $_zwzeiten = array();
        #printr($_staffeln);exit;
        if($_db->holeAnzahl()>0){
        	$_zwzeiten = $_db->baueArray('*', '#');
            foreach($_zwzeiten as $row){
            	$_zwischenzeiten[$row['staffelid']][$row['laenge']]['zid'] = $row['zeitid'];
            	$_zwischenzeiten[$row['staffelid']][$row['laenge']]['laenge'] = $row['streckenlaenge'];
            	$_zwischenzeiten[$row['staffelid']][$row['laenge']]['zeit'] = $row['zeit'];
            }
        }

        foreach($_zwischenzeiten as $sid => $zeiten){
        	$plus = array();
            $anz = 0;
            $plus[0] = 0;
        	foreach($zeiten as $laenge => $row){
            	if(is_null($row['zeit']) or empty($row['zeit'])){
                	continue;
                }
                if($row['laenge'] === false){
                	$plus[$row['nr']] = $row['zeit'];
                }
                if($row['nr']>$anz){
                	$anz = $row['nr'];
                }
            }
            $plus[$anz] = $_staffeln[$sid]['gesamtzeit'];
        	foreach($zeiten as $laenge => $row){
            	if(is_null($row['zeit']) or empty($row['zeit'])){
                	continue;
                }
                if($row['laenge'] === false){
                	continue;
                }
                else{
                	if(isset($plus[$row['nr']-1]) and !is_null($plus[$row['nr']-1])){
                        $_zwischenzeiten[$sid][$laenge]['zeit'] += $plus[$row['nr']-1];
                    }
                	elseif(isset($plus[$row['nr']]) and !is_null($plus[$row['nr']])){
                    	$_zwischenzeiten[$sid][$laenge]['zeit'] = $plus[$row['nr']]-$row['zeit'];
                    }
                }
            }
        }

        foreach($_zwischenzeiten as $sid => $zeiten){
            $_staffeln[$sid]['zwischenzeiten'] = $zeiten;
        }

        # Formular verarbeiten
        if(isset($_POST['speichern'])){
            require_once('func/pruefen.inc.php');
            $f = '';

            foreach($_POST['daten'] as $sid => $row){
            	if(!isset($_staffeln[$sid])){
                	continue;
                }
                $fehlername = 'Staffel '.$_staffeln[$sid]['tmpid'];
            	$f .= pruefen($row['bemerkung']['staffel'], 'maxlaenge', 'Die Staffelbemerkung bei '.$fehlername.' ist zu lang (max. 255 Zeichen)', 255);
                for($i=1;isset($row['bemerkung'][$i]);$i++){
            		$f .= pruefen($row['bemerkung'][$i], 'maxlaenge', 'Die Bemerkung bei '.$fehlername.'/Schwimmer '.$i.' ist zu lang (max. 255 Zeichen)', 255);
                }
                if(!isset($row['zwischenzeiten']) or count($_staffeln[$sid]['zwischenzeiten'])<1){
                	continue;
                }
                $vorherige = 0;
                foreach($row['zwischenzeiten'] as $laenge => $zwzeit){
                	if(!isset($_staffeln[$sid]['zwischenzeiten'][$laenge])){
                    	unset($_POST['daten'][$sid]['zwischenzeiten'][$laenge]);
                        continue;
                    }
                    # Zeit korrekt?
                    $f .= pruefen($row['zwischenzeiten'][$laenge], 'schwimmzeit', 'Die '.$laenge.'m-Zeit bei '.$fehlername.' ist ungltig');
                    # Zeit grer als voherige Zeit?
                    if($row['zwischenzeiten'][$laenge]<=$vorherige and $row['zwischenzeiten'][$laenge]>0){
                    	$f .= 'Die '.$laenge.'m-Zeit bei '.$fehlername.' muss grer sein als die voherigen Zeiten<br />';
                    }
                    $vorherige = $row['zwischenzeiten'][$laenge];
                    # Endzeit des vorherigen Schwimmers enthalten? (sonst kann die Zeit des aktuellen Staffelschwimmers nicht ausgerechnet werden)
                    if(empty($zwzeit) or $_zwischenzeiten[$sid][$laenge]['nr'] == 1){
                    	continue;
                    }
                    $nr = $_zwischenzeiten[$sid][$laenge]['nr'];
                    $einzellaenge = $_staffeln[$sid]['laenge'];
                    if(empty($row['zwischenzeiten'][($nr-1)*$einzellaenge])){
                    	$f .= 'Bei der '.$fehlername.' fehlt fr die '.$laenge.'m-Zwischenzeit die '.(($nr-1)*$einzellaenge).'m Zwischenzeit<br />';
                    }
                }
                $_POST['daten'][$sid] = $row;
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler', $f);
            	foreach($_POST['daten'] as $sid => $row){
                    $_staffeln[$sid]['bemerkung'] = $row['bemerkung']['staffel'];
                	for($i=1;isset($row['bemerkung'][$i]);$i++){
            			$_staffeln[$sid]['_schwimmer'][$i]['bemerkung'] = $row['bemerkung'][$i];
                	}
                    if(!isset($_POST['daten'][$sid]['zwischenzeiten'])){
                    	continue;
                    }
                    foreach($_POST['daten'][$sid]['zwischenzeiten'] as $laenge => $zeit){
                 		$_staffeln[$sid]['zwischenzeiten'][$laenge]['zeit'] = $zeit;
                    }
               }
            }
            else{
                $querys = array();
                foreach($_POST['daten'] as $sid => $row){
                	if($row['bemerkung']['staffel'] != $_staffeln[$sid]['bemerkung']){
                		$querys[] = "UPDATE ".DB_PREFIX."staffeln SET bemerkung = ".(empty($row['bemerkung']['staffel'])?'NULL':"'".text_format($row['bemerkung']['staffel'], 'db')."'")."
                                       WHERE id = ".$sid."";
                    }
                	for($i=1;isset($row['bemerkung'][$i]);$i++){
                    	if($row['bemerkung'][$i] == $_staffeln[$sid]['_schwimmer'][$i]['bemerkung']){
                        	continue;
                        }
                		$querys[] = "UPDATE ".DB_PREFIX."zeiten SET bemerkung = ".(empty($row['bemerkung'][$i])?'NULL':"'".text_format($row['bemerkung'][$i], 'db')."'")."
                                       WHERE id = ".$_staffeln[$sid]['_schwimmer'][$i]['zid']."";
                	}

                    foreach($row['zwischenzeiten'] as $laenge => $zeit){
                        $dbzeit = $zeit;
                        if($_zwischenzeiten[$sid][$laenge]['nr']>1){
                        	$dbzeit -= $row['zwischenzeiten'][($_zwischenzeiten[$sid][$laenge]['nr']-1)*$_staffeln[$sid]['laenge']];
                        }
                        $dblaenge = $laenge;
                        if($_zwischenzeiten[$sid][$laenge]['nr']>1){
                        	$dblaenge -= ($_zwischenzeiten[$sid][$laenge]['nr']-1)*$_staffeln[$sid]['laenge'];
                        }
                        $tmplaenge = $_zwischenzeiten[$sid][$laenge]['nr']*$_staffeln[$sid]['laenge'];
                        if(!isset($_zwischenzeiten[$sid][$tmplaenge])){
                        	$zwzeitid = $_staffeln[$sid]['_schwimmer'][$_zwischenzeiten[$sid][$laenge]['nr']]['zid'];
                        }
                        else{
                        	$zwzeitid = $_zwischenzeiten[$sid][$tmplaenge]['zid'];
                        }
                        if(empty($zeit)){ # Zeit ist leer
                        	if(empty($_zwischenzeiten[$sid][$laenge])){ # Zeit war vorher auch leer
                        		continue;
                            }
                            if($_zwischenzeiten[$sid][$laenge]['laenge'] === false){ # Zeit ist die Endzeit eines Schwimmers
                            	if(!is_null($_zwischenzeiten[$sid][$laenge]['zeit'])){
                					$querys[] = "UPDATE ".DB_PREFIX."zeiten SET zeit = NULL WHERE id = ".$_zwischenzeiten[$sid][$laenge]['zid']."";
                                }
                            }
                            elseif(!is_null($_zwischenzeiten[$sid][$laenge]['laenge'])){ # Zeit ist eine Zwischenzeit
                        		$querys[] = "DELETE FROM ".DB_PREFIX."zwischenzeiten
                                               WHERE zeitid = ".$_zwischenzeiten[$sid][$laenge]['zid']." AND streckenlaenge = ".$_zwischenzeiten[$sid][$laenge]['laenge']."";
                                if($_zwischenzeiten[$sid][$laenge]['nr']==1){
                                	$querys[] = "DELETE FROM ".DB_PREFIX."zeiten_rekorde
                                	               WHERE zeitid = ".$_zwischenzeiten[$sid][$laenge]['zid']." AND laenge = ".$_zwischenzeiten[$sid][$laenge]['laenge']."";
                                }
                            }
                        }
                    	elseif(empty($_zwischenzeiten[$sid][$laenge]['zeit']) or is_null($_zwischenzeiten[$sid][$laenge]['zeit'])){ # Zeit existiert bisher nicht -> einfgen
                            if($_zwischenzeiten[$sid][$laenge]['laenge'] === false){ # Zeit ist die Endzeit eines Schwimmers
                				$querys[] = "UPDATE ".DB_PREFIX."zeiten SET zeit = ".$dbzeit."".($_zwischenzeiten[$sid][$laenge]['nr']==1?', bestenliste = 0':'')."
                                               WHERE id = ".$_zwischenzeiten[$sid][$laenge]['zid']."";
                            }
                            else{ # Zeit ist eine Zwischenzeit
                        		$querys[] = "INSERT INTO ".DB_PREFIX."zwischenzeiten
                                               SET zeitid = ".$zwzeitid.", streckenlaenge = ".$dblaenge.", zeit = ".$dbzeit.", bestenliste = 0";
                            }
                        }
                        else{ # Zeit existiert schon
                            if($_zwischenzeiten[$sid][$laenge]['laenge'] === false){ # Zeit ist die Endzeit eines Schwimmers
                            	if($zeit != $_zwischenzeiten[$sid][$laenge]['zeit']){
                					$querys[] = "UPDATE ".DB_PREFIX."zeiten SET zeit = ".$dbzeit."".($_zwischenzeiten[$sid][$laenge]['nr']==1?', bestenliste = 0':'')."
                                	               WHERE id = ".$_zwischenzeiten[$sid][$laenge]['zid']."";
                                }
                            }
                            else{
                            	if($zeit != $_zwischenzeiten[$sid][$laenge]['zeit']){
                        			$querys[] = "UPDATE ".DB_PREFIX."zwischenzeiten SET zeit = ".$dbzeit." WHERE zeitid = ".$zwzeitid."";
                                }
                            }
                        }
                    }
                }
                foreach($querys as $q){
                	$_db->fuehreQueryAus($q);
                }
                weiterleiten('/wettkaempfe/abwickeln.html?aktion=zwischenzeiten-bemerkungen_speichern&bereich='.$_GET['bereich'], 'Die nderungen wurden gespeichert');
            }
        }

        $_tmpl->assign('staffeln', $_staffeln);
        $_tmpl->assign('_platzarten', $_platzarten);
        $_tmpl->assign('_lagen', $_lagen);
        $_tmpl->assign('_geschlechter', $_geschlechter);
        $_tmpl->assign('art', 's');
    	break;

    case 't': # Teilnehmer

    	# berschrift setzen
        $_tmpl->assign('titel', 'Teilnehmerbemerkungen');


        $query = "SELECT mt.id as tid, m.id as mid, kommentar, vorname, nachname, YEAR(gebdatum) as jg, m.mw, mt.teilnahme
                    FROM ".DB_PREFIX."meldungen_teilnehmer as mt LEFT JOIN ".DB_PREFIX."mitglieder as m ON mt.mid = m.id
                    WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']."
                    ORDER BY nachname, vorname";
        $_db->holeDaten($query);
        $teilnehmer = $_db->baueArray('*', 'tid');
        $mid2tid = $_db->baueArray('tid', 'mid');
        foreach($teilnehmer as $tid => $row){
        	$row['_na'] = 0;
        	$row['_ab'] = 0;
        	$row['_au'] = 0;
        	$row['_ds'] = 0;
        	$row['_zeit'] = 0;
        	$row['_staffel'] = 0;
            $teilnehmer[$tid] = $row;
        }

        # Zeiten holen
        if($_db->holeAnzahl()>0){
        	$query = "SELECT z.platz, z.mitgliedid, sz.staffelid
                        FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid
                        WHERE mitgliedid IN (".implode(', ', array_keys($mid2tid)).") AND z.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."";
        	$_db->holeDaten($query);
        	$zeiten = $_db->baueArray('*', '#');

            foreach($zeiten as $row){
            	if($row['platz'] == 'DS'){
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_ds']++;
                }
            	elseif($row['platz'] == 'AB'){
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_ab']++;
                }
            	elseif($row['platz'] == 'AU'){
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_au']++;
                }
            	elseif($row['platz'] == 'NA'){
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_na']++;
                }
                elseif(!is_null($row['staffelid'])){
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_staffel']++;
                }
                else{
                	$teilnehmer[$mid2tid[$row['mitgliedid']]]['_zeit']++;
                }
            }
        }

        foreach($teilnehmer as $tid => $row){
            $tmp = array();
            if($row['_zeit']>0){
            	$tmp[] = $row['_zeit'].' Zeit'.($row['_zeit']>1?'en':'');
            }
            if($row['_staffel']>0){
            	$tmp[] = $row['_staffel'].' Staffel'.($row['_staffel']>1?'n':'');
            }
            if($row['_ds']>0){
            	$tmp[] = $row['_ds'].'*<abbr title="disqualifiziert">DS</abbr>';
            }
            if($row['_na']>0){
            	$tmp[] = $row['_na'].'*<abbr title="nicht am Start">NA</abbr>';
            }
            if($row['_ab']>0){
            	$tmp[] = $row['_ab'].'*<abbr title="abgemeldet">AB</abbr>';
            }
            if($row['_au']>0){
            	$tmp[] = $row['_au'].'*<abbr title="aufgegeben">AU</abbr>';
            }
            $teilnehmer[$tid]['zusammenfassung'] = count($tmp)>0?implode(', ', $tmp):'-';
        }

        if(isset($_POST['speichern'])){
            require_once('func/pruefen.inc.php');
            $f = '';
            foreach($_POST['bemerkung'] as $tid => $bemerkung){
            	if(!isset($teilnehmer[$tid])){
                	unset($_POST['bemerkung'][$tid]);
                    continue;
                }
            	$f .= pruefen($bemerkung, 'maxlaenge', 'Die Bemerkung von '.text_format($teilnehmer[$tid]['vorname'].' '.$teilnehmer[$tid]['nachname'], 'html').' ist zu lang (max. 200 Zeichen)', 200);
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler', $f);
            	foreach($_POST['bemerkung'] as $tid => $bemerkung){
                    $teilnehmer[$tid]['kommentar'] = $bemerkung;
               }
            }
            else{
            	foreach($_POST['bemerkung'] as $tid => $bemerkung){
                	if($bemerkung == $teilnehmer[$tid]['kommentar']){
                    	continue;
                    }
                    $query = "UPDATE ".DB_PREFIX."meldungen_teilnehmer SET kommentar = '".text_format($bemerkung, 'db')."' WHERE id = ".$tid."";
                    $_db->fuehreQueryAus($query);
            	}
                weiterleiten('/wettkaempfe/abwickeln.html?aktion=zwischenzeiten-bemerkungen_speichern&bereich='.$_GET['bereich'], 'Die nderungen wurden gespeichert');
            }
        }
        $_tmpl->assign('zusage', $_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1);
        $_tmpl->assign('teilnehmer', $teilnehmer);
        $_tmpl->assign('art', 't');
    	break;

    case 'o': # sonstige Starts
    	# berschrift setzen
        $_tmpl->assign('titel', 'Starts ohne Meldung in tkswim');

    	# Bahnlnge holen
        $query = "SELECT bahnlaenge FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
        $_db->holeDaten($query);
        $bahnlaenge = $_db->holeWert();
        if(!in_array($bahnlaenge, array('25', '50'))){
        	$bahnlaenge = 25;
        }

        $query = "SELECT z.id as zid, m.id as mid, z.zeit, z.platz, z.bemerkung, z.disziplin, z.streckenlaenge, z.zeit, ms.*,
                      m.vorname, m.nachname, YEAR(m.gebdatum) as jg
                    FROM (((".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid)
                      LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON z.id=ms.zeitid)
                      LEFT JOIN ".DB_PREFIX."wks as w ON ms.wkid = w.id)
                      LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid = m.id
                    WHERE z.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND sz.staffelid IS NULL AND ms.zeitid IS NULL AND (z.platz != 'NA' OR z.platz IS NULL)
                    ORDER BY z.disziplin, z.streckenlaenge, z.zeit";
        $_db->holeDaten($query);
        $daten = $_db->baueArray('*', 'zid');

        # Zwischenzeiten holen bzw. Array bauen
        if(count($daten)>0){
        	$query = "SELECT zeitid, streckenlaenge, zeit, bestenliste, CONCAT(zeitid,'_',streckenlaenge) as schluessel
                        FROM ".DB_PREFIX."zwischenzeiten WHERE zeitid IN (".implode(', ', array_keys($daten)).")";
        	$_db->holeDaten($query);
        	$zwzeiten = $_db->baueArray('*', 'schluessel');
            foreach($daten as $zid => $row){
            	$row['zwischenzeiten'] = array();
                for($i=$bahnlaenge;$i<$row['streckenlaenge'];$i+=$bahnlaenge){
                	$row['zwischenzeiten'][$i] = '';
                    if(isset($zwzeiten[$row['zid'].'_'.$i])){
                		$row['zwischenzeiten'][$i] = $zwzeiten[$row['zid'].'_'.$i]['zeit'];
                    }
                }
                $daten[$zid] = $row;
            }
        }

        # Formular verarbeiten
        if(isset($_POST['speichern'])){
            require_once('func/pruefen.inc.php');
            $f = '';
            foreach($_POST['daten'] as $zid => $zeit){
            	if(!isset($daten[$zid])){
                	continue;
                }
                $fehlername = text_format($daten[$zid]['vorname'].' '.$daten[$zid]['nachname'], 'html').' ('.$daten[$zid]['streckenlaenge'].'m '.$_lagen[$daten[$zid]['disziplin']].')';
            	$f .= pruefen($zeit['bemerkung'], 'maxlaenge', 'Die Bemerkung bei '.$fehlername.' ist zu lang (max. 255 Zeichen)', 255);
                if(!isset($zeit['zwischenzeiten']) or !isset($daten[$zid]['zwischenzeiten'])){
                	continue;
                }
                $vorherige = 0;
                $erste = true;
                foreach($zeit['zwischenzeiten'] as $laenge => $zwzeit){
                	if(!isset($daten[$zid]['zwischenzeiten'][$laenge])){
                    	unset($_POST['daten'][$zid]['zwischenzeiten'][$laenge]);
                        continue;
                    }
                    $f .= pruefen($zeit['zwischenzeiten'][$laenge], 'schwimmzeit', 'Die '.$laenge.'m-Zeit bei '.$fehlername.' ist ungltig');
                    if($zeit['zwischenzeiten'][$laenge]<=$vorherige and $zeit['zwischenzeiten'][$laenge]>0 and !$erste){
                    	$f .= 'Die '.$laenge.'m-Zeit bei '.$fehlername.' muss grer sein als die voherigen Zeit(en)<br />';
                    }
                    $erste = false;
                    $vorherige = $zeit['zwischenzeiten'][$laenge];
                }
                $_POST['daten'][$zid] = $zeit;
            }
            if(!empty($f)){
            	$_tmpl->assign('fehler', $f);
            	foreach($_POST['daten'] as $zid => $zeit){
                    $daten[$zid]['bemerkung'] = $zeit['bemerkung'];
                 	$daten[$zid]['zwischenzeiten'] = $zeit['zwischenzeiten'];
               }
            }
            else{
                $querys = array();
                foreach($_POST['daten'] as $zid => $row){
                	if($row['bemerkung'] != $daten[$zid]['bemerkung']){
                		$querys[] = "UPDATE ".DB_PREFIX."zeiten SET bemerkung = ".(empty($row['bemerkung'])?'NULL':"'".text_format($row['bemerkung'], 'db')."'")." WHERE id = ".$zid."";
                    }

                    foreach($row['zwischenzeiten'] as $laenge => $zeit){
                    	$key = $zid.'_'.$laenge;
                        if(empty($zeit)){
                        	if(isset($zwzeiten[$key])){
                        		$querys[] = "DELETE FROM ".DB_PREFIX."zwischenzeiten WHERE zeitid = ".$zid." AND streckenlaenge = ".$laenge."";
                                $querys[] = "DELETE FROM ".DB_PREFIX."zeiten_rekorde WHERE zeitid = ".$zid." AND laenge = ".$laenge."";
                            }
                        }
                    	elseif(isset($zwzeiten[$key])){ # Update
                        	if($zeit != $zwzeiten[$key]['zeit']){
                        		$querys[] = "UPDATE ".DB_PREFIX."zwischenzeiten SET zeit = ".$zeit."".($zwzeiten[$key]['bestenliste']==1?", bestenliste = 0":'')."
                                               WHERE zeitid = ".$zid." AND streckenlaenge = ".$laenge."";
                            }
                        }
                        else{
                        	$querys[] = "INSERT INTO ".DB_PREFIX."zwischenzeiten SET zeitid = ".$zid.", streckenlaenge = ".$laenge.", zeit = ".$zeit.", bestenliste = 0";
                        }
                    }
                }
                foreach($querys as $q){
                	$_db->fuehreQueryAus($q);
                }
                weiterleiten('/wettkaempfe/abwickeln.html?aktion=zwischenzeiten-bemerkungen_speichern&bereich='.$_GET['bereich'], 'Die nderungen wurden gespeichert');
            }
        }

        # Daten zuweisen
        $_tmpl->assign('daten', $daten);
        $_tmpl->assign('_platzarten', $_platzarten);
        $_tmpl->assign('_lagen', $_lagen);
        $_tmpl->assign('art', 'o');
        break;
    }
    $_inh .= $_tmpl->fetch('wettkaempfe/42.zwischenzeiten-bemerkungen_formular.inc.html');
}

# EOF
?>