<?php
# Funktion entfernen
function holeInterpolierteZeitFuerMitglied($mid,$strecke,$lage,$maxalter = ''){
	if(empty($maxalter)){
    	$maxalter = 36;
    }
	global $_db,$_einst;
	$query = "SELECT id, streckenlaenge, DATE_FORMAT(datum,'%d.%m.%Y') as datum, zeit
                FROM ".DB_PREFIX."zeiten
                WHERE
                  mitgliedid = ".$mid." AND
                  disziplin = ".$lage." AND
                  DATE_ADD(datum, INTERVAL ".$maxalter." MONTH) >= NOW() AND
                  wettkampfid > 5
                ORDER BY ".DB_PREFIX."zeiten.datum DESC";
    $_db->holeDaten($query);
    if($_db->ergebnis['anzahl'] == 0){
    	return false;
    }
    $zeiten = $_db->ergebnis['daten'];
    $moeglichkeiten = array(
        25   => array(50),
        50   => array(25,100,200),
        100  => array(50,200,400),
        200  => array(50,100,400,800,1500),
        400  => array(100,200,800,1500),
        800  => array(200,400,1500),
        1500 => array(200,400,800)
    );
    foreach($zeiten as $key => $z){
        if(!in_array($z['streckenlaenge'],$moeglichkeiten[$strecke])){ # untauglicher Zeiten entfernen
            unset($zeiten[$key]);
            continue;
        }
    }
    if(count($zeiten) == 0){
        return false;
    }
    $tmp = array();
    foreach($zeiten as $row){
        $tmp[] = $row;
    }
    $zeiten = $tmp;
    $zeit = $zeiten[0];
    $a_zeit   = $zeit['zeit'];
    $a_laenge = $zeit['streckenlaenge'];
    $z_laenge = $strecke;
    $richtung = $a_laenge>$z_laenge?'runter':'hoch';
    $faktor = $_gleinst['wettkaempfe_abwickeln']['interplationsfaktor'.$richtung];
    $q = $z_laenge/$a_laenge;
    $faktor = pow($faktor,abs(log($q,2)))*$q;
    $z_zeit = round($faktor*$a_zeit,0);
    return array(
        'zeit' => $z_zeit,
        'datum' => $zeit['datum'],
        'vonstrecke' => $zeit['streckenlaenge']
    );
} # Ende der Funktion, EOF
?>