<?php
function holeTrainingsgruppen($kommentar=false){
	global $_db, $_wochentage;
    $trainingsgruppen = array();
    if($kommentar === 'kurz'){
        $query = "SELECT id, wochentag, TIME_FORMAT(anfangszeit,'%H:%i') as zeit
                    FROM ".DB_PREFIX."trainingsgruppen ORDER BY wochentag,anfangszeit";
        $_db->holeDaten($query);
        foreach($_db->ergebnis['daten'] as $row){
            $trainingsgruppen[$row['id']] = substr($_wochentage[$row['wochentag']],0,2).$row['zeit'];
        }
    }
    else{
        $query = "SELECT id, wochentag, kommentar,
                      CONCAT(TIME_FORMAT(anfangszeit,'%H:%i'),'-',TIME_FORMAT(endzeit,'%H:%i')) as zeit
                    FROM ".DB_PREFIX."trainingsgruppen ORDER BY wochentag,anfangszeit";
        $_db->holeDaten($query);
        foreach($_db->ergebnis['daten'] as $row){
            $trainingsgruppen[$row['id']] = $_wochentage[$row['wochentag']].' '.$row['zeit'].(($kommentar and !empty($row['kommentar']))?' - '.$row['kommentar']:'');
        }
    }
    $_db->leereErgebnis();
    return $trainingsgruppen;
}
// EOF
?>