<?php
function mitglieder_rechtegruppensetzen($mid){
	global $_db;
	# Ist das Mitglied freigeschaltet, bzw. ausgetreten? (gleichzeitig Pruefung ob Mitglied existiert)
    $query = "SELECT m.id, l.freigeschaltet, m.ausgetreten
                FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
                WHERE m.id = '".text_format($mid,'db')."'";
    $_db->holeDaten($query);
    if($_db->holeAnzahl() != 1){
    	return false;
    }
    $row = $_db->holeZeile();
    $flags = array(
    	'freigeschaltet' => $row['freigeschaltet']==1?true:false,
        'ausgetreten'    => !is_null($row['ausgetreten'])
    );
    # ausgetretene oder freigeschaltete werden alle Rechte entzogen
    if($flags['ausgetreten'] or !$flags['freigeschaltet']){
    	$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid."";
        $_db->fuehreQueryAus($query);
        return true;
    }

    # zu setzende Rechtegruppenzuordungen suchen
    $zusetzen = array(3); # 3=alle Mitglieder
      # vorhandene Rechtegruppenzuordungen suchen
    $query = "SELECT DISTINCT rechtegrid FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid NOT IN (2,3,4,5)";
    $_db->holeDaten($query);
    if($_db->holeAnzahl() != 0){
    	foreach($_db->baueArray('rechtegrid','#') as $rgid){
    		$zusetzen[] = $rgid;
        }
    }
      # Vorstand?
    $query = "SELECT id FROM ".DB_PREFIX."vorstand WHERE mitgliedid = ".$mid." and sort < 100";
    $_db->holeDaten($query);
    if($_db->holeAnzahl() > 0){
    	$zusetzen[] = 4; # 4=Vorstand
    }
      # Uebungsleiter?
    $query = "SELECT u.id FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."trainingsgruppen_uebungsleiter as tu ON u.id=tu.uebungsleiterid
                WHERE mitgliedid = ".$mid." AND trainingsgruppenid IS NOT NULL";
    $_db->holeDaten($query);
    if($_db->holeAnzahl() > 0){
    	$zusetzen[] = 2; #2=Uebungsleiter
    }

    # alle Zuordungen loeschen und gewuenschte neu setzen
    $zusetzen = array_unique($zusetzen);
      # pruefen ob sich die zu setzenden Rechtegruppen gegenber den gesetzten gendert haben
    $query = "SELECT DISTINCT rechtegrid FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid."";
    $_db->holeDaten($query);
    $vorhandene = $_db->baueArray('rechtegrid','#');
    sort($vorhandene);
    $vorhandene = implode('_', $vorhandene);
    sort($zusetzen);
    $zusetzen_str = implode('_', $zusetzen);
    if($vorhandene == $zusetzen_str){ # die Gruppen haben sich nicht gendert -> nichts ndern und abbrechen
		return true;
    }
      # alte Gruppen lschen und neue setzen
    $query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid."";
    $_db->fuehreQueryAus($query);
    $rg = array();
    foreach($zusetzen as $z){
    	$rg[] = '('.$mid.', '.$z.')';
    }
    $query = "INSERT INTO ".DB_PREFIX."rechtegruppen_mitglieder (mitgliedid,rechtegrid) VALUES ".implode(', ',$rg)."";
    $_db->fuehreQueryAus($query);
    return true;
}
# EOF
?>