<?php
function parseChangelog($datei, $von = false, $bis = false){
	global $_monate;
	$daten = file($datei);
    $daten = array_map('rtrim',$daten);
    $ergebnis = array();
    $version = array('_eintraege'=>array());
    $eintrag = '';
    $aktuell_h = -1;
    $aktuell_u = -1;
    foreach($daten as $row){
    	if(substr($row,0,7) == 'Version'){
            list($v,$d) = explode(',',substr($row,8));
        	if(count($version['_eintraege']) > 0){
        		$ergebnis[] = $version;
            }
    		$aktuell_h = -1;
    		$aktuell_u = -1;
            $version = array(
            	'version' => $v,
                'datum'   => trim($d),
                'filter'  => trim($d),
                '_eintraege' => array()
            );
            list($jahr,$monat,$tag) = explode('-',$version['datum']);
            $version['filter'] = $version['datum'];
            $version['datum'] = (int)$tag.'. '.$_monate[(int)$monat].' '.$jahr;
            continue;
        }
        $row = text_format($row,'htmlmaskieren');
        if(substr($row,0,5) == '    -'){
        	$aktuell_h++;
        	$version['_eintraege'][$aktuell_h] = array(
            	'eintrag' => substr($row,6),
                '_eintraege' => array()
            );
        }
        elseif(substr($row,0,9) == '        -'){
        	$aktuell_u++;
        	$version['_eintraege'][$aktuell_h]['_eintraege'][$aktuell_u] = substr($row,10);
        }
        elseif(substr($row,0,12) == '            '){
        	$version['_eintraege'][$aktuell_h]['_eintraege'][$aktuell_u] .= substr($row,11);
        }
        elseif(substr($row,0,8) == '        '){
        	$version['_eintraege'][$aktuell_h]['eintrag'] .= substr($row,7);
        }
    }
    $ergebnis[] = $version;

    # ggf. Ausgabe nach Datum filtern
    foreach($ergebnis as $key => $row){
    	if($von !== false and $row['filter'] < $von){
        	unset($ergebnis[$key]);
        }
    	if($bis !== false and $row['filter'] > $bis){
        	unset($ergebnis[$key]);
        }
    }
    return $ergebnis;
}
# EOF
?>