<?php

function parseSonstigesFeld($daten,$feld='',$doppeltealsarray=false){
	if(empty($daten)){
		return array();
    }
	$teile = preg_split("~((?:\015\012)|\015|\012){3,}~",$daten);
    $rueckgabe = array();
    for($i=0;$i<=count($teile)-1;$i++){
    	if(empty($teile[$i])){
        	continue;
        }
        $anz = preg_match('~^([a-z]+):\s*(.*)$~s',$teile[$i],$match);
        if($anz == 1){
        	if(!isset($rueckgabe[$match[1]])){
            	$rueckgabe[$match[1]] = $match[2];
            }
            elseif($doppeltealsarray){
            	$tmp = $rueckgabe[$match[1]];
                $rueckgabe[$match[1]] = array($tmp);
                $rueckgabe[$match[1]][] = $match[2];
            }
            else{
				$rueckgabe[$match[1]] .= "\n\n".$match[2];
            }
        }
        else{
        	if(!isset($rueckgabe['_default'])){
            	$rueckgabe['_default'] = $teile[$i];
            }
            elseif($doppeltealsarray){
            	$tmp = $rueckgabe['_default'];
                $rueckgabe['_default'] = array($tmp);
                $rueckgabe['_default'][] = $teile[$i];
            }
            else{
            	$rueckgabe['_default'] .= "\n\n".$teile[$i];
            }
        }
    }
    if(!isset($rueckgabe['_default'])){
    	$rueckgabe['_default'] = '';
    }
    foreach($rueckgabe as $key => $value){
    	if(is_array($value)){
    	    $rueckgabe[$key] = array_map('trim',$value);
    	}
        else{
        	$rueckgabe[$key] = trim($value);
        }
    }
    if(empty($rueckgabe['_default'])){
		unset($rueckgabe['_default']);
    }
	if(!empty($feld)){
		if(isset($rueckgabe[$feld])){
        	return $rueckgabe[$feld];
        }
        else{
        	return '';
        }
    }
    return $rueckgabe;
}
?>