<?php
/*
prft ob fr den angemeldeten User der Zugriff erlaubt ist oder nicht
(liefert true oder false zurck)

Parameter:
  die Funktion erwartet beliebig viele Parameter - wenn der User auf mindestens
  einen Zugreifen darf, liefert die Funktion true; erlaubt ist auch z.B. e_*,
  in dem Fall liefert die Funktion true wenn der User ein beliebiges Recht das
  mit e_ anfngt hat.
*/
function pruefeRechte(){
    if(!isset($_SESSION['user']['rechte'])){
        return false;
    }
    $rechte = func_get_args();
    foreach($rechte as $r){
    	if(in_array($r,$_SESSION['user']['rechte'])){
        	return true;
        }
    }
    foreach($rechte as $r){
    	if(substr($r,-1) != '*'){
        	continue;
        }
        $bereich = substr($r,0,-1);
        foreach($_SESSION['user']['rechte'] as $re){
        	if(substr($re,0,strlen($bereich)) == $bereich){
            	return true;
            }
        }
    }
    return false;
}
# EOF
?>