/*
Quelle: http://www.robertnyman.com/2005/11/07/the-ultimate-getelementsbyclassname/

 To get all a elements in the document with a "info-links" class.
  getElementsByClassName(document, "a", "info-links");

 To get all div elements within the element named "container", with a "col" and a "left" class.
  getElementsByClassName(document.getElementById("container"), "div", ["col", "left"]);
*/
function getElementsByClassName(oElm, strTagName, oClassNames){
    var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
    var arrReturnElements = new Array();
    var arrRegExpClassNames = new Array();
    if(typeof oClassNames == "object"){
        for(var i=0; i<oClassNames.length; i++){
            arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames[i].replace(/\-/g, "\\-") + "(\\s|$)"));
        }
    }
    else{
        arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames.replace(/\-/g, "\\-") + "(\\s|$)"));
    }
    var oElement;
    var bMatchesAll;
    for(var j=0; j<arrElements.length; j++){
        oElement = arrElements[j];
        bMatchesAll = true;
        for(var k=0; k<arrRegExpClassNames.length; k++){
            if(!arrRegExpClassNames[k].test(oElement.className)){
                bMatchesAll = false;
                break;
            }
        }
        if(bMatchesAll){
            arrReturnElements.push(oElement);
        }
    }
    return (arrReturnElements)
}

function ajax_verfuegbar(){
  new Ajax.Request(ajaxdatei,
  {
   method    : 'post',
   postBody  : 'mimeType=text/xml&aktion=online',
   onSuccess : function(){
     var a = getElementsByClassName(document, "a", "ajaxlink");
     if(a.length > 0){
       for(var i=a.length-1;i>=0;i--){
         a[i].style.display = 'inline';
       }
     }
     var span = getElementsByClassName(document, "span", "ajaxlink");
     if(span.length > 0){
       for(var i=span.length-1;i>=0;i--){
         span[i].style.display = 'inline';
       }
     }
   }
  });
}

function js_verfuegbar(){
  var a = getElementsByClassName(document, "a", "jslink");
  if(a.length > 0){
    for(var i=a.length-1;i>=0;i--){
      a[i].style.display = 'inline';
    }
  }
  var span = getElementsByClassName(document, "span", "jslink");
  if(span.length > 0){
    for(var i=span.length-1;i>=0;i--){
      span[i].style.display = 'inline';
    }
  }
}