var profile = new Array( // Definiert die moegelichen Profile
  'Adressen-PDF',                     // Adressenexport
  'Daten fr Erstregistrierung',      // Adressenexport
  'DMS-J',                            // Export - trainierende Mitglieder
  'Goldsprinterpokal Schwabach',      // Export - Zeiten - besteschwimmer
  'Zenngrundpokal Langenzenn',        // Export - Zeiten - besteschwimmer
  'Standardlisten (Einzel- und Staffelstrecken)', // Hall of Fame - Standardlisten
  'Standardlisten (Einzelstrecken)',  // Hall of Fame - Standardlisten (Einzel)
  'Standardlisten (Staffelstrecken)', // Hall of Fame - Standardlisten (Staffel)
  'alle Strecken',                    // Hall of Fame - alle Strecken
  'nderungen nach letztem Wettkampf (Einzelstrecken)' // Hall of Fame - Aenderungen nach letztem Wettkampf
);

var optionen = new Array(
/*
 Dieses Array enthaelt die Optionen die jeweils gesetzt werden muessen, dabei
 ist jedes Element wieder ein Array das wiederrum folgende Arrays enthalt:
  0: Namen der Checkboxen die markiert werden sollen
  1: Namen der Checkboxen die demarkiert werden sollen
  2: Namen der Radiobuttons (in der Form 'key_name', wobei key die Nummer es
       auszuwaehlenden Radiobuttons ist)
  3: Namen der Selectfelder die markiert werden sollen (in der Form 'key_name',
       wobei key die Nummer des zu markierenden Eintrages ist, wenn key mit
       "value:" anfngt werden die nachfolgenden Werte als Wert der value-
       Eigenschaft interpretiert, auerdem koennen bei key dann auch Bereiche
       (z.B. 1-4) und mehrere Werte (z.B. wert1,wert2,wert3) angegeben werden)
  4: Die IDs mit denen die Funktion wahl() aufgerufen werden soll
  5: Namen der text-felder die gesetzt werden sollen (in der Form 'name|wert',
       wobei bei wert=standardwert das Feld den Wert von defaultValue zugewiesen
       bekommt)
*/
  new Array( // Adressen-PDF (0)
    new Array('felder[name]','felder[telefon]','felder[gebdatum]','felder[strasse]','felder[ort]','sonstiges[pdferzeugen]',
      'optionen[pdf][datum]', 'optionen[pdf][seitenzahlen]'),
    new Array('felder[id]','felder[mw]','felder[eingetreten]','felder[ausgetreten]','felder[email]','felder[dsvid]',
      'sonstiges[strhausnrgetrennt]', 'sonstiges[ortplzgetrennt]'),
    new Array('0_optionen[name][langkurz]'),
    new Array('2_optionen[name][reihenfolge]','0_optionen[gebdatum][format]','1_sonstiges[welchemitglieder]','value:eineart_optionen[telefon][welche]',
      '0_optionen[telefon][art]'),
    new Array('f_name','f_gebdatum','f_telefon','s_pdferzeugen','o_pdf_seitenzahlen'),
    new Array('optionen[pdf][ueberschrift]|standardwert','optionen[pdf][seitenzahlformat]|standardwert')
  ),
  new Array( // Erstregistrierung (1)
    new Array('felder[name]','felder[gebdatum]','felder[mw]','felder[strasse]','felder[ort]','felder[dsvid]'),
    new Array('felder[id]','felder[eingetreten]','felder[telefon]','felder[ausgetreten]','felder[email]','sonstiges[strhausnrgetrennt]',
      'sonstiges[ortplzgetrennt]','sonstiges[pdferzeugen]'),
    new Array('0_optionen[name][langkurz]'),
    new Array('2_optionen[name][reihenfolge]','0_optionen[gebdatum][format]','0_sonstiges[welchemitglieder]'),
    new Array('f_name','f_gebdatum','f_telefon','s_pdferzeugen'),
    ''
  ),
  new Array( // DMS-J (2)
    '',
    '',
    '',
    new Array('value:1-15_filter[trainingsgruppen][]', 'value:ja,jb,jc,jd_filter[altersklassen][]','0_gruppierung'),
    '',
    new Array('filter[wettkampfjahr]|standardwert','filter[jahrgaenge]|')
  ),
  new Array( // Schwabacher Goldsprinterpokal (3)
    new Array('optionen[interpolieren]','optionen[trainierender]'),
    '',
    new Array('0_lagenart','0_lagenmehrere[geschlecht][]','1_lagenmehrere[geschlecht][]'),
    new Array('value:1-4_lagenmehrere[lage][]','value:50_lagenmehrere[strecke][]','-1_lagenmehrere[altersklasse][]','value:laengedisziplin_optionen[m_gruppierung]','value:mw_optionen[m_sort][1]','value:jahrgak_optionen[m_sort][2]','value:zeit_optionen[m_sort][3]'),
    new Array('lagen'),
    new Array('optionen[anzahlschwimmer]|10','lagenmehrere[jahrgang]|1987+,1988-1989,1990,1991,1992,1993,1994,1995,1996,1997,1998,1999')
  ),
  new Array( // Zenngrundpokal Langenzenn (4)
    new Array('optionen[interpolieren]','optionen[interpoliertebevorzugen]','optionen[trainierender]'),
    '',
    new Array('0_lagenart','0_lagenmehrere[geschlecht][]','1_lagenmehrere[geschlecht][]'),
    new Array('value:1-3_lagenmehrere[lage][]','value:50_lagenmehrere[strecke][]','value:je,jd_lagenmehrere[altersklasse][]'),
    new Array('lagen'),
    new Array('optionen[anzahlschwimmer]|7','lagenmehrere[jahrgang]|')
  ),
  new Array( // Hall of Fame - Standardlisten (5)
    new Array('strecken[50f_offen]','strecken[50f_11jahre]','strecken[50b_offen]','strecken[50b_11jahre]','strecken[50r_offen]','strecken[50r_11jahre]','strecken[50s_offen]','strecken[50s_11jahre]','strecken[100f]','strecken[100b]','strecken[100r]','strecken[100s]','strecken[100l]','strecken[200f]','strecken[200b]','strecken[200l]','strecken[4x50f]','strecken[4x50b]','strecken[4x50r]','strecken[4x50s]','strecken[4x50l]','strecken[4x100f]','strecken[4x100b]','strecken[4x100r]','strecken[4x100s]','strecken[4x100l]','optionen[mixedstaffeln]'),
    new Array('strecken[200r]','strecken[200s]','strecken[400f]','strecken[400l]','strecken[800f]','strecken[1500f]'),
    new Array('0_optionen[stand]'),
    '',
    '',
    ''
  ),
  new Array( // Hall of Fame - Standardlisten (Einzel) (6)
    new Array('strecken[50f_offen]','strecken[50f_11jahre]','strecken[50b_offen]','strecken[50b_11jahre]','strecken[50r_offen]','strecken[50r_11jahre]','strecken[50s_offen]','strecken[50s_11jahre]','strecken[100f]','strecken[100b]','strecken[100r]','strecken[100s]','strecken[100l]','strecken[200f]','strecken[200b]','strecken[200l]'),
    new Array('strecken[4x50f]','strecken[4x50b]','strecken[4x50r]','strecken[4x50s]','strecken[4x50l]','strecken[4x100f]','strecken[4x100b]','strecken[4x100r]','strecken[4x100s]','strecken[4x100l]','strecken[200r]','strecken[200s]','strecken[400f]','strecken[400l]','strecken[800f]','strecken[1500f]'),
    new Array('0_optionen[stand]'),
    '',
    '',
    ''
  ),
  new Array( // Hall of Fame - Standardlisten (Staffel) (7)
    new Array('strecken[4x50f]','strecken[4x50b]','strecken[4x50r]','strecken[4x50s]','strecken[4x50l]','strecken[4x100f]','strecken[4x100b]','strecken[4x100r]','strecken[4x100s]','strecken[4x100l]','optionen[mixedstaffeln]'),
    new Array('strecken[50f_offen]','strecken[50f_11jahre]','strecken[50b_offen]','strecken[50b_11jahre]','strecken[50r_offen]','strecken[50r_11jahre]','strecken[50s_offen]','strecken[50s_11jahre]','strecken[100f]','strecken[100b]','strecken[100r]','strecken[100s]','strecken[100l]','strecken[200f]','strecken[200b]','strecken[200l]','strecken[200r]','strecken[200s]','strecken[400f]','strecken[400l]','strecken[800f]','strecken[1500f]'),
    new Array('0_optionen[stand]'),
    '',
    '',
    ''
  ),
  new Array( // Hall of Fame - alle Strecken (8)
    new Array('strecken[50f_offen]','strecken[50f_11jahre]','strecken[50b_offen]','strecken[50b_11jahre]','strecken[50r_offen]','strecken[50r_11jahre]','strecken[50s_offen]','strecken[50s_11jahre]','strecken[100f]','strecken[100b]','strecken[100r]','strecken[100s]','strecken[100l]','strecken[200f]','strecken[200b]','strecken[200l]','strecken[4x50f]','strecken[4x50b]','strecken[4x50r]','strecken[4x50s]','strecken[4x50l]','strecken[4x100f]','strecken[4x100b]','strecken[4x100r]','strecken[4x100s]','strecken[4x100l]','strecken[200r]','strecken[200s]','strecken[400f]','strecken[400l]','strecken[800f]','strecken[1500f]','optionen[mixedstaffeln]'),
    '',
    new Array('0_optionen[stand]'),
    '',
    '',
    ''
  ),
  new Array( // Hall of Fame - Aenderungen nach letztem Wettkampf (nur Einzelstrecken) (9)
    new Array('strecken[50f_offen]','strecken[50f_11jahre]','strecken[50b_offen]','strecken[50b_11jahre]','strecken[50r_offen]','strecken[50r_11jahre]','strecken[50s_offen]','strecken[50s_11jahre]','strecken[100f]','strecken[100b]','strecken[100r]','strecken[100s]','strecken[100l]','strecken[200f]','strecken[200b]','strecken[200l]','optionen[zusammenfassung]'),
    new Array('strecken[200r]','strecken[200s]','strecken[400f]','strecken[400l]','strecken[800f]','strecken[1500f]','strecken[4x50f]','strecken[4x50b]','strecken[4x50r]','strecken[4x50s]','strecken[4x50l]','strecken[4x100f]','strecken[4x100b]','strecken[4x100r]','strecken[4x100s]','strecken[4x100l]'),
    new Array('1_optionen[stand]'),
    new Array('0_optionen[wettkampf]'),
    '',
    ''
  )
);

function erzeugeProfilselect(){
  document.write('<h2 id="profilh2">Profile</h2>')
  document.write('<p id="profilp"><select name="profile" size="1">');
  document.write('<option value="-">Benutzerdefiniert</option>');
  for(var i=0; i<erzeugeProfilselect.arguments.length;i++){
    document.write('<option value="'+erzeugeProfilselect.arguments[i]+'">'+profile[erzeugeProfilselect.arguments[i]]+'</option>');
  }
  document.write('</select> <input type="button" onclick="profilwaehlen(this.form.profile.options[this.form.profile.selectedIndex].value, this.form);" value="auswhlen" /></p>');
}

function profilwaehlen(nr,f){
  if(!profile[nr]){
    return;
  }

  // Checkboxen, true und false
  if(optionen[nr][0] != ''){
    for(var i=0;i<optionen[nr][0].length;i++){
      f.elements[optionen[nr][0][i]].checked = true;
    }
  }
  if(optionen[nr][1] != ''){
    for(var i=0;i<optionen[nr][1].length;i++){
      f.elements[optionen[nr][1][i]].checked = false;
    }
  }

  // Radio-Buttons
  if(optionen[nr][2] != ''){
    for(var i=0;i<optionen[nr][2].length;i++){
      var key = optionen[nr][2][i].substr(0,optionen[nr][2][i].indexOf('_'));
      var name = optionen[nr][2][i].substr(optionen[nr][2][i].indexOf('_')+1);
      f.elements[name][key].checked = true;
    }
  }

  // Select-Boxen
  if(optionen[nr][3] != ''){
    for(var i=0;i<optionen[nr][3].length;i++){
      var si = optionen[nr][3][i].substr(0,optionen[nr][3][i].indexOf('_'));
      var name = optionen[nr][3][i].substr(optionen[nr][3][i].indexOf('_')+1);
      var opt = f.elements[name].options;
      if(si.indexOf('value:') > -1){ // wert ist ein value
        var value = si.substr(6);
        if(si.indexOf('-') > -1){ // Bereich
          var von = value.substr(0,value.indexOf('-'));
          var bis = value.substr(value.indexOf('-')+1);
          for(var j=0;j<opt.length;j++){
            opt[j].selected = false;
            for(var k=von;k<=bis;k++){
              if(opt[j].value==k){
                opt[j].selected = true;
              }
            }
          }
        }
        else{
          if(si.indexOf(',') > -1){ // mehrere Werte
            var werte = value.split(',');
            for(var j=0;j<opt.length;j++){
              opt[j].selected = false;
              for(var k=0;k<werte.length;k++){
                if(opt[j].value==werte[k]){
                  opt[j].selected = true;
                }
              }
            }
          }
          else{ // ein Wert
            for(var j=0;j<opt.length;j++){
              opt[j].selected = false;
              if(opt[j].value==value){
                opt[j].selected = true;
              }
            }
          }
        }
      }
      else{
        f.elements[name].selectedIndex = si;
      }
    }
  }

  // wahl()
  if(window.wahl && optionen[nr][4] != ''){
    for(var i=0;i<optionen[nr][4].length;i++){
      wahl(optionen[nr][4][i]);
    }
  }

  // Text-Felder
  if(optionen[nr][5] != ''){
    for(var i=0;i<optionen[nr][5].length;i++){
      var name = optionen[nr][5][i].substr(0,optionen[nr][5][i].indexOf('|'));
      var wert = optionen[nr][5][i].substr(optionen[nr][5][i].indexOf('|')+1);
      if(wert == 'standardwert'){
          f.elements[name].value = f.elements[name].defaultValue;
      }
      else{
          f.elements[name].value = wert;
      }
    }
  }
  return;
}
// EOF