<?php
if(!isset($_SESSION['adminlogin'])){
	weiterleiten('/');
}

$aktuelleversion = '0.8.6';

$_seite = 'admin';
$querys = array(
	# die hier genannten Updates mssten fr ein Update auf die im Key genannte Version ausgefhrt werden.
    '0.8.6' => array(
    	"ALTER TABLE ".DB_PREFIX."mitglieder_trainingsgruppen ADD INDEX (mitgliedid)"
    ),
	'0.8.5' => array(
        "ALTER TABLE ".DB_PREFIX."zeiten ADD platz VARCHAR(3) NULL, ADD platzvon TINYINT UNSIGNED NULL, ADD bemerkung VARCHAR(255) NULL",
        "ALTER TABLE ".DB_PREFIX."staffeln ADD platz VARCHAR(3) NULL, ADD platzvon TINYINT UNSIGNED NULL, ADD bemerkung VARCHAR(255) NULL",
        "ALTER TABLE ".DB_PREFIX."meldungen_starts ADD zeitid MEDIUMINT UNSIGNED NULL",
        "ALTER TABLE ".DB_PREFIX."staffeln CHANGE gesamtzeit gesamtzeit MEDIUMINT(8) UNSIGNED NULL",
        "CREATE TABLE ".DB_PREFIX."zwischenzeiten (zeitid MEDIUMINT UNSIGNED NOT NULL, streckenlaenge SMALLINT UNSIGNED NOT NULL, zeit MEDIUMINT UNSIGNED NOT NULL, bestenliste CHAR(1) NOT NULL default '0', PRIMARY KEY (zeitid,streckenlaenge)) ENGINE = MYISAM CHARACTER SET latin1 COLLATE latin1_german2_ci",
        "CREATE TABLE ".DB_PREFIX."zeiten_rekorde (zeitid MEDIUMINT UNSIGNED NOT NULL, art VARCHAR(10) NOT NULL, laenge varchar(6) default NULL) ENGINE = MYISAM CHARACTER SET latin1 COLLATE latin1_german2_ci",
        "ALTER TABLE ".DB_PREFIX."mitglieder CHANGE dsvid dsvid VARCHAR(6) NULL DEFAULT NULL",
        "UPDATE ".DB_PREFIX."wks SET wkart = 'e' WHERE wkart = 'fo'",
        "ALTER TABLE ".DB_PREFIX."wks CHANGE wkart wkart CHAR(1) NOT NULL",
        "DROP TABLE ".DB_PREFIX."ferien",
        "CREATE TABLE ".DB_PREFIX."ferien (art TINYINT(3) unsigned NOT NULL, jahr YEAR(4) NOT NULL, nr TINYINT(3) unsigned NOT NULL default '1', von DATE default NULL, bis DATE default NULL, bezeichnung VARCHAR(50) NOT NULL, PRIMARY KEY (art,jahr,nr)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german2_ci",
        "ALTER TABLE ".DB_PREFIX."meldungen_starts ADD INDEX (zeitid)",
        "ALTER TABLE ".DB_PREFIX."zeiten_rekorde ADD INDEX (zeitid)",
        "ALTER TABLE ".DB_PREFIX."staffeln ADD anzahl TINYINT UNSIGNED NOT NULL AFTER disziplin",
        "ALTER TABLE ".DB_PREFIX."staffeln ADD mw CHAR(1) NOT NULL DEFAULT 'x' AFTER laenge",
  		"INSERT INTO ".DB_PREFIX."wettkaempfe (id,titel,kurztitel,ort,datum,bahnlaenge) SELECT 7, 'Rekordversuch', 'Rekordversuch', ort, '1988-01-04', '25' FROM ".DB_PREFIX."wettkaempfe WHERE id = 9",
  		"INSERT INTO ".DB_PREFIX."wettkaempfe (id,titel,kurztitel,ort,datum,bahnlaenge) SELECT 8, 'Rekordversuch', 'Rekordversuch', ort, '1988-01-05', '50' FROM ".DB_PREFIX."wettkaempfe WHERE id = 9"
    ),
	'0.8' => array(
    	"ALTER TABLE ".DB_PREFIX."aktuellezeiten ADD zeitid MEDIUMINT UNSIGNED NOT NULL"
    ),
	'0.7.8' => array(
    	"UPDATE ".DB_PREFIX."rechte SET bezeichnung = 'Wettkmpfe abwickeln - Grundrechte' WHERE id = 'w_abwickeln'",
        "ALTER TABLE ".DB_PREFIX."logins ADD salz VARCHAR(10) CHARACTER SET latin1 COLLATE latin1_german2_ci NULL AFTER anmeldename"
    ),
	'0.7.6' => array(
    	"ALTER TABLE ".DB_PREFIX."trainingsgruppen ADD rangfolge TINYINT UNSIGNED NULL",
        "ALTER TABLE ".DB_PREFIX."abschnitte ADD kindgerecht CHAR(1) NULL",
        "ALTER TABLE ".DB_PREFIX."meldungen_teilnehmer CHANGE telefon telefon VARCHAR(22) NOT NULL DEFAULT ''",
        "ALTER TABLE ".DB_PREFIX."meldungen_teilnehmer CHANGE kommentar kommentar VARCHAR(200) NOT NULL DEFAULT ''",
        "ALTER TABLE ".DB_PREFIX."uebungsleiter ADD trainerbis YEAR NULL AFTER trainer"
    ),
	'0.7.5' => array(
    	"CREATE TABLE ".DB_PREFIX."aktuellezeiten (mid smallint(5) unsigned NOT NULL, laenge smallint(5) unsigned NOT NULL, disziplin tinyint(3) unsigned NOT NULL, zeit mediumint(8) unsigned NOT NULL, UNIQUE KEY strecke (mid,laenge,disziplin)) ENGINE=MyISAM",
    	"ALTER TABLE ".DB_PREFIX."lizenzierungen ADD UNIQUE (mitgliedid,jahr)",
    	"ALTER TABLE ".DB_PREFIX."lizenzierungen DROP id",
        "ALTER TABLE ".DB_PREFIX."mitglieder CHANGE strasse strasse VARCHAR(40) NULL, CHANGE hausnr hausnr VARCHAR(5) NULL, CHANGE plz plz VARCHAR(5) NULL, CHANGE ort ort VARCHAR(40) NULL, CHANGE email email VARCHAR(50) NULL, CHANGE sonstiges sonstiges TEXT NULL",
        "ALTER TABLE ".DB_PREFIX."staffeln DROP datum",
        "ALTER TABLE ".DB_PREFIX."dateien CHANGE `type` `typ` VARCHAR(4) CHARACTER SET latin1 COLLATE latin1_german2_ci NOT NULL"
    ),
    '0.7.3' => array(
        "ALTER TABLE ".DB_PREFIX."meldungen_starts ADD meldezeit MEDIUMINT UNSIGNED NULL AFTER teilnahme",
        "ALTER TABLE ".DB_PREFIX."zeiten ADD INDEX (wettkampfid)",
        "ALTER TABLE ".DB_PREFIX."zeiten ADD INDEX (mitgliedid)",
        "ALTER TABLE ".DB_PREFIX."zeiten ADD INDEX strecke (disziplin,streckenlaenge)",
        "ALTER TABLE ".DB_PREFIX."staffeln_zeiten ADD INDEX (zeitid)",
        "ALTER TABLE ".DB_PREFIX."meldungen_teilnehmer ADD INDEX (wettkampfid)",
        "ALTER TABLE ".DB_PREFIX."meldungen_starts DROP id"
    ),
    '0.7.2' => array(
        "UPDATE ".DB_PREFIX."rechte SET bezeichnung = 'Pflichtzeiten' WHERE id = 'w_pflichtzeiten'",
        "ALTER TABLE ".DB_PREFIX."wettkaempfe ADD bahnlaenge ENUM('25','50') NULL DEFAULT '25' AFTER datum",
        "ALTER TABLE ".DB_PREFIX."meldungen_starts CHANGE meldezeitid meldezeitid MEDIUMINT(8) UNSIGNED NULL DEFAULT 0"
    ),
	'0.7.1' => array(
        "INSERT INTO ".DB_PREFIX."logins (id, anmeldename, passwort, freigeschaltet)
           SELECT id, anmeldename, passwort, freigeschaltet FROM ".DB_PREFIX."mitglieder WHERE anmeldename != '' and freigeschaltet = 1",
        "UPDATE ".DB_PREFIX."rechte SET id = 'm_logins' WHERE id = 'm_aendern_anmeldename'",
        "UPDATE ".DB_PREFIX."rechtegruppen_rechte SET rechteid = 'm_logins' WHERE rechteid = 'm_aendern_anmeldename'",
        "UPDATE ".DB_PREFIX."dateien SET systemname = 'anwenderhandbuch.pdf' WHERE id = 1",
        "DELETE FROM ".DB_PREFIX."rechte WHERE id IN ('a_updateusereinstellungen','t_datenbankaufraeumen','m_freischalten')",
        "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid IN ('a_updateusereinstellungen','t_datenbankaufraeumen','m_freischalten')",
    	"ALTER TABLE ".DB_PREFIX."zeiten DROP lenpunkte",
        "ALTER TABLE ".DB_PREFIX."mitglieder DROP anmeldename, DROP passwort, DROP freigeschaltet",
        "ALTER TABLE ".DB_PREFIX."logins CHANGE id id SMALLINT(5) UNSIGNED NOT NULL",
        "ALTER TABLE ".DB_PREFIX."logins DROP mitgliedid"
    )
);

$neuerechte = array(
	'0.8.5' => array(
    	'a_einstellungen_anzeigen;230;globale Einstellungen anzeigen',
        'a_einstellungen_bearbeiten;231;globale Einstellungen bearbeiten',
        'w_abwickeln_bemerkungen;427;Wettkmpfe abwickeln - Bemerkungen bearbeiten'
    ),
	'0.8.1' => array(
    	'm_tools_mitgliederimportieren;182;Mitgliedertools - Mitglieder importieren'
    ),
	'0.8' => array(
    	'e_zeiten_alledatensaetze;721;Export - Zeiten - Zugriff auf alle Datenstze',
        'm_tools_emailsverschicken;181;Mitgliedertools - E-Mails verschicken',
        'z_vereinsrekordeeinlesen;503;Vereinsrekorde einlesen'
    ),
	'0.7.8' => array(
    	'w_abwickeln_mitglhinzufuegen;421;Wettkmpfe abwickeln - Mitglieder der Meldung hinzufgen',
        'w_abwickeln_meldezettel;422;Wettkmpfe abwickeln - Meldezettel erstellen',
        'w_abwickeln_ruecklaufzettel;423;Wettkmpfe abwickeln - Rcklaufzettel eingeben',
        'w_abwickeln_kampfrichter;424;Wettkmpfe abwickeln - Kampfrichter melden',
        'w_abwickeln_meldung;425;Wettkmpfe abwickeln - Meldung erstellen',
        'w_abwickeln_ergebnisse;426;Wettkmpfe abwickeln - Ergebnisse bearbeiten',
        't_altersklassen;906;Tools - Altersklassen'
    ),
	'0.7.6' => array(
    	'a_neueversion;201;Admin - neue Version verfgbar?'
    ),
	'0.7.2' => array(
    	'w_pflichtzeiten_bearbeiten;451;Pflichtzeiten bearbeiten'
    )
);

$vorhandeneupdates = array(
	'0.7'   => '0.7.1', '0.7.1' => '0.7.2', '0.7.2' => '0.7.3',
    '0.7.3' => '0.7.4', '0.7.4' => '0.7.5', '0.7.5' => '0.7.6',
    '0.7.6' => '0.7.7', '0.7.7' => '0.7.8', '0.7.8' => '0.8',
    '0.8'   => '0.8.1', '0.8.1' => '0.8.5', '0.8.5' => '0.8.6'
);

$_tmpl->assign('ueberschrift','Update ausfhren');


if(!isset($_POST['update']) or $aktuelleversion == TKSWIM_VERSION or !isset($vorhandeneupdates[TKSWIM_VERSION])){
	$_tmpl->assign('von',TKSWIM_VERSION);
	$_tmpl->assign('nach',$aktuelleversion);
    $_tmpl->assign('updatevorhanden',isset($vorhandeneupdates[TKSWIM_VERSION]));
    $_inh .= $_tmpl->fetch('admin/29.admin-update.inc.html');
}
else{
    # Zielversion festlegen
	$zielversion = $aktuelleversion;
    if(strpos($zielversion,'_') !== false){
    	list($zielversion,) = explode('_',$zielversion);
    }
    # alle Updateschritte zwischen Anfangs- und Zielversion durchfhren
    $von = TKSWIM_VERSION;
    while(true){
    	fuehreUpdateAus($vorhandeneupdates[$von]);
        $von = $vorhandeneupdates[$von];
        if($von == $zielversion){
        	break;
        }
    }

    # Template-Cache leeren (bei nderungen in Templates werden die bei TKSWIM_DEBUG=false sonst nicht bernommen)
    if(is_dir(PFAD_TEMPLATESC) and is_writable(PFAD_TEMPLATESC)){
        $dh = opendir(PFAD_TEMPLATESC);
        while(false !== ($file = readdir($dh))){
            if($file == '.' or $file == '..'){
                continue;
            }
            unlink(PFAD_TEMPLATESC.'/'.$file);
        }
        closedir($dh);
    }

    # Updates bei den Rechten von Modulen bernehmen
    $module = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
    if(count($module['_versionen']) > 0){
    	$geaendert = false;
    	foreach($module['_versionen'] as $modul => $version){
        	$modulconf = parse_ini_file(PFAD_INCLUDE.'module/'.$modul.'/conf.ini', true);
            if(version_compare($version, $modulconf['conf']['version'], '>=')){ # keine neue Version
        		continue;
            }
            # neue Version
            $module['_versionen'][$modul] = $modulconf['conf']['version'];
    		$geaendert = true;
            if(count($modulconf['rechte']) < 1){
            	continue;
            }
            # prfen ob neue Rechte angelegt werden mssen
            $_inh .= printr($modulconf,1,1);
            $rechte = $modulconf['rechte'];
              # vorhandene Rechte holen
            $query = "SELECT id FROM ".DB_PREFIX."rechte WHERE id IN ('".implode("', '", array_keys($rechte))."')";
            $_db->holeDaten($query);
            $vorhandenerechte = $_db->baueArray('id', 'id');
              # aus $rechte die entfernen die schon vorhanden sind
            foreach($vorhandenerechte as $id){
            	unset($rechte[$id]);
            }
              # wenn in $rechte noch Rechte stehen mssen die noch angelegt werden
            if(count($rechte) < 1){
            	continue;
            }
            $rgr = $r = array();
            foreach($rechte as $id => $dat){
            	list($sort, $bezeichnung) = explode(';', $dat, 2);
                $r[] = "('".text_format($id,'db')."', '".text_format($sort,'db')."', '".text_format($bezeichnung,'db')."')";
                $rgr[] = "(1, '".text_format($id,'db')."')";
            }
              # fehlende Rechte anlegen und der Rechtegruppe Admin zuordnen
            $query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ', $r)."";
            $_db->fuehreQueryAus($query);
            $query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ', $rgr)."";
            $_db->fuehreQueryAus($query);
        }
        if($geaendert){
        	require_once('func/schreibe_ini_datei.inc.php');
        	schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $module, true);
        }
    }

    # Versionsnummer in der conf.inc.php anpassen
	$_tmpl->assign('daten',array('tkswim_version'=>$zielversion));
    $neuerinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
    $fh = fopen(PFAD_INCLUDE.'conf/conf.inc.php', 'w');
    fwrite($fh, $neuerinhalt, strlen($neuerinhalt));
    fclose($fh);

    require_once('class/einstellungen.inc.php');
    # Usereinstellungen aktualisieren
	$einst = new einstellungen(PFAD_INCLUDE.'conf/user-ini.xml',PFAD_INIDATEIEN,'');
	$einst->db = &$_db;
	$einst->einlesen();
    $einst->aktualisiereUserinidateien();
    # globale Einstellungen aktualisieren (ab Version 0.8.5)
	if(version_compare($zielversion, '0.8.5', '>=')){
		$einst = new einstellungen(PFAD_INCLUDE.'conf/einstellungen-ini.php', PFAD_INCLUDE.'conf/einstellungen.ini');
		$einst->db = &$_db;
		$einst->aktualisiereGlobalIniDatei();
    }

    weiterleiten('/','Das Update wurde durchgefhrt');
}

function fuehreUpdateAus($bis){
	global $_db, $querys, $neuerechte, $_tmpl;

    # Query fr das Anpassen der Gre der Doku
    if(file_exists(PFAD_DATEIEN.'anwenderhandbuch.pdf')){
        if(!isset($querys[$bis])){
            $querys[$bis] = array();
        }
        $groesse = filesize(PFAD_DATEIEN.'anwenderhandbuch.pdf');
        $querys[$bis][] = "UPDATE ".DB_PREFIX."dateien SET groesse = ".$groesse.", letzteaenderung = NOW() WHERE id = 1";
    }

    # falls ntig neue Rechte anlegen (und Admins dieses Recht geben)
    if(isset($neuerechte[$bis]) and count($neuerechte[$bis])>0){
        if(!isset($querys[$bis])){
            $querys[$bis] = array();
        }
        $r = $rgr = array();
        foreach($neuerechte[$bis] as $recht){
        	$r[] = "('".str_replace(';',"','",$recht)."')";
            $rgr[] = "(1, '".substr($recht,0,strpos($recht,';'))."')";
        }
        $querys[$bis][] = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ',$r);
        $querys[$bis][] = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ',$rgr);
    }

    # ggf. Datenbankstruktur anpassen
    if(isset($querys[$bis])){
    	foreach($querys[$bis] as $query){
        	$_db->fuehreQueryAus($query);
        }
    }

	switch($bis){
    case '0.8.5':
        require_once('func/schreibe_ini_datei.inc.php');
    	# Flags in Wettkampfabwicklungsdateien berarbeiten
    	$dateien = glob(PFAD_INIDATEIEN.'wkabwickeln_*.ini');
        foreach($dateien as $datei){
            $inhalt = parse_ini_file($datei, true);
        	if(basename($datei) == 'wkabwickeln_default.ini'){
                $inhalt['flags']['ergebnisseimportiert'] = '-';
                $inhalt['flags']['ausgewertet'] = '-';
            }
            else{
                $inhalt['flags']['ergebnisseimportiert'] = $inhalt['flags']['dsvimportiert'];
                $inhalt['flags']['ausgewertet'] = $inhalt['flags']['ergebnisseimportiert']=='+'?'+':'-';
            }
            unset($inhalt['flags']['dsvimportiert'], $inhalt['flags']['zeitengeschrieben']);
        	schreibe_ini_datei($datei, $inhalt, true);
        }

        # die .htaccess-Datei im Root muss neu geschrieben werden
        $grenze_umf = 2*1048576;
        $grenze_pms = 8*1048576;
        $speichern = array(
            'htaccess_include' => (substr(PFAD_INCLUDE,0,1)!='/'?substr(PFAD_INCLUDE,strpos(PFAD_INCLUDE,'/')):PFAD_INCLUDE),
            'upload_max_filesize' => (TKSWIM_MAXDATEIGROESSE>$grenze_umf?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false),
            'post_max_size'       => (TKSWIM_MAXDATEIGROESSE>$grenze_pms?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false)
        );
        $_tmpl->assign('daten',$speichern);
        $htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
        $fh = fopen(PFAD_HTTP.'.htaccess','w');
        fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
        fclose($fh);

        # alte Wettkampfauswertungen in die neue Speicherung umwandeln
        $dateien = glob(PFAD_INIDATEIEN.'wkauswertung_*.ini');
        foreach($dateien as $datei){
    		$inhalt = parse_ini_file($datei,true);
            foreach($inhalt as $_wkid => $daten){
                # Daten auftrennen und zurckgeben
                $auswertung = array();
                $anfaenge = array('dsbem','zwzeiten');
                foreach($daten as $strecke => $row){
                    if($strecke == '_mitglieder'){
                        continue;
                    }
                    list($disziplin, $laenge, $mw) = explode('_', $strecke, 3);
                    if(strpos($strecke,'x') !== false){ # Staffel
                        $auswertung[$strecke] = array(
                            'disziplin' => $disziplin,
                            'laenge'    => $laenge,
                            'mw'        => $mw,
                            'staffel'   => 1,
                        );
                        $staffeln = explode('|',$row);
                        $anz = count($staffeln);
                        for($i=0;$i<$anz;$i++){
                            list(, $ezeit, $mzeit, $platz, $vonplaetzen, $mids, $zwzeiten, $sonstiges) = explode(';', $staffeln[$i], 8);

                            $tmp = explode('@',$sonstiges);
                            $sonstiges = array();
                            foreach($tmp as $t){
                                $anfang = substr($t,0,strpos($t,':'));
                                if(in_array($anfang,$anfaenge)){
                                    $sonstiges[$anfang] = substr($t,strpos($t,':')+1);
                                }
                                else{
                                    $sonstiges[] = $t;
                                }
                            }
                            $tmp = array();
                            if(!empty($platz)){
                                if($platz == 'DS'){
                                    $platz = 'DISQ';
                                }
                                $tmp['platz'] = $platz;
                                if(!empty($vonplaetzen)){
                                    $tmp['vonplaetzen'] = $vonplaetzen;
                                }
                            }
                            if(!empty($ezeit)){
                                $tmp['zeit'] = $ezeit;
                            }
                            if(!empty($mzeit)){
                                $tmp['meldezeit'] = $mzeit;
                            }
                            $t = array();
                            foreach($sonstiges as $key => $wert){
                                if($key === 'dsbem'){
                                    $t[] = 'DSBEM: '.$wert;
                                }
                                else{
                                    $t[] = $wert;
                                }
                            }
                            if(count($t)>0){
                                $fertig = implode(', ',$t);
                                $fertig = trim($fertig);
                                if(!empty($fertig)){
                                    $tmp['_sonstiges'] = $fertig;
                                }
                            }
                            if(empty($mids)){
                                $tmp['_schwimmer'] = false;
                            }
                            else{
                                $tmp['_schwimmer'] = array();

                                $tmp_s = explode(':',$mids);
                                $tmp_z = explode(':',$zwzeiten);
                                $summe = 0;
                                for($j=0;$j<count($tmp_s);$j++){
                                    if(empty($tmp_z[$j])){
                                        $tmp_z[$j] = 0;
                                    }
                                    if($tmp_z[$j] > 0){
                                        $summe += $tmp_z[$j];
                                    }
                                    else{
                                        $summe = 0;
                                    }
                                    $tmp['_schwimmer'][$j+1] = array(
                                        'mid'        => $tmp_s[$j],
                                        'einzelzeit' => $tmp_z[$j],
                                        'summe'      => $summe
                                    );
                                }
                            }
                            $auswertung[$strecke]['_staffeln'][] = $tmp;
                        }
                    }
                    else{ # Einzelstrecke
                        $auswertung[$strecke] = array(
                            'disziplin' => $disziplin,
                            'laenge'    => $laenge,
                            'mw'        => $mw,
                        );

                        $schwimmer = explode('|', $row);
                        $anz = count($schwimmer);
                        for($i=0;$i<$anz;$i++){
                            list($mid, $ezeit, $mzeit, $platz, $vonplaetzen, $sonstiges) = explode(';', $schwimmer[$i], 6);
                            $tmp = explode('@',$sonstiges);
                            $sonstiges = array();
                            foreach($tmp as $t){
                                $anfang = substr($t,0,strpos($t,':'));
                                if(in_array($anfang,$anfaenge)){
                                    $sonstiges[$anfang] = substr($t,strpos($t,':')+1);
                                }
                                else{
                                    $sonstiges[] = $t;
                                }
                            }
                            if($platz == 'NA'){
                                if(!isset($auswertung[$strecke]['_nase'])){
                                    $auswertung[$strecke]['_nase'] = array();
                                }
                                $auswertung[$strecke]['_nase'][] = $mid;
                            }
                            elseif($platz == 'DS'){
                                if(!isset($auswertung[$strecke]['_disq'])){
                                    $auswertung[$strecke]['_disq'] = array();
                                }
                                $auswertung[$strecke]['_disq'][$mid] = array(
                                    'dsbem' => $sonstiges['dsbem']
                                );
                                if(isset($ezeit) and !empty($ezeit)){
                                    $auswertung[$strecke]['_disq'][$mid]['zeit'] = $ezeit;
                                }
                            }
                            else{
                                if(!isset($auswertung[$strecke]['_schwimmer'])){
                                    $auswertung[$strecke]['_schwimmer'] = array();
                                }
                                $tmp = array(
                                    'mid' => $mid,
                                    'zeit' => $ezeit
                                );
                                if(!empty($mzeit)){
                                    $tmp['meldezeit'] = $mzeit;
                                }
                                if(!empty($platz)){
                                    $tmp['platz'] = $platz;
                                    if(!empty($vonplaetzen)){
                                        $tmp['vonplaetzen'] = $vonplaetzen;
                                    }
                                }
                                $t = array();
                                foreach($sonstiges as $key => $wert){
                                    if($key === 'zwzeiten'){
                                        $werte = explode(':',$wert);
                                        $w = array();
                                        for($j=0;$j<count($werte);$j++){
                                            if($werte[$j] > 0){
                                                $w[] = $werte[$j];
                                            }
                                        }
                                        if(count($w)>0){
                                            $t[] = 'Zwzeit:'.implode(',',$w);
                                        }
                                    }
                                    else{
                                        $t[] = $wert;
                                    }
                                }
                                if(count($t)>0){
                                    $fertig = implode(';',$t);
                                    $fertig = trim($fertig);
                                    if(!empty($fertig)){
                                        $tmp['_sonstiges'] = $fertig;
                                    }
                                }
                                $auswertung[$strecke]['_schwimmer'][] = $tmp;
                            }
                        }
                    }
                }

                # vorhandene Zeiten des Wettkampfes holen
                $query = "SELECT id, mitgliedid, zeit, disziplin, streckenlaenge, bestenliste, staffelid, schwimmernr
                            FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON z.id=sz.zeitid
                            WHERE wettkampfid = ".$_wkid."";
                $_db->holeDaten($query);
                $zeiten = $_db->baueArray('*', 'id');

                # vorhandene Staffeln des Wettkampfes holen
                $query = "SELECT id, disziplin, laenge, gesamtzeit, platz, platzvon, bemerkung, COUNT(sz.zeitid) as anz
                            FROM ".DB_PREFIX."staffeln as s LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON s.id = sz.staffelid
                            WHERE wettkampfid = ".$_wkid." GROUP BY id";
                $_db->holeDaten($query);
                $staffeln = $_db->baueArray('*', 'id');

                # vorhandene Meldungen holen
                $query = "SELECT mt.id, mt.mid, ms.meldezeit, ms.wkid, w.wknr, w.mw, w.laenge, w.disziplin
                            FROM (".DB_PREFIX."meldungen_starts as ms LEFT JOIN ".DB_PREFIX."meldungen_teilnehmer as mt ON ms.teilnehmerid = mt.id)
                              LEFT JOIN ".DB_PREFIX."wks as w ON ms.wkid = w.id
                            WHERE mt.teilnahme != '-' AND wettkampfid = ".$_wkid."";
                $_db->holeDaten($query);
                $meldungen = $_db->baueArray('*', '#');

                # Datum des Wettkampfes holen
                $query = "SELECT datum FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_wkid."";
                $_db->holeDaten($query);
                $datum = $_db->holeWert();

                # WR-Cup oder VM?
                $query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'w' AND eigenschaft = 'wettkampfart' AND (wert = 'vm' OR wert = 'wrcup') AND artid = ".$_wkid."";
                $_db->holeDaten($query);
                $_wrcupvm = $_db->holeAnzahl()<1?false:true;

                $querys = array();
                $rekordarten = array('PB', 'PB25', 'PB50', 'HoF', 'HoF11', 'VJR', 'VR');
                $zwischenzeiten = array(
                    25   => false,
                    50   => false,
                    100  => array( 2    => 50),
                    200  => array( 4    => 50,   2    => 100),
                    400  => array( 8    => 50,   4    => 100, 2   => 200,  1.33 => 300),
                    800  => array(16    => 50,   8    => 100, 4   => 200,  2.67 => 300,  2    => 400,  1.6  => 500,  1.33 => 600,  1.14 => 700),
                    1500 => array(30    => 50,  15    => 100, 7.5 => 200,  5    => 300,  3.75 => 400,  3    => 500,  2.5  => 600,  2.14 => 700,
                                   1.88 => 800,  1.67 => 900, 1.5 => 1000, 1.36 => 1100, 1.25 => 1200, 1.15 => 1300, 1.07 => 1400)
                );

                foreach($auswertung as $wkkey => $wkdat){
                    if(strpos($wkdat['laenge'], 'x') === false){ # Einzelstart
                        if(isset($wkdat['_schwimmer'])){
                            foreach($wkdat['_schwimmer'] as $key => $row){
                                # Ergebniszeit fr den Auswertungseintrag suchen
                                foreach($zeiten as $zid => $zeit){
                                    if($wkdat['laenge'] != $zeit['streckenlaenge'] or $wkdat['disziplin'] != $zeit['disziplin']){
                                        continue;
                                    }
                                    if($row['zeit'] != $zeit['zeit'] or $row['mid'] != $zeit['mitgliedid']){
                                        continue;
                                    }
                                    if((isset($row['platz']) and !empty($row['platz'])) or (isset($row['vonplaetzen']) and !empty($row['vonplaetzen']))){
                                        $querys[] = "UPDATE ".DB_PREFIX."zeiten SET
                                                         platz = ".((isset($row['platz']) and !empty($row['platz']))?"'".text_format($row['platz'],'db')."'":'NULL').",
                                                         platzvon = ".((isset($row['vonplaetzen']) and !empty($row['vonplaetzen']))?"'".text_format($row['vonplaetzen'],'db')."'":'NULL')."
                                                       WHERE id = ".$zid."";
                                    }
                                    if(!empty($row['_sonstiges'])){
                                        $rekorde = explode(';', $row['_sonstiges']);
                                        foreach($rekorde as $rekord){
                                            if(!in_array($rekord, $rekordarten)){
                                                if(strpos($rekord, ':') === false){
                                                    continue;
                                                }
                                                list($anfang, $wert) = explode(':', $rekord);
                                                if($anfang == 'Zwzeit'){ # Zwischenzeiten speichern
                                                    if($zwischenzeiten[$wkdat['laenge']] === false){
                                                        continue;
                                                    }
                                                    if($wkdat['laenge'] == 200 and $wkdat['disziplin'] == 5){
                                                        continue; # bei den 200L gibt es keine Zwischenzeiten
                                                    }
                                                    $zwzeiten = explode(',',$wert);
                                                    foreach($zwzeiten as $zwzeit){
                                                        $test = array();
                                                        foreach($zwischenzeiten[$wkdat['laenge']] as $faktor => $laenge){
                                                            $erg = abs($zeit['zeit']/$faktor-$zwzeit);
                                                            $test[$erg] = $faktor;
                                                        }
                                                        ksort($test);
                                                        $faktor = array_shift($test);
                                                        $laenge = $zwischenzeiten[$wkdat['laenge']][$faktor];
                                                        $querys[] = "INSERT INTO ".DB_PREFIX."zwischenzeiten SET
                                                                         zeitid = ".$zid.",
                                                                         streckenlaenge = ".$laenge.",
                                                                         zeit = ".$zwzeit.",
                                                                         bestenliste = 1";
                                                    }
                                                }
                                                continue;
                                            }
                                            $querys[] = "INSERT INTO ".DB_PREFIX."zeiten_rekorde SET zeitid = ".$zid.", art = '".text_format($rekord,'db')."'";
                                        }
                                    }
                                    unset($zeiten[$zid]);
                                    break;
                                }
                                # Meldung fr den Auswertungseintrag suchen
                                foreach($meldungen as $meldid => $meldung){
                                    if($wkdat['laenge'] != $meldung['laenge'] or $wkdat['disziplin'] != $meldung['disziplin']){
                                        continue;
                                    }
                                    if((($row['meldezeit'] != $meldung['meldezeit']) AND !is_null($meldung['meldezeit'])) or $row['mid'] != $meldung['mid']){
                                        continue;
                                    }
                                    $querys[] = "UPDATE ".DB_PREFIX."meldungen_starts SET
                                                     zeitid = '".$zid."'
                                                   WHERE teilnehmerid = ".$meldung['id']." AND wkid = ".$meldung['wkid']."";
                                    unset($meldungen[$meldid]);
                                    break;
                                }
                                unset($auswertung[$wkkey]['_schwimmer'][$key]);
                                if(count($auswertung[$wkkey]['_schwimmer']) == 0){
                                    unset($auswertung[$wkkey]['_schwimmer']);
                                }
                            }
                        }
                        if(isset($wkdat['_nase']) and !$_wrcupvm){ # "nicht am Start" in der Datenbank speichern
                            foreach($wkdat['_nase'] as $key => $nasemid){
                                $query = "INSERT INTO ".DB_PREFIX."zeiten SET
                                                 mitgliedid = ".$nasemid.",
                                                 datum = '".$datum."',
                                                 zeit = NULL,
                                                 disziplin = ".$wkdat['disziplin'].",
                                                 streckenlaenge = ".$wkdat['laenge'].",
                                                 wettkampfid = ".$_wkid.",
                                                 bestenliste = 1,
                                                 platz = 'NA',
                                                 platzvon = NULL,
                                                 bemerkung = NULL";
                                $_db->fuehreQueryAus($query);
                                $zeitid = $_db->ergebnis['insertid'];

                                # Meldung fr den Auswertungseintrag suchen
                                foreach($meldungen as $meldid => $meldung){
                                    if($wkdat['laenge'] != $meldung['laenge'] or $wkdat['disziplin'] != $meldung['disziplin']){
                                        continue;
                                    }
                                    if($nasemid != $meldung['mid']){
                                        continue;
                                    }
                                    $querys[] = "UPDATE ".DB_PREFIX."meldungen_starts SET
                                                     zeitid = '".$zeitid."'
                                                   WHERE teilnehmerid = ".$meldung['id']." AND wkid = ".$meldung['wkid']."";
                                    unset($meldungen[$meldid]);
                                    break;
                                }
                                unset($auswertung[$wkkey]['_nase'][$key]);
                            }
                            if(count($auswertung[$wkkey]['_nase']) == 0){
                                unset($auswertung[$wkkey]['_nase']);
                            }
                        }
                        if(isset($wkdat['_disq'])){ # Disqualifikationen in der Datenbank speichern
                            foreach($wkdat['_disq'] as $disqmid => $disq){
                                $query = "INSERT INTO ".DB_PREFIX."zeiten SET
                                                 mitgliedid = ".$disqmid.",
                                                 datum = '".$datum."',
                                                 zeit = NULL,
                                                 disziplin = ".$wkdat['disziplin'].",
                                                 streckenlaenge = ".$wkdat['laenge'].",
                                                 wettkampfid = ".$_wkid.",
                                                 bestenliste = 1,
                                                 platz = 'DS',
                                                 platzvon = NULL,
                                                 bemerkung = '".text_format($disq['dsbem'], 'db')."'";
                                $_db->fuehreQueryAus($query);
                                $zeitid = $_db->ergebnis['insertid'];

                                # Meldung fr den Auswertungseintrag suchen
                                foreach($meldungen as $meldid => $meldung){
                                    if($wkdat['laenge'] != $meldung['laenge'] or $wkdat['disziplin'] != $meldung['disziplin']){
                                        continue;
                                    }
                                    if($disqmid != $meldung['mid']){
                                        continue;
                                    }
                                    $querys[] = "UPDATE ".DB_PREFIX."meldungen_starts SET
                                                     zeitid = '".$zeitid."'
                                                   WHERE teilnehmerid = ".$meldung['id']." AND wkid = ".$meldung['wkid']."";
                                    unset($meldungen[$meldid]);
                                    break;
                                }
                                unset($auswertung[$wkkey]['_disq'][$disqmid]);
                            }
                            if(count($auswertung[$wkkey]['_disq']) == 0){
                                unset($auswertung[$wkkey]['_disq']);
                            }
                        }
                        unset($auswertung[$wkkey]);
                    }
                    else{ # Staffelstart
                        foreach($wkdat['_staffeln'] as $key => $row){
                            foreach($staffeln as $sid => $staffel){
                                list($anz, $laenge) = explode('x', $wkdat['laenge']);
                                if($laenge != $staffel['laenge'] or $wkdat['disziplin'] != $staffel['disziplin']){
                                    continue;
                                }
                                if($row['zeit'] != $staffel['gesamtzeit'] or count($row['_schwimmer']) != $staffel['anz']){
                                    continue;
                                }
                                if((isset($row['platz']) and !empty($row['platz'])) or (isset($row['vonplaetzen']) and !empty($row['vonplaetzen']))){
                                	$querys[] = "UPDATE ".DB_PREFIX."staffeln SET
                                                     platz = ".((isset($row['platz']) and !empty($row['platz']))?"'".text_format($row['platz'],'db')."'":'NULL').",
                                                     platzvon = ".((isset($row['vonplaetzen']) and !empty($row['vonplaetzen']))?"'".text_format($row['vonplaetzen'],'db')."'":'NULL')."
                                                   WHERE id = ".$sid."";
                                }
                                if(!empty($row['_sonstiges'])){
                                    $rekorde = explode(', ', $row['_sonstiges']);

                                    # Zeit des ersten Schwimmers suchen
                                    $ersterschwimmer = false;
                                    foreach($zeiten as $zid => $zeit){
                                        if($zeit['staffelid'] != $sid or $zeit['schwimmernr'] != 1){
                                            continue;
                                        }
                                        $ersterschwimmer = $zid;
                                    }

                                    if($ersterschwimmer !== false){
                                        foreach($rekorde as $rekord){
                                            if(!in_array($rekord, $rekordarten)){
                                                continue;
                                            }
                                            $querys[] = "INSERT INTO ".DB_PREFIX."zeiten_rekorde SET zeitid = ".$ersterschwimmer.", art = '".text_format($rekord,'db')."'";
                                        }
                                    }
                                }
                                unset($zeiten[$zid]);
                                break;
                            }
                        }
                    }
                }
                foreach($querys as $q){
                    $_db->fuehreQueryAus($q);
                }
            }
        }

    	# Wettkampfauswertungen lschen
        $dateien = glob(PFAD_INIDATEIEN.'wkauswertung_*.ini');
        foreach($dateien as $datei){
        	unlink($datei);
        }

        # Anzahl der Schwimmer und Geschlecht der Staffeln speichern
          # Anzahl der Schwimmer holen
        $query = "SELECT s.id as sid, COUNT(schwimmernr) as anz
                    FROM ".DB_PREFIX."staffeln as s LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON s.id=sz.staffelid GROUP BY s.id";
        $_db->holeDaten($query);
        $anzahl = $_db->baueArray('anz', 'sid');
          # Geschlecht der Staffel holen
        $query = "SELECT s.id as sid, GROUP_CONCAT(DISTINCT m.mw ORDER BY m.mw SEPARATOR '') as mw
                    FROM ((".DB_PREFIX."staffeln as s LEFT JOIN ".DB_PREFIX."staffeln_zeiten as sz ON s.id=sz.staffelid)
                      LEFT JOIN ".DB_PREFIX."zeiten as z ON sz.zeitid=z.id) LEFT JOIN ".DB_PREFIX."mitglieder as m ON z.mitgliedid = m.id
                    GROUP BY s.id";
        $_db->holeDaten($query);
        $mw = $_db->baueArray('mw', 'sid');
          # Werte in die Datenbank schreiben
        foreach($anzahl as $sid => $anz){
        	$mwx = $mw[$sid]=='mw'?'x':$mw[$sid];
			$query = "UPDATE ".DB_PREFIX."staffeln SET anzahl = ".$anz.", mw = '".$mwx."' WHERE id = ".$sid."";
            $_db->fuehreQueryAus($query);
        }

        # aktuelle Vereinsrekorde in die Datenbank schreiben
        $rekorde = parse_ini_file(PFAD_INIDATEIEN.'vereinsrekorde.ini', true);
          # VR/VJR schreiben
        $datensaetze = array();
        foreach($rekorde['rekorde'] as $strecke => $zid){
        	list(,,,$alter) = explode('_', $strecke);
            if($alter == '*'){
            	$datensaetze[] = "(".$zid.", 'aVR', NULL)";
            }
            else{
            	$datensaetze[] = "(".$zid.", 'aVJR', NULL)";
            }
        }
        if(count($datensaetze)>0){
        	$query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde (zeitid, art, laenge) VALUES ".implode(', ', $datensaetze)."";
            $_db->fuehreQueryAus($query);
        }
          # Hall-of-Fame-Eintrge schreiben
        $datensaetze = array();
        foreach($rekorde['halloffame'] as $strecke => $zeitids){
            if(empty($zeitids)){
            	continue;
            }
            $ids = explode(',',$zeitids);
            $art = substr($strecke,-1)=='o'?'aHoF':'aHoF11';

            $i = 1;
            foreach($ids as $id){
                $datensaetze[] = "(".$id.", '".$art."_".$i."', NULL)";
                $i++;
            }
        }
        if(count($datensaetze)>0){
        	$query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde (zeitid, art, laenge) VALUES ".implode(', ', $datensaetze)."";
            $_db->fuehreQueryAus($query);
        }
          # Rekorddatei leeren
        $fh = fopen(PFAD_INIDATEIEN.'vereinsrekorde.ini', 'w');
        fclose($fh);

        # die jeweils ersten VR/VJR in die Datenbank schreiben
        $rekorde = parse_ini_file(PFAD_INIDATEIEN.'vereinsrekorde_entwicklung.ini', true);
        $vrids = $vjrids = array();
        foreach($rekorde as $rekordklassen){
        	foreach($rekordklassen as $klasse => $ids){
        		if(strpos($ids, ',') === false){
                	if($klasse == '*'){
                    	$vrids[] = $ids;
                    }
                    else{
                    	$vjrids[] = $ids;
                    }
            	}
                else{
                	# erste ID suchen
                    $query = "SELECT id FROM ".DB_PREFIX."zeiten WHERE id IN (".$ids.") ORDER BY datum LIMIT 1";
                    $_db->holeDaten($query);
                    $id = $_db->holeWert();
                	if($klasse == '*'){
                    	$vrids[] = $id;
                    }
                    else{
                    	$vjrids[] = $id;
                    }
                }
            }
        }
        $datensaetze = array();
        foreach($vrids as $id){
        	$datensaetze[] = "(".$id.", 'VR', NULL)";
        }
        foreach($vjrids as $id){
        	$datensaetze[] = "(".$id.", 'VJR', NULL)";
        }
        $query = "INSERT INTO ".DB_PREFIX."zeiten_rekorde (zeitid, art, laenge) VALUES ".implode(', ',$datensaetze)."";
        $_db->fuehreQueryAus($query);
          # Rekordverlaufdatei leeren
        $fh = fopen(PFAD_INIDATEIEN.'vereinsrekorde_entwicklung.ini', 'w');
        fclose($fh);

        # doppelte Rekordvermerke entfernen
        $query = "SELECT z.id, zr.art, COUNT(zr.art) as anz
                    FROM ".DB_PREFIX."zeiten as z LEFT JOIN ".DB_PREFIX."zeiten_rekorde as zr ON z.id=zr.zeitid
                    WHERE zr.laenge IS NULL and zr.art IS NOT NULL
                    GROUP BY z.id, zr.art HAVING anz>1 ORDER BY anz DESC";
        $_db->holeDaten($query);
        $daten = $_db->baueArray('*', '#');
        foreach($daten as $row){
        	$query = "DELETE FROM ".DB_PREFIX."zeiten_rekorde WHERE zeitid = ".$row['id']." AND art = '".$row['art']."' LIMIT ".($row['anz']-1)."";
            $_db->fuehreQueryAus($query);
        }

        # die cronjob.ini erweitern
        $inhalt = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
        $inhalt['einstellungen']['aufrufvonip'] .= ',87.106.138.4';
        $inhalt['gc']['wettkampfabwicklungsdateien'] = '5';
        schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$inhalt,true);
    	break;

    case '0.8':
    	# Zeitenexporte lschen
        $fh = fopen(PFAD_INIDATEIEN.'zeiten_export.ini', 'w');
        fclose($fh);
        # aktuelle Zeiten neu einlesen
		require_once('class/zeiten.inc.php');
		$z = new zeiten;
    	$z->db = &$_db;
    	$z->schreibeAktuelleZeiten();
    	break;

    case '0.7.7':
    	# .htaccess-Datei im Root aktualisieren
        $grenze_umf = 2*1048576;
        $grenze_pms = 8*1048576;
        $speichern = array(
        	'htaccess_include' => (substr(PFAD_INCLUDE,0,1)!='/'?substr(PFAD_INCLUDE,strpos(PFAD_INCLUDE,'/')):PFAD_INCLUDE),
            'upload_max_filesize' => (TKSWIM_MAXDATEIGROESSE>$grenze_umf?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false),
            'post_max_size'       => (TKSWIM_MAXDATEIGROESSE>$grenze_pms?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false)
        );
        $_tmpl->assign('daten',$speichern);
        $htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
        $fh = fopen(PFAD_HTTP.'.htaccess','w');
        fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
        fclose($fh);
    	# Wettkampfauswertungen lschen
        $dateien = glob(PFAD_INIDATEIEN.'wkauswertung_*.ini');
        foreach($dateien as $datei){
        	unlink($datei);
        }
    	# bungsleiterabrechnungsdateien in das neue Format umschreiben
        # Wochentag2Anfangszeit
        $query = "SELECT wochentag, TIME_FORMAT(MIN(anfangszeit),'%H:%i') as zeit
                    FROM ".DB_PREFIX."trainingsgruppen GROUP BY wochentag";
        $_db->holeDaten($query);
        $wtag2zeit = $_db->baueArray('zeit','wochentag');

        foreach($wtag2zeit as $wtag => $zeit){
            $teile = explode(':',$zeit);
            $wtag2zeit[$wtag] = array('std' => $teile[0], 'min' => $teile[1]);
        }
        $dateien = glob(PFAD_INIDATEIEN.'stundennachweis_*.ini');
        require_once('func/schreibe_ini_datei.inc.php');
        foreach($dateien as $datei){
            $daten = parse_ini_file($datei,true);
            $datenneu = array();
            foreach($daten as $key => $halbjahr){
                $datenneu[$key] = array();
                foreach($halbjahr as $key2 => $zeile){
                    if($key2[0] != 't'){
                        continue;
                    }
                    # neuen Key berechnen
                    $dat = explode('|', $zeile);
                    $tag = date('w', $dat[0]);
                    if($tag == 0){
                        $tag = 7;
                    }
                    $keyneu = mktime($wtag2zeit[$tag]['std'], $wtag2zeit[$tag]['min'], 0, date('n', $dat[0]), date('j', $dat[0]), date('Y', $dat[0]));
                    # Werte ermitteln/kopieren
                      # Endzeit, bungsleiter/Trainer
                    $zeileneu = date('H:i', $keyneu + ($dat[1]*0.75*60*60)).'|U|';
                      # Taetigkeit, Anzahl Teilnehmer, Bemerkung
                    $zeileneu .= $dat[2].'||'.$dat[3];
                    $datenneu[$key][$keyneu] = $zeileneu;
                }
            }
            ksort($datenneu);
            schreibe_ini_datei($datei, $datenneu, true);
        }
        break;

    case '0.7.6':
    	# bungsleitertabelle berarbeiten
        $query = "UPDATE ".DB_PREFIX."uebungsleiter SET trainerbis = YEAR(NOW())+1 WHERE trainer = 1";
        $_db->fuehreQueryAus($query);
        $query = "ALTER TABLE ".DB_PREFIX."uebungsleiter DROP trainer";
        $_db->fuehreQueryAus($query);
        # Konstante TKSWIM_VEREINSART anlegen
		$_tmpl->assign('daten',array('tkswim_vereinsart'=>'abteilung'));
        $neuerinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
        $fh = fopen(PFAD_INCLUDE.'conf/conf.inc.php', 'w');
        fwrite($fh, $neuerinhalt, strlen($neuerinhalt));
        fclose($fh);
    	break;

    case '0.7.5':
    	# cronjob.ini-Eintrag fr das erzeugen der aktuellen Zeiten anlegen
    	require_once('func/schreibe_ini_datei.inc.php');
        $datei = PFAD_INCLUDE.'conf/cronjob.ini';
    	$cronjobini = parse_ini_file($datei,true);
        $cronjobini['zeitpunkte']['aktuellezeiten'] = 'woechentlich:3';
        schreibe_ini_datei($datei,$cronjobini,true);
        # aktuelle Zeiten anlegen
        require_once('class/zeiten.inc.php');
		$z = new zeiten;
    	$z->db = &$_db;
    	$z->schreibeAktuelleZeiten();
    	break;

    case '0.7.4':
    	require_once('func/schreibe_ini_datei.inc.php');
        $datei = PFAD_INCLUDE.'conf/cronjob.ini';
    	$cronjobini = parse_ini_file($datei,true);
        $cronjobini['zeitpunkte']['feiertageanlegen'] = 'nie:2do';
        schreibe_ini_datei($datei,$cronjobini,true);
    	break;

    case '0.7.3':
    	# Meldezeiten in meldungen_starts schreiben
        $query = "SELECT meldezeitid, zeit FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."zeiten as z
                    WHERE ms.meldezeitid=z.id AND meldezeitid IS NOT NULL";
        $_db->holeDaten($query);
        $id2zeit = $_db->baueArray('zeit','meldezeitid');
        foreach($id2zeit as $id => $zeit){
        	$query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeit = ".$zeit." WHERE meldezeitid = ".$id."";
            $_db->fuehreQueryAus($query);
        }
        # 59:59,99er Zeiten auf NULL setzen
        $query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeit = NULL WHERE meldezeit = 359999";
        $_db->fuehreQueryAus($query);
        # meldezeitid-Spalte lschen
        $query = "ALTER TABLE ".DB_PREFIX."meldungen_starts DROP meldezeitid";
        $_db->fuehreQueryAus($query);

        # Flag fr das Einlsesen von Vereinsrekorden anlegen
    	require_once('func/schreibe_ini_datei.inc.php');
        $datei = PFAD_INCLUDE.'conf/cronjob.ini';
        $inhalt = parse_ini_file($datei,true);
        $inhalt['flags']['vereinsrekordeeinlesen'] = 0;
        schreibe_ini_datei($datei,$inhalt,true);

        # Vereinsrekorde einlesen
		require_once(PFAD_INCLUDE.'conf/select.inc.php');
    	require_once('class/zeiten.inc.php');
    	$zeit = new zeiten;
    	$zeit->leseVereinsrekordeEin();
    	break;

    case '0.7.2':
    	require_once('func/schreibe_ini_datei.inc.php');
        # einige Defaulteinstellungen anpassen
		foreach(glob(PFAD_INIDATEIEN.'userconf_*.ini') as $datei){
        	$inhalt = parse_ini_file($datei,true);
            $inhalt['wettkaempfemelden']['interplationsfaktorhoch'] = '1.11';
            $inhalt['wettkaempfemelden']['interplationsfaktorrunter'] = '0.91';
            $inhalt['anwesenheitsliste']['nummerierung'] = '0';
            $inhalt['anwesenheitsliste']['anfang'] = 'vorgegeben';
            schreibe_ini_datei($datei,$inhalt,true);
        }
        # cronjob.ini im conf-Verzeichnis ndern
        $inhalt = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
        $inhalt['flags']['zeitenentwicklungsbilderloeschen'] = '0';
        schreibe_ini_datei(PFAD_INCLUDE.'conf/cronjob.ini',$inhalt,true);
    	break;
    default:
    	return false;
    	break;
    }
    return true;
}
# EOF
?>