<?php
/*
 Wettkampfabwicklung, Aktion: einhaltung_pflichtzeit
 verwendete Templates:
  - 42.pflichtzeitpruefung.inc.html
*/
$query = "SELECT CONCAT(m.nachname,', ',m.vorname) as name, YEAR(m.gebdatum) as jg, m.mw, ms.meldezeit as zeit,
              w.wknr, ms.wkid, w.laenge, w.disziplin, ms.teilnahme
            FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt,
              ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."wks as w
            WHERE mt.mid=m.id AND ms.teilnehmerid=mt.id AND ms.wkid = w.id AND
              mt.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND ms.teilnahme != '-'
            ORDER BY name, w.wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl']<1){
	$_SESSION['hinweis'] = 'Es sind keine Schwimmer gemeldet';
}
else{
    $mitglieder = $_db->ergebnis['daten'];
    $pflichtzeit = false;
    $offiziell = false;
    $anzdurchgefallen = 0;
    $wk->wettkampfjahr = substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4);
    foreach($mitglieder as $key => $m){
        $tmp = $wk->meldezeitInPflichtzeit($m['zeit'],$m['wkid'],$m['jg']);
        $mitglieder[$key]['bestanden'] = $tmp['bestanden'];
        $mitglieder[$key]['pflichtzeit'] = $tmp['pflichtzeit'];
        $mitglieder[$key]['offiziell'] = $tmp['offiziell'];
        $mitglieder[$key]['richtpflicht'] = $tmp['richtpflicht'];
        if($tmp['richtpflicht'] == 'p'){
            $pflichtzeit = true;
        }
        if($tmp['offiziell'] == 1){
            $offiziell = true;
        }
        if($tmp['bestanden'] == '-'){
            $anzdurchgefallen++;
        }
    }
    $meldungmoeglich = true;
    if($anzdurchgefallen > 0){
        $meldungmoeglich = !($pflichtzeit and $offiziell);
    }
    $neuerwert = $meldungmoeglich?'+':'-';
    if($_wkeinst['flags']['pflichtzeitengeprueft'] != $neuerwert){
    	$_wkeinst['flags']['pflichtzeitengeprueft'] = $neuerwert;
    	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
    }
    $_tmpl->assign('meldungmoeglich',$meldungmoeglich);
    $_tmpl->assign('mitglieder',$mitglieder);
    $_tmpl->assign('lagen',$_lagen);
    $_inh .= $_tmpl->fetch('wettkaempfe/42.pflichtzeitpruefung.inc.html');
}
# EOF
?>