<?php
/*
 Wettkampfabwicklung, Aktion: einstellungen
 verwendete Templates:
  - 42.abwickeln-einstellungen.inc.html
*/
$query = "SELECT v.id, CONCAT(v.bezeichnung, ' (', IF(m.nachname IS NULL,'-',CONCAT(vorname,' ',nachname)),')') as bezeichnung, mitgliedid
            FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid = m.id
            WHERE v.mitgliedid IS NOT NULL ORDER BY v.sort";
$_db->holeDaten($query);
$vorstand = $_db->baueArray('bezeichnung','id');
$meldeformate = array(
	'dsv5'    => 'DSV-Format 5',
    'dsvform' => 'DSV-Formulare 101 und 102'
);
$ohnemeldezeit = array(
	'ohnezeit' => 'ohne Zeit melden (00:00,00)',
    'stunde'   => 'mit einer Stunde melden (59:59,99)'
);
if(isset($_POST['speichern'])){
	require_once('func/pruefen.inc.php');
    $f = '';
    $f .= pruefen($_POST['daten']['ansprechpartner'],'wertemenge','Der Ansprechpartner ist ungltig',array_keys($vorstand));
    $f .= pruefen($_POST['daten']['meldeformat'],'wertemenge','Das Meldeformat ist ungltig',array_keys($meldeformate));
    $f .= pruefen($_POST['daten']['ohnemeldezeit'],'wertemenge','Das Verhalten bei Meldungen ohne Meldezeit ist ungltig',array_keys($ohnemeldezeit));
    $f .= pruefen($_POST['daten']['dateiname'],'leer','Der Dateiname fehlt');
    $f .= pruefen($_POST['daten']['dateiname'],'regexpr','Der Dateiname ist ungltig (nur die Zeichen a-z0-9_.-)','^[a-z0-9_.-]+$');
    $f .= pruefen($_POST['daten']['dateiname'],'minlaenge','Der Dateiname ist zu kurz (min 10 Zeichen)',10);
    $f .= pruefen($_POST['daten']['dateiname'],'maxlaenge','Der Dateiname ist zu lang (max 80 Zeichen)',80);
    if(!empty($f)){
    	$_tmpl->assign('fehler',$f);
        $_tmpl->assign('daten',$_POST['daten']);
    }
    else{
    	$_wkeinst['meldedatei']['dateiname'] = $_POST['daten']['dateiname'];
    	$_wkeinst['meldedatei']['meldeformat'] = $_POST['daten']['meldeformat'];
    	$_wkeinst['meldedatei']['ansprechpartner'] = $_POST['daten']['ansprechpartner'];
    	$_wkeinst['meldedatei']['ohnemeldezeit'] = $_POST['daten']['ohnemeldezeit'];
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
	 	weiterleiten('/wettkaempfe/abwickeln.html','Die Einstellungen wurden gespeichert');
    }
}
else{
	if(empty($_wkeinst['meldedatei']['ansprechpartner'])){
        $_wkeinst['meldedatei']['ansprechpartner'] = 4;
    }
	$_tmpl->assign('daten',$_wkeinst['meldedatei']);
}
$_tmpl->assign('ohnemeldezeit', $ohnemeldezeit);
$_tmpl->assign('meldeformate',$meldeformate);
$_tmpl->assign('vorstand',$vorstand);
$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-einstellungen.inc.html');
# EOF
?>