<?php
/*
 Wettkampfabwicklung, Aktion: hinzufuegen_trainingsgruppen
 verwendete Templates:
  - 42.hinzufuegen-trainingsgruppen-gruppewaehlen.inc.html
  - 42.hinzufuegen-trainingsgruppen-streckenwaehlen.inc.html
*/
require_once('func/holetrainingsgruppen.inc.php');
$_trainingsgruppen = holeTrainingsgruppen(true);
$_tmpl->assign('gruppen', $_trainingsgruppen);

# Gruppe setzen
if(isset($_POST['gruppe']) and in_array($_POST['gruppe'], array_keys($_trainingsgruppen))){
	$_SESSION['wk_abwickeln']['tg_trainingsgruppe'] = $_POST['gruppe'];
}

# Gruppe zurcksetzen
if(isset($_GET['gruppezuruecksetzen'])){
	unset($_SESSION['wk_abwickeln']['tg_trainingsgruppe']);
}

if(!isset($_SESSION['wk_abwickeln']['tg_trainingsgruppe'])){ # Trainingsgruppe whlen
    $_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-trainingsgruppen-gruppewaehlen.inc.html');
}
else{
	# Mitglieder der Gruppe holen
    $query = "SELECT m.id as mid, CONCAT(nachname, ', ',vorname, ' (',mw, ', ', YEAR(gebdatum),')') as name
                FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt, ".DB_PREFIX."mitglieder as m
                WHERE mt.mitgliedid = m.id AND mt.trainingsgruppenid = ".$_SESSION['wk_abwickeln']['tg_trainingsgruppe']."
                ORDER BY name";
    $_db->holeDaten($query);
    $mitglieder = $_db->baueArray('name','mid');
    # Wettkmpfe holen
    $query = "SELECT w.id, laenge, disziplin FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
                WHERE w.abschnittid=a.id AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']."".($_wettkampfart=='wrcup'?" AND w.wkart != 'f'":'')."
                ORDER BY disziplin, laenge";
    $_db->holeDaten($query);
    $wettkaempfe = $wkid2disziplin = array();
    foreach($_db->baueArray('*','#') as $wettkampf){
    	$wettkaempfe[$wettkampf['id']] = $wettkampf['laenge'].'m '.$_lagen[$wettkampf['disziplin']];
        $wkid2disziplin[$wettkampf['id']] = $wettkampf['laenge'].'_'.$wettkampf['disziplin'];
    }
    $_tmpl->assign('mitglieder', $mitglieder);
    $_tmpl->assign('wettkaempfe', $wettkaempfe);

    if(count($mitglieder)<1){
    	$_tmpl->assign('fehler', 'In der gewhlten Gruppe sind keine Mitglieder eingetragen.');
    	$_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-trainingsgruppen-gruppewaehlen.inc.html');
    }
    else{
    	$wk->wettkampfjahr = substr($_SESSION['wk_abwickeln']['wettkampfdatum'],0,4);
        $mid2wkid = array();
    	foreach($mitglieder as $mid => $name){
            $mid2wkid[$mid] = $wk->wettkaempfeFuerSchwimmer($_SESSION['wk_abwickeln']['id'],$mid);
        }
        if(isset($_POST['strecken']) and count($_POST['strecken'])>0){
        	# ungltige Angaben ausfiltern
            foreach($_POST['strecken'] as $mid => $strecken){
            	if(!in_array($mid, array_keys($mid2wkid))){
                	unset($_POST['strecken'][$mid]);
                    continue;
                }
                foreach($strecken as $key => $sid){
                	if(!in_array($sid, $mid2wkid[$mid]['wks'])){
                		unset($_POST['strecken'][$mid][$key]);
                    	continue;
                    }
                }
                if(count($_POST['strecken'][$mid]) < 1){
                	unset($_POST['strecken'][$mid]);
                }
            }
            if(count($_POST['strecken']) > 0){
            	$mids = array_keys($_POST['strecken']);
            	# vorhande Meldungen holen
                $query = "SELECT id, mid FROM ".DB_PREFIX."meldungen_teilnehmer
                            WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mid IN (".implode(',',array_keys($mitglieder)).")";
                $_db->holeDaten($query);
                $mid2teilnehmer = $_db->baueArray('id', 'mid');
                foreach($mid2teilnehmer as $id => $teilnehmerid){ # Mitglieder lschen die gemeldet sind, aber abgewhlt wurden
                	if(in_array($id, $mids)){
                    	continue;
                    }
                    $anhaengen = '';
                    if(count($wettkaempfe)>0){
                    	$anhaengen = ' AND wkid IN ('.implode(',',array_keys($wettkaempfe)).')';
                    }
                    $query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$teilnehmerid.$anhaengen."";
                    $_db->fuehreQueryAus($query);
                    # Wenn fr keine Strecke mehr gemeldet -> Teilnehmer entfernen
                    $query = "SELECT wkid FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$teilnehmerid."";
                    $_db->holeDaten($query);
                    if($_db->holeAnzahl() < 1){
                    	$query = "DELETE FROM ".DB_PREFIX."meldungen_teilnehmer WHERE id = ".$teilnehmerid."";
                    	unset($mid2teilnehmer[$id]);
                    	$_db->fuehreQueryAus($query);
                    }
                }
                $teilnehmerstrecken = array();
                if(count($mid2teilnehmer) > 0){
                	$query = "SELECT teilnehmerid, wkid FROM ".DB_PREFIX."meldungen_starts
                                WHERE teilnehmerid IN (".implode(',',$mid2teilnehmer).")";
                    $_db->holeDaten($query);
                    $teilnehmerstrecken = $_db->baueArray('*', '#');
                }
                # aktuelle Zeiten holen
                $query = "SELECT CONCAT(mid, '_', laenge, '_', disziplin) as strecke, zeit
                            FROM ".DB_PREFIX."aktuellezeiten WHERE mid IN (".implode(',',$mids).")";
                $_db->holeDaten($query);
                $zeiten = $_db->baueArray('zeit','strecke');

                foreach($_POST['strecken'] as $mid => $strecken){
                	if(in_array($mid, array_keys($mid2teilnehmer))){ # bereits gemeldet
                    	$teilnehmerid = $mid2teilnehmer[$mid];
                    }
                    else{ # Teilnehmer einfgen
                    	$query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer
                                    SET wettkampfid = ".$_SESSION['wk_abwickeln']['id'].",
                                        mid = ".$mid."";
                        $_db->fuehreQueryAus($query);
                        $teilnehmerid = $_db->ergebnis['insertid'];
                    }

                    $loeschen = $anlegen = array();
                    foreach($strecken as $s){
                    	$anlegen[$s] = $s;
                    }
                    foreach($teilnehmerstrecken as $strecke){
                    	if($strecke['teilnehmerid'] != $teilnehmerid){
                        	continue;
                        }
                        if(!in_array($strecke['wkid'], array_keys($wettkaempfe))){
                            # Strecke wird bei der Gruppenweisen Meldung ignoriert -> weitergehen
                            continue;
                        }
                        if(in_array($strecke['wkid'], $strecken)){
                            # Strecke schon vorhanden -> ignorieren
                            unset($anlegen[$strecke['wkid']]);
                        }
                        else{
                        	# Strecke vorhanden -> lschen
                            $loeschen[] = $strecke['wkid'];
                        }
                    }
                    if(count($loeschen) > 0){
                    	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts
                                    WHERE teilnehmerid = ".$teilnehmerid." AND wkid IN (".implode(',',$loeschen).")";
                    	$_db->fuehreQueryAus($query);
                    }
                    if(count($anlegen) > 0){
                    	$queryteile = array();
                    	foreach($anlegen as $wkid){
                        	# Zeit suchen
                            if(substr($wkid2disziplin[$wkid],0,2) == 25){
                            	$einebahn = true;
                                $suchkey = $mid.'_50'.substr($wkid2disziplin[$wkid],2);
                            }
                            else{
                            	$einebahn = false;
                                $suchkey = $mid.'_'.$wkid2disziplin[$wkid];
                            }
                            if(isset($zeiten[$suchkey])){
                            	$zeit = $zeiten[$suchkey];
                                if($einebahn){
                                    $faktor = $_gleinst['wettkaempfe_abwickeln']['interplationsfaktorrunter'];
                                    $zeit = round($faktor*0.5*$zeit);
                                }
                            }
                            else{
                            	$zeit = 'NULL';
                            }
                            $queryteile[] = '('.$teilnehmerid.', '.$wkid.', '.$zeit.')';
                        }
                    	$query = "INSERT INTO ".DB_PREFIX."meldungen_starts (teilnehmerid, wkid, meldezeit) VALUES ".implode(',',$queryteile)."";
                        $_db->fuehreQueryAus($query);
                        #exit;
                    }
                }
                unset($_SESSION['wk_abwickeln']['tg_trainingsgruppe']);
                weiterleiten('/wettkaempfe/abwickeln.html?aktion=hinzufuegen_trainingsgruppen', 'Die Meldungen wurden gespeichert');
            }
        }
        $_tmpl->assign('mid2wkid', $mid2wkid);

        $_tmpl->assign('js_inline',"function alle(mid, art){\n  var wks = document.forms[0].elements['strecken['+mid+'][]'];\n".
                                   "  var grenze = art=='FBR'?(wks.length<3?wks.length:3):wks.length;\n".
                                   "  for(var i=0;i<grenze;i++){\n      wks[i].checked = true;\n  }\n}");
        $_inh .= $_tmpl->fetch('wettkaempfe/42.hinzufuegen-trainingsgruppen-streckenwaehlen.inc.html');
    }
}
# EOF
?>