<?php
/*
 Wettkampfabwicklung, Aktion: pdf_dsvidliste
 verwendete Templates:
  - [keines]
*/
$query = "SELECT m.id, CONCAT(m.nachname,', ',m.vorname) as name, mw, YEAR(gebdatum) as jg, dsvid
            FROM ".DB_PREFIX."meldungen_teilnehmer as t, ".DB_PREFIX."mitglieder as m
            WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND t.mid = m.id AND t.teilnahme IN ('0','+')
            ORDER BY m.nachname, m.vorname";
$_db->holeDaten($query);
$mitglieder = $_db->baueArray('*','id');
require_once('class/pdf.inc.php');
$schriftgroesse = (isset($_GET['sg']) and ctype_digit($_GET['sg']))?$_GET['sg']:12;
$pdf = new tkpdf($schriftgroesse);
$daten = array();
$teilnahmenichtsicher = false;
$spalten = array(
	'name' => '<b>Name</b>',
    'mw' => '<b>mw</b>',
    'jg' => '<b>JG</b>',
    'dsvid' => '<b>DSV-ID</b>'
);
$optionen = array(
	'fontSize' => $schriftgroesse,
    'xPos' => 70,
    'xOrientation' => 'right',
    'shaded' => 0,
    'showLines' => 2,
    'colGap' => 7
);
$pdf->tkseitennummern();
$pdf->tkseitentitel('DSV-ID-Liste der Teilnehmer fr '.$_SESSION['wk_abwickeln']['titel'].' (fr Staffeln)');
$pdf->ezTable($mitglieder,$spalten,'',$optionen);
$pdf->tk_autor = $_SESSION['user']['realname'];
$pdf->tk_titel = 'DSV-ID-Liste der Teilnehmer, '.$_SESSION['wk_abwickeln']['titel'];
$pdf->tkstream('wettkampfmeldung_dsvids.pdf');
# EOF
?>