<?php
/*
 Wettkampfabwicklung, Aktion: pdf_meldezettelgenerieren
 verwendete Templates:
  - 42.meldezettel-mitgliederwaehlen.inc.html
*/
if(!isset($_POST['mids'])){
	$mitglieder = true;
	if($_wettkampfart == 'dmsj'){
        if(!isset($_wkeinst['dmsj'])){
        	$mitglieder = false;
        }
        # Mitglieder(-ids) holen
        $tmpmids = array();
        foreach($_wkeinst['dmsj'] as $m){
            $tmp = explode('|',$m);
            $tmpmids = array_merge($tmpmids,$tmp);
        }
        if(count($tmpmids)<1){
        	$mitglieder = false;
        }
        # Mitglieder alphabetisch sortieren
        $query = "SELECT CONCAT(' ',nachname,', ',vorname,' (',YEAR(gebdatum),')') as name, id as mid
                    FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$tmpmids).") ORDER BY nachname, vorname";
        $_db->holeDaten($query);
    }
    else{
        $query = "SELECT CONCAT(' ',nachname,', ',vorname,' (',YEAR(gebdatum),')') as name, mid
                    FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
                    WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mt.mid = m.id
                    ORDER BY nachname, vorname";
        $_db->holeDaten($query);
        if($_db->ergebnis['anzahl'] < 1){
        	$mitglieder = false;
        }
    }

    if(!$mitglieder){
    	$_tmpl->assign('fehler','Es wurden noch keine Mitglieder gewhlt');
    }
    else{
        $mids = $_db->baueArray('mid','#');
        $_tmplanzeige = $_db->baueArray('name','mid');
        $query = "SELECT trainingsgruppenid as tid, m.id as mid FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt, ".DB_PREFIX."mitglieder as m
                    WHERE mt.mitgliedid = m.id AND m.id IN (".implode(',',$mids).")";
        $_db->holeDaten($query);

        $trgr = array();
        foreach($_db->ergebnis['daten'] as $row){
            if(!isset($trgr[$row['tid']])){
                $trgr[$row['tid']] = array();
            }
            $trgr[$row['tid']][] = $row['mid'];
        }
        require_once('func/holetrainingsgruppen.inc.php');
        $trainingsgruppen = holeTrainingsgruppen(true);
        $vorhandene = array_keys($trgr);
        foreach($trainingsgruppen as $key => $wert){
            if(!in_array($key,$vorhandene)){
                unset($trainingsgruppen[$key]);
            }
        }
        $js_array = 'var trgrarray = new Array();'."\n";
        foreach($trgr as $key => $t){
            $js_array .= 'trgrarray['.$key.'] = new Array('.implode(',',$t).');'."\n";
        }
        $js_array .= 'var gespeicherte = new Array('.(isset($_wkeinst['meldezettel']['generierte'])?str_replace('|',',',$_wkeinst['meldezettel']['generierte']):'').');';
        $_tmpl->assign('js_trainingsgruppenarray',$js_array);
        $_tmpl->assign('trainingsgruppen',$trainingsgruppen);
        $_tmpl->assign('mitglieder',$_tmplanzeige);
        $_inh .= $_tmpl->fetch('wettkaempfe/42.meldezettel-mitgliederwaehlen.inc.html');
    }
}
else{
    if(isset($_POST['optionen'])){
        if(isset($_POST['optionen']['zuruecksetzen'])){
            $_wkeinst['meldezettel']['generierte'] = '';
        }
        if(isset($_POST['optionen']['merken'])){
            $_wkeinst['meldezettel']['generierte'] = implode('|',$_POST['mids']);
        }
        schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
    }
    $wk->conf['wochentage'] = $_wochentage;
	$wk->conf['gleinst'] = $_gleinst;
    $wk->generiereMeldezettel($_SESSION['wk_abwickeln']['id'],$_POST['mids']);
}

# EOF
?>