<?php
/*
 Wettkampfabwicklung, Aktion: pdf_wettkaempfe
 verwendete Templates:
  - [keines]
*/
$query = "SELECT w.id, abschnittid, wknr, mw, laenge, disziplin, jahrgang, wkart, a.nr as abschnnr
            FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
            WHERE w.abschnittid = a.id AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND SUBSTRING(laenge,2,1) != 'x'
            ORDER BY a.nr, wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] < 1){
    $_tmpl->assign('fehler','Es wurden noch keine Mitglieder gemeldet');
}
else{
    $wkdaten = $_db->ergebnis['daten'];
    foreach($wkdaten as $key => $row){
        if($row['wkart'] != 'e' AND $row['wkart'] != 'v'){
            $wkdaten[$key]['_mitglieder'] = array();
            continue;
        }
        $query = "SELECT CONCAT(m.vorname,' ',m.nachname) as name, ms.meldezeit as zeit, IF(meldezeit IS NULL,2,1) as zeitvorh, ms.teilnahme
                    FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt
                    WHERE ms.teilnehmerid = mt.id AND mt.mid = m.id AND wkid = ".$row['id']." AND ms.teilnahme IN ('0','+')
                    ORDER BY zeitvorh, zeit, nachname DESC, vorname DESC";
        $_db->holeDaten($query);
        if($_db->ergebnis['anzahl'] < 1){
            $wkdaten[$key]['_mitglieder'] = array();
            continue;
        }
        $wkdaten[$key]['_mitglieder'] = $_db->ergebnis['daten'];
    }
    require_once('class/pdf.inc.php');
    $schriftgroesse = (isset($_GET['sg']) and ctype_digit($_GET['sg']))?$_GET['sg']:12;
    $pdf = new tkpdf($schriftgroesse);
    $pdf->ezSetMargins(45,40,50,50);
    $pdf->tkseitennummern();
    $pdf->tkseitentitel('Teilnehmerliste fr '.$_SESSION['wk_abwickeln']['titel'].' (nach Wettkmpfen sortiert)');
    $daten = array();
    $teilnahmenichtsicher = false;
    foreach($wkdaten as $wk){
        if(count($wk['_mitglieder']) < 1){
            continue;
        }
        $pdf->ezText('WK'.$wk['wknr'].' - '.$wk['laenge'].' '.$_lagen[$wk['disziplin']].' (Abschnitt '.$wk['abschnnr'].')',$schriftgroesse+2);
        $anz = count($wk['_mitglieder']);
        $tmp = array();
        for($i=$anz-1;$i>=0;$i--){
            $row = $wk['_mitglieder'][$i];
            $tmp[] = $row['name'].($row['teilnahme']=='0'?'*':'');
            if($row['teilnahme']=='0'){
                $teilnahmenichtsicher = true;
            }
        }
        $pdf->ezText(implode(', ',$tmp)."\n",$schriftgroesse);
    }
    if($teilnahmenichtsicher){
        $pdf->ezText("\n* Teilnahme noch nicht sicher",$schriftgroesse);
    }
    $pdf->tk_autor = $_SESSION['user']['realname'];
    $pdf->tk_titel = 'Wettkampfliste, '.$_SESSION['wk_abwickeln']['titel'];
    if(isset($_GET['ziel']) and $_GET['ziel']=='dateisystem' and isset($_SESSION['wk_abwickeln']['verzeichnisid'])){
        require_once('class/dateien.inc.php');
        $dat = new dateien($_db,$_tmpl);
        $daten = $pdf->tkstream('wettkampfmeldung_wettkaempfe.pdf','rueckgabe');
        if($dat->legeDateiInWettkampfvereichnisAn($_SESSION['wk_abwickeln']['verzeichnisid'], 'wettkampfmeldung_wettkaempfe.pdf', 'pdf', $daten, 'Wettkampfliste',true)){
            weiterleiten('/wettkaempfe/abwickeln.html','die Datei wurde im Dateisystem abgelegt');
        }
    }
    $pdf->tkstream('wettkampfmeldung_wettkaempfe.pdf');
}
# EOF
?>