<?php
/*
 Wettkampfabwicklung, Aktion: staffeln
 verwendete Templates:
  - 42.staffeln-formular.inc.html
*/
$query = "SELECT w.id, wknr, a.nr as abschnnr, w.mw, w.laenge, w.disziplin, w.jahrgang, w.wkart
            FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
            WHERE a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND w.abschnittid = a.id AND
              (wkart = 'e' OR wkart = 'v') AND (SUBSTRING(laenge,2,1) = 'x' OR SUBSTRING(w.laenge,3,1) = 'x')
            ORDER BY wknr";
$_db->holeDaten($query);
$_tmpl->assign('lagen',$_lagen);
if(!isset($_wkeinst['staffeln'])){
	$_wkeinst['staffeln'] = array();
}
$wks = array();
if(isset($_POST['verarbeiten'])){
	if(isset($_POST['loeschen'])){
    	list($key,) = each($_POST['loeschen']);
        list($id,$nr) = explode('_',$key);
        unset($_POST['meldezeiten'][$id][$nr]);
    }
    if(isset($_POST['neu'])){
    	list($id,) = each($_POST['neu']);
        $_POST['meldezeiten'][$id][] = '';
    }
    require_once('func/pruefen.inc.php');
    $fz = $fehler = '';
}

foreach($_db->ergebnis['daten'] as $row){
	if(isset($_POST['verarbeiten'])){ # Post-Daten verabeiten
        if(isset($_POST['meldezeiten'][$row['id']])){
        	foreach($_POST['meldezeiten'][$row['id']] as $key => $value){
            	$fz .= pruefen($_POST['meldezeiten'][$row['id']][$key],'schwimmzeit','-','wert');
            }
            sort($_POST['meldezeiten'][$row['id']]);
            $row['_zeiten'] = $_POST['meldezeiten'][$row['id']];
        }
    }
    else{
        if(isset($_wkeinst['staffeln'][$row['id']])){ # Daten aus ini-Datei holen
            $row['_zeiten'] = explode(',',$_wkeinst['staffeln'][$row['id']]);
        }
    }
    $wks[$row['id']] = $row;
}
if(!empty($fz)){
	$fehler = 'Mindestens eine Meldezeit ist ungltig<br />';
}
if(empty($fehler) and isset($_POST['speichern'])){
	$staffeldaten = array();
    $_wkeinst['staffeln'] = array();
	foreach($_POST['meldezeiten'] as $wkid => $zeiten){
    	$tmp = array();
        foreach($_POST['meldezeiten'][$wkid] as $value){
        	if(empty($value)){
            	continue;
            }
            $tmp[] = $value;
        }
        $staffeldaten[$wkid] = implode(',',$tmp);
    }
    foreach($staffeldaten as $key => $value){
   		$_wkeinst['staffeln'][$key] = $value;
    }
    schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
    weiterleiten('/wettkaempfe/abwickeln.html?aktion=staffeln','Die Staffeln wurden gespeichert');
}
if(!empty($fehler)){
    $_tmpl->assign('fehler',$fehler);
}
$_tmpl->assign('wks',$wks);
$_tmpl->assign('mwx',$_geschlechter);
$_inh .= $_tmpl->fetch('wettkaempfe/42.staffeln-formular.inc.html');
# EOF
?>