<?php
function berechneLenPunkte(&$zeit, $strecke, $disziplin, $mw){
	global $_db, $_lagen;
    require_once('func/pruefen.inc.php');
    $f = '';
	$f .= pruefen($zeit,'leer','-');
    $zeit = text_format($zeit,'schwimmzeit');
    $f .= pruefen($zeit,'schwimmzeit','-','wert');
    if(!empty($f)){
    	return '?';
    }
    $strecken = array(50,100,200,400,800,1500);
    if(!in_array($strecke,$strecken)){
    	return '?';
    }
    if(!in_array($disziplin,array_keys($_lagen)) and $disziplin != 6){ # 6=sonstiges
    	return '?';
    }
    if(!in_array($mw,array('w','m'))){
    	$mw = 'm';
    }
    $query = "SELECT zeit
                FROM ".DB_PREFIX."lenreferenzzeiten
                WHERE
                  strecke   = '".$strecke."' AND
                  disziplin = ".$disziplin." AND
                  mw        = '".$mw."'";
	$_db->holeDaten($query);
    if($_db->ergebnis['anzahl']!=1){
    	return '?';
    }
    $row = $_db->holeZeile();
    $basiszeit = $row['zeit'];
    $erreichtezeit = $zeit;
    if($erreichtezeit == 0){
    	return '?';
    }
    $punkte = floor(1000 * pow($basiszeit/$erreichtezeit,3));
    return $punkte;
}
?>