<?php

function smarty_function_titel($params, &$smarty){

	$hauptbereiche = array(
        '-'           => 'Startseite',
        'admin'       => 'Adminbereich',
        'mitglieder'  => 'Mitglieder',
        'training'    => 'Training',
        'wettkaempfe' => 'Wettkmpfe',
        'zeiten'      => 'Zeiten',
        'sonstiges'   => 'Sonstiges',
        'tools'       => 'Tools',
        'export'      => 'Export',
        'admin.php'   => 'Administrationstool',
        'update.php'  => 'Updates',
        'login'       => 'Login'
    );
	$unterbereiche = array(
    	'zeitenbearbeiten'  => 'Zeiten bearbeiten',  # Admin
        'anzeigen'          => 'anzeigen',           # Mitglieder
        'anlegen'           => 'anlegen',
        'aendern'           => 'ndern',
        'freischalten'      => 'freischalten',
        'uebungsleiter'     => 'bungsleiter',       # Training
        'abwickeln'         => 'abwickeln',          # Wettkaempfe
        'eingeben'          => 'eingeben',           # Zeiten
        'importieren'       => 'importieren',
        'lenreferenzzeiten' => 'LEN-Referenzzeiten',
        'lenpunkte'         => 'LEN-Punkte'          # Tools
    );

	$url = substr($_SERVER['PHP_SELF'],1);
    $url = str_replace(array('index','.html'),'',$url);
    if(substr($url,-1)=='/'){
    	$url = substr($url,0,-1);
    }


    $teile = explode('/',$url);
    #printr($teile);
    if(empty($url)){ # Startseite
        $titel = $hauptbereiche['-'];
    }
    else{
    	for($i=0;$i<5;$i++){
        	if(!isset($teile[0]) or !in_array($teile[0], array_keys($hauptbereiche))){
            	array_shift($teile);
            }
            else{
				break;
            }
        }
        if(count($teile) == 0){
       		$titel = $hauptbereiche['-'];
        }
        if(count($teile) == 1){ # Hauptseite
    		$index = isset($hauptbereiche[$teile[0]])?$teile[0]:'-';
    		$titel = $hauptbereiche[$index];
        }
        elseif(isset($teile[1])){ # Unterseite
    		$h = $teile[0];
    		$u = $teile[1];
    		$titel = isset($unterbereiche[$u])?$unterbereiche[$u]:ucfirst($u);
        	$index_h = isset($hauptbereiche[$h])?$h:'-';
    		$titel .= '  '.$hauptbereiche[$index_h];
        }

    }
    $titel .= '  '.TKSWIM_VEREIN;
    $titel .= '  tkswim';
    return $titel;
}
# EOF
?>